"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _requireLib = _interopRequireDefault(require("../utils/requireLib"));

var _processBackend = _interopRequireDefault(require("./processBackend"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Aerospike = null;

var AerospikeBackend =
/*#__PURE__*/
function (_ProcessBackend) {
  _inherits(AerospikeBackend, _ProcessBackend);

  function AerospikeBackend() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        manager = _ref.manager,
        id = _ref.id,
        ns = _ref.ns,
        options = _ref.options;

    _classCallCheck(this, AerospikeBackend);

    Aerospike = (0, _requireLib.default)('aerospike');
    _this = _possibleConstructorReturn(this, _getPrototypeOf(AerospikeBackend).call(this));
    _this.options = options;
    _this.id = id;
    _this.ns = ns;
    return _this;
  }

  _createClass(AerospikeBackend, [{
    key: "parseRequest",
    value: function parseRequest(req) {}
  }, {
    key: "bind",
    value: function () {
      var _bind = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _get(_getPrototypeOf(AerospikeBackend.prototype), "bind", this).call(this);

              case 2:
                return _context.abrupt("return", Aerospike.connect(this.options));

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function bind() {
        return _bind.apply(this, arguments);
      }

      return bind;
    }()
  }, {
    key: "getKey",
    value: function getKey(set, pk) {
      return new Aerospike.Key(this.ns, set, pk);
    }
  }, {
    key: "getClient",
    value: function getClient() {
      return this.client;
    }
  }, {
    key: "create",
    value: function () {
      var _create = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var _ref2,
            collection,
            object,
            id,
            _args2 = arguments;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _ref2 = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : {}, collection = _ref2.collection, object = _ref2.object, id = _ref2.id;
                _context2.next = 3;
                return this.getClient().put(this.getKey(collection, id), object);

              case 3:
                return _context2.abrupt("return", this.loadById({
                  collection: collection,
                  id: id
                }));

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function create() {
        return _create.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: "createIndex",
    value: function () {
      var _createIndex = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3() {
        var _ref3,
            collection,
            index,
            type,
            datatype,
            _args3 = arguments;

        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _ref3 = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {}, collection = _ref3.collection, index = _ref3.index, type = _ref3.type;
                datatype = Aerospike.indexDataType.STRING;

                switch (type) {
                  case 'number':
                    datatype = Aerospike.indexDataType.NUMERIC;
                }

                return _context3.abrupt("return", this.getClient().createIndex({
                  ns: this.ns,
                  set: collection,
                  bin: index,
                  index: "".concat(collection, "_").concat(index, "Idx"),
                  datatype: datatype
                }));

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function createIndex() {
        return _createIndex.apply(this, arguments);
      }

      return createIndex;
    }()
  }, {
    key: "save",
    value: function save() {
      var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref4.collection,
          id = _ref4.id,
          update = _ref4.update;

      return this.create({
        collection: collection,
        id: id,
        object: update
      });
    }
  }, {
    key: "exists",
    value: function exists() {
      var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref5.collection,
          id = _ref5.id;

      return this.getClient().exists(this.getKey(collection, id));
    }
  }, {
    key: "increment",
    value: function increment() {
      var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref6.collection,
          id = _ref6.id,
          bins = _ref6.bins;

      return this.getClient().incr(this.getKey(collection, id), bins);
    }
  }, {
    key: "remove",
    value: function remove() {
      var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref7.collection,
          id = _ref7.id;

      return this.getClient().remove(this.getKey(collection, id));
    }
  }, {
    key: "loadAll",
    value: function loadAll() {
      var _this2 = this;

      var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref8.collection,
          select = _ref8.select;

      return new Promise(function (resolve, reject) {
        var options = _lodash.default.isArray(select) ? {
          select: select
        } : undefined;

        var query = _this2.getClient().query(_this2.ns, collection, options);

        var records = [];

        var dataCallback = function dataCallback(record) {
          return records.push(record.bins);
        };

        var stream = query.foreach();
        stream.on('data', dataCallback);
        stream.on('error', reject);
        stream.on('end', function () {
          return resolve(records);
        });
      });
    }
  }, {
    key: "loadById",
    value: function () {
      var _loadById = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4() {
        var _ref9,
            collection,
            id,
            select,
            record,
            pk,
            _args4 = arguments;

        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _ref9 = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : {}, collection = _ref9.collection, id = _ref9.id, select = _ref9.select;
                _context4.prev = 1;
                record = null;
                pk = this.getKey(collection, id);

                if (!_lodash.default.isArray(select)) {
                  _context4.next = 10;
                  break;
                }

                _context4.next = 7;
                return this.getClient().select(pk, select);

              case 7:
                record = _context4.sent;
                _context4.next = 13;
                break;

              case 10:
                _context4.next = 12;
                return this.getClient().get(pk);

              case 12:
                record = _context4.sent;

              case 13:
                return _context4.abrupt("return", record.bins);

              case 16:
                _context4.prev = 16;
                _context4.t0 = _context4["catch"](1);

                if (!(_context4.t0.code === 2)) {
                  _context4.next = 20;
                  break;
                }

                return _context4.abrupt("return", null);

              case 20:
                throw _context4.t0;

              case 21:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this, [[1, 16]]);
      }));

      function loadById() {
        return _loadById.apply(this, arguments);
      }

      return loadById;
    }()
  }, {
    key: "loadByQuery",
    value: function loadByQuery() {
      var _this3 = this;

      var _ref10 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref10.collection,
          query = _ref10.query,
          select = _ref10.select;

      return new Promise(function (resolve, reject) {
        var aeroQuery = _this3.getClient().query(_this3.ns, collection, _makeFiltersFromObject(query, select));

        var records = [];

        var dataCallback = function dataCallback(record) {
          return records.push(record.bins);
        };

        var stream = aeroQuery.foreach();
        stream.on('data', dataCallback);
        stream.on('error', reject);
        stream.on('end', function () {
          return resolve(records);
        });
      });
    }
  }, {
    key: "loadByIds",
    value: function () {
      var _loadByIds = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5() {
        var _this4 = this;

        var _ref11,
            collection,
            ids,
            select,
            keys,
            results,
            _args5 = arguments;

        return _regenerator.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _ref11 = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : {}, collection = _ref11.collection, ids = _ref11.ids, select = _ref11.select;
                keys = ids.map(function (id) {
                  return {
                    key: _this4.getKey(collection, id),
                    read_all_bins: !select,
                    bins: select
                  };
                });
                _context5.next = 4;
                return this.getClient().batchRead(keys);

              case 4:
                results = _context5.sent;
                return _context5.abrupt("return", results.map(function (result) {
                  return result.record.bins;
                }));

              case 6:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function loadByIds() {
        return _loadByIds.apply(this, arguments);
      }

      return loadByIds;
    }()
  }, {
    key: "removeById",
    value: function removeById(_ref12) {
      var collection = _ref12.collection,
          id = _ref12.id;
      return this.getClient(collection).remove(this.getKey(collection, id));
    }
  }, {
    key: "bulk",
    value: function bulk() {
      var _ref13 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref13.collection,
          ids = _ref13.ids,
          action = _ref13.action,
          select = _ref13.select;

      switch (action) {
        case 'loadByIds':
          return this[action]({
            collection: collection,
            ids: ids,
            select: select
          });

        default:
          throw new Error("Action 'action' is not supported");
      }
    }
  }, {
    key: "proxy",
    value: function () {
      var _proxy = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee7(req, res) {
        var _this5 = this;

        var result;
        return _regenerator.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                this.use(
                /*#__PURE__*/
                function () {
                  var _ref14 = _asyncToGenerator(
                  /*#__PURE__*/
                  _regenerator.default.mark(function _callee6(req, res) {
                    var entityAction, result;
                    return _regenerator.default.wrap(function _callee6$(_context6) {
                      while (1) {
                        switch (_context6.prev = _context6.next) {
                          case 0:
                            entityAction = req.getEntity();
                            _context6.next = 3;
                            return _this5[entityAction.action](entityAction.payload);

                          case 3:
                            result = _context6.sent;
                            res.json(result);

                          case 5:
                          case "end":
                            return _context6.stop();
                        }
                      }
                    }, _callee6);
                  }));

                  return function (_x3, _x4) {
                    return _ref14.apply(this, arguments);
                  };
                }());
                _context7.next = 3;
                return this.transport.getClient().request(req.getEntity());

              case 3:
                result = _context7.sent;
                res.json(result);

              case 5:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function proxy(_x, _x2) {
        return _proxy.apply(this, arguments);
      }

      return proxy;
    }()
  }]);

  return AerospikeBackend;
}(_processBackend.default);

exports.default = AerospikeBackend;

function _makeFiltersFromObject(obj) {
  var filter = Aerospike.filter;
  var statement = {
    filters: []
  };
  if (_lodash.default.isArray(obj.select)) statement.select = obj.select;

  _lodash.default.each(obj, function (val, key) {
    if (_lodash.default.isObject(val)) {
      var min;
      var max;

      _lodash.default.each(val, function (_val, _key) {
        switch (_key) {
          case '$gt':
            min = _val;
            break;

          case '$lt':
            max = _val;
            break;
        }
      });

      return statement.filters.push(filter.range(key, min, max));
    }

    statement.filters.push(filter.equal(key, val));
  });

  return statement;
}