"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _events = _interopRequireDefault(require("events"));

var _lodash = _interopRequireDefault(require("lodash"));

var _jsonwebtoken = _interopRequireDefault(require("jsonwebtoken"));

var _lokijs = _interopRequireDefault(require("lokijs"));

var _enum = require("../enum");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _authMiddlewareHandler(_x, _x2, _x3) {
  return _authMiddlewareHandler2.apply(this, arguments);
}

function _authMiddlewareHandler2() {
  _authMiddlewareHandler2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3(req, res, next) {
    var _this$parseRequest, payload, token;

    return _regenerator.default.wrap(function _callee3$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.prev = 0;
            _this$parseRequest = this.parseRequest(req), payload = _this$parseRequest.payload;

            if (!(payload.masterKey && payload.masterKey === this.masterKey)) {
              _context4.next = 4;
              break;
            }

            return _context4.abrupt("return", res.json({
              token: this.masterKey,
              entities: this.entities,
              rules: this.rules
            }));

          case 4:
            _context4.next = 6;
            return this.authClient(payload.credentials);

          case 6:
            token = _context4.sent;

            if (token) {
              _context4.next = 9;
              break;
            }

            return _context4.abrupt("return", next({
              message: 'Unauthorized.',
              status: 401
            }));

          case 9:
            res.next = {
              token: token,
              entities: this.entities
            }; // todo: serialize entities by permissions

            next();
            _context4.next = 17;
            break;

          case 13:
            _context4.prev = 13;
            _context4.t0 = _context4["catch"](0);
            console.error(_context4.t0);
            next({
              message: 'Internal Server Error.',
              status: 500
            });

          case 17:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee3, this, [[0, 13]]);
  }));
  return _authMiddlewareHandler2.apply(this, arguments);
}

function _fetchMiddlewareHandler(_x4, _x5, _x6) {
  return _fetchMiddlewareHandler2.apply(this, arguments);
}

function _fetchMiddlewareHandler2() {
  _fetchMiddlewareHandler2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee4(req, res, next) {
    var _this$parseRequest2, auth, responseData;

    return _regenerator.default.wrap(function _callee4$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            try {
              _this$parseRequest2 = this.parseRequest(req), auth = _this$parseRequest2.auth;
              responseData = {
                entities: this.entities
              };
              if (auth.masterKey === this.masterKey) responseData.rules = this.rules;
              res.next = responseData; // todo: serialize entities by permissions

              next();
            } catch (err) {
              console.error(err);
              next({
                message: 'Internal Server Error.',
                status: 500
              });
            }

          case 1:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee4, this);
  }));
  return _fetchMiddlewareHandler2.apply(this, arguments);
}

function _checkAuthMiddleware(_x7, _x8, _x9) {
  return _checkAuthMiddleware2.apply(this, arguments);
}

function _checkAuthMiddleware2() {
  _checkAuthMiddleware2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee5(req, res, next) {
    var parsedRequest, token, action, isAuth;
    return _regenerator.default.wrap(function _callee5$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.prev = 0;
            parsedRequest = this.parseRequest(req);
            token = parsedRequest.token, action = parsedRequest.action;

            if (!(action === _enum.EntityAction.AUTH)) {
              _context6.next = 5;
              break;
            }

            return _context6.abrupt("return", next());

          case 5:
            if (!(token === this.masterKey)) {
              _context6.next = 7;
              break;
            }

            return _context6.abrupt("return", next());

          case 7:
            _context6.next = 9;
            return this.checkAuth(parsedRequest);

          case 9:
            isAuth = _context6.sent;

            if (isAuth) {
              _context6.next = 12;
              break;
            }

            return _context6.abrupt("return", next({
              message: 'Unauthorized',
              status: 401
            }));

          case 12:
            next();
            _context6.next = 19;
            break;

          case 15:
            _context6.prev = 15;
            _context6.t0 = _context6["catch"](0);
            console.error(_context6.t0);
            next({
              message: 'Internal Server Error.',
              status: 500
            });

          case 19:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee5, this, [[0, 15]]);
  }));
  return _checkAuthMiddleware2.apply(this, arguments);
}

function _checkPermissions(_x10, _x11, _x12) {
  return _checkPermissions2.apply(this, arguments);
}

function _checkPermissions2() {
  _checkPermissions2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee6(req, res, next) {
    var _this$parseRequest3, token, action, payload, collection, tag, auth;

    return _regenerator.default.wrap(function _callee6$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.prev = 0;
            _this$parseRequest3 = this.parseRequest(req), token = _this$parseRequest3.token, action = _this$parseRequest3.action, payload = _this$parseRequest3.payload, collection = _this$parseRequest3.collection, tag = _this$parseRequest3.tag, auth = _this$parseRequest3.auth;

            if (!(action === _enum.EntityAction.AUTH)) {
              _context7.next = 4;
              break;
            }

            return _context7.abrupt("return", next());

          case 4:
            // let rule = this.getRule({ tag, collection })
            // if (!rule) return next()

            /* switch (action) {
              case EntityAction.LOAD_ALL:
              case EntityAction.LOAD_ONE:
              case EntityAction.LOAD_BY_ID:
              case EntityAction.LOAD_BY_QUERY:
                if (typeof rule.read === 'undefined') return next()
                if (typeof rule.read === 'boolean') {
                  if (rule) {
                    next()
                  } else {
                    next({ message: 'Forbidden', status: 403 })
                  }
                  return
                }
                if (typeof rule.read === 'string') {
                  req.rule = { auth, rule: rule.write }
                  return next()
                }
                return next({ message: 'Forbidden', status: 403 })
              case EntityAction.REMOVE_BY_QUERY:
              case EntityAction.REMOVE_BY_ID:
              case EntityAction.UPDATE:
              case EntityAction.UPDATE_BY_ID:
              case EntityAction.CREATE:
                if (typeof rule.write === 'undefined') return next()
                if (typeof rule.write === 'boolean') {
                  if (rule) {
                    next()
                  } else {
                    next({ message: 'Forbidden', status: 403 })
                  }
                  return
                }
                if (typeof rule.write === 'string') {
                  req.rule = { auth, rule: rule.write }
                  return next()
                }
                return next({ message: 'Forbidden', status: 403 })
             } */
            req.auth = auth;
            next();
            _context7.next = 11;
            break;

          case 8:
            _context7.prev = 8;
            _context7.t0 = _context7["catch"](0);
            next({
              message: 'Internal Server Error',
              status: 500
            });

          case 11:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee6, this, [[0, 8]]);
  }));
  return _checkPermissions2.apply(this, arguments);
}

function _isMaster(_x13, _x14, _x15) {
  return _isMaster2.apply(this, arguments);
}

function _isMaster2() {
  _isMaster2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee7(req, res, next) {
    var _this$parseRequest4, token;

    return _regenerator.default.wrap(function _callee7$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            _context8.prev = 0;
            _this$parseRequest4 = this.parseRequest(req), token = _this$parseRequest4.token;

            if (!(token !== this.masterKey)) {
              _context8.next = 4;
              break;
            }

            return _context8.abrupt("return", next({
              status: 403,
              message: 'Forbidden'
            }));

          case 4:
            next();
            _context8.next = 10;
            break;

          case 7:
            _context8.prev = 7;
            _context8.t0 = _context8["catch"](0);
            next({
              status: 500,
              message: 'Internal Server Error'
            });

          case 10:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee7, this, [[0, 7]]);
  }));
  return _isMaster2.apply(this, arguments);
}

function _defineRule(_x16, _x17, _x18) {
  return _defineRule2.apply(this, arguments);
}

function _defineRule2() {
  _defineRule2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee8(req, res, next) {
    var _this$parseRequest5, payload, collection, tag, rule, customRule;

    return _regenerator.default.wrap(function _callee8$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            try {
              _this$parseRequest5 = this.parseRequest(req), payload = _this$parseRequest5.payload;
              collection = payload.collection, tag = payload.tag, rule = payload.rule;

              if (collection) {
                tag = tag || this.tag;
              } else {
                tag = tag || _enum.ALL_COLLECTIONS;
              }

              if (collection === _enum.ALL_COLLECTIONS) collection = undefined;
              customRule = this.customRules.insert({
                tag: tag,
                collection: collection,
                rule: rule
              });
              res.next = {
                id: customRule.$loki,
                tag: tag,
                collection: collection,
                rule: rule
              };
              next();
            } catch (err) {
              next({
                status: 500,
                message: 'Internal Server Error'
              });
            }

          case 1:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee8, this);
  }));
  return _defineRule2.apply(this, arguments);
}

function _removeRule(_x19, _x20, _x21) {
  return _removeRule2.apply(this, arguments);
}

function _removeRule2() {
  _removeRule2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee9(req, res, next) {
    var _this$parseRequest6, payload, id;

    return _regenerator.default.wrap(function _callee9$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            try {
              _this$parseRequest6 = this.parseRequest(req), payload = _this$parseRequest6.payload;
              id = payload.id;
              this.customRules.remove({
                $loki: id
              });
              next();
            } catch (err) {
              next({
                status: 500,
                message: 'Internal Server Error'
              });
            }

          case 1:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee9, this);
  }));
  return _removeRule2.apply(this, arguments);
}

function _getRules(_x22, _x23, _x24) {
  return _getRules2.apply(this, arguments);
}

function _getRules2() {
  _getRules2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee10(req, res, next) {
    var _this$parseRequest7, payload, _payload$count, count, _payload$skip, skip;

    return _regenerator.default.wrap(function _callee10$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            try {
              _this$parseRequest7 = this.parseRequest(req), payload = _this$parseRequest7.payload;
              _payload$count = payload.count, count = _payload$count === void 0 ? 10 : _payload$count, _payload$skip = payload.skip, skip = _payload$skip === void 0 ? 0 : _payload$skip;
              res.next = _lodash.default.map(this.customRules.chain().find({}).offset(skip).limit(count).data(), function (rule) {
                return {
                  rule: rule.rule,
                  collection: rule.collection,
                  tag: rule.tag,
                  id: rule.$loki
                };
              });
              next();
            } catch (err) {
              next({
                status: 500,
                message: 'Internal Server Error'
              });
            }

          case 1:
          case "end":
            return _context11.stop();
        }
      }
    }, _callee10, this);
  }));
  return _getRules2.apply(this, arguments);
}

function _handleWatchRequest(_ref) {
  var id = _ref.id,
      collection = _ref.collection,
      entityId = _ref.entityId,
      tag = _ref.tag,
      filter = _ref.filter;

  try {
    if (!collection) {
      if (!this.watchMap.has(_enum.ALL_COLLECTIONS)) {
        this.watchMap.set(_enum.ALL_COLLECTIONS, new Set([id]));
        this.emit(_enum.TransportEvent.PROXY_WATCH_REQUEST, {
          collection: collection,
          entityId: entityId,
          tag: tag,
          filter: filter
        });
      } else {
        this.watchMap.get(_enum.ALL_COLLECTIONS).add(id);
      }

      return;
    }

    var watchName = "".concat(tag, ":").concat(collection);

    if (!entityId) {
      if (!this.watchMap.has(watchName)) {
        this.watchMap.set(watchName, new Set([id]));
        this.emit(_enum.TransportEvent.PROXY_WATCH_REQUEST, {
          collection: collection,
          entityId: entityId,
          tag: tag,
          filter: filter
        });
      } else {
        this.watchMap.get(watchName).add(id);
      }

      return;
    }

    watchName = "".concat(tag, ":").concat(collection, ":").concat(entityId);

    if (!this.watchMap.has(watchName)) {
      this.watchMap.set(watchName, new Set([id]));
      this.emit(_enum.TransportEvent.PROXY_WATCH_REQUEST, {
        collection: collection,
        entityId: entityId,
        tag: tag,
        filter: filter
      });
    } else {
      this.watchMap.get(watchName).add(id);
    }
  } catch (err) {
    console.error(err);
  }
}

function _handleUnwatchRequest(_ref2) {
  var id = _ref2.id,
      collection = _ref2.collection,
      entityId = _ref2.entityId,
      filter = _ref2.filter,
      tag = _ref2.tag;

  try {
    var collectionListeners;

    if (!collection) {
      if (!this.watchMap.has(_enum.ALL_COLLECTIONS)) {
        return;
      }

      collectionListeners = this.watchMap.get(_enum.ALL_COLLECTIONS);
      collectionListeners.delete(id);

      if (!collectionListeners.size) {
        this.watchMap.delete(_enum.ALL_COLLECTIONS);
        this.emit(_enum.TransportEvent.PROXY_UNWATCH_REQUEST, {
          collection: collection,
          entityId: entityId,
          filter: filter,
          tag: tag
        });
      }

      return;
    }

    var watchName = "".concat(tag, ":").concat(collection);

    if (!entityId) {
      if (!this.watchMap.has(watchName)) {
        return;
      }

      collectionListeners = this.watchMap.get(watchName);
      collectionListeners.delete(id);

      if (!collectionListeners.size) {
        this.watchMap.delete(watchName);
        this.emit(_enum.TransportEvent.PROXY_UNWATCH_REQUEST, {
          collection: collection,
          entityId: entityId,
          filter: filter,
          tag: tag
        });
      }

      return;
    }

    watchName = "".concat(tag, ":").concat(collection, ":").concat(entityId);

    if (!this.watchMap.has(watchName)) {
      return;
    }

    collectionListeners = this.watchMap.get(watchName);
    collectionListeners.delete(id);

    if (!collectionListeners.size) {
      this.watchMap.delete(watchName);
      this.emit(_enum.TransportEvent.PROXY_UNWATCH_REQUEST, {
        collection: collection,
        entityId: entityId,
        filter: filter,
        tag: tag
      });
    }
  } catch (err) {
    console.error(err);
  }
}

function _next(middlewares, index, req, res, error) {
  if (error) return this.errorHandler(req, res, error);

  if (index === middlewares.length) {
    return res.json(res.next);
  }

  return middlewares[index](req, res, _next.bind(this, middlewares, ++index, req, res));
}

var _private = new WeakMap();

var BaseBackend =
/*#__PURE__*/
function (_EventEmitter) {
  _inherits(BaseBackend, _EventEmitter);

  function BaseBackend() {
    var _context;

    var _this;

    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref3$config = _ref3.config,
        config = _ref3$config === void 0 ? {} : _ref3$config,
        _ref3$entities = _ref3.entities,
        entities = _ref3$entities === void 0 ? [] : _ref3$entities,
        _ref3$rules = _ref3.rules,
        rules = _ref3$rules === void 0 ? [] : _ref3$rules,
        _ref3$tag = _ref3.tag,
        tag = _ref3$tag === void 0 ? _enum.DEFAULT_TAG : _ref3$tag,
        masterKey = _ref3.masterKey,
        id = _ref3.id;

    _classCallCheck(this, BaseBackend);

    if (!masterKey) throw new Error('must pass masterKey.');
    if (typeof masterKey !== 'string') throw new Error('type of masterKey must be string.');
    _this = _possibleConstructorReturn(this, _getPrototypeOf(BaseBackend).call(this));
    var _scope = {
      id: id,
      config: config,
      globalMiddlewareArray: [],
      collectionMiddlewareMap: new Map(),
      actionMiddlewareMap: new Map(),
      collectionActionMiddlewareMap: new Map(),
      // ** just to index the handlers
      handlerIndex: 0,
      entities: entities,
      rules: _defineProperty({}, _enum.ALL_COLLECTIONS, [{
        write: "auth.masterKey === '".concat(masterKey, "'"),
        read: "auth.masterKey === '".concat(masterKey, "'"),
        include: '*',
        exclude: null,
        forbiddenActions: [],
        permittedActions: []
      }]),
      tag: tag,
      masterKey: masterKey
    };

    _private.set(_assertThisInitialized(_this), _scope);

    _this.defineRules(rules);

    _this.watchMap = new Map();
    _this.handleWatchrequest = (_context = _assertThisInitialized(_this), _handleWatchRequest).bind(_context);
    _this.handleUnwatchrequest = (_context = _assertThisInitialized(_this), _handleUnwatchRequest).bind(_context);
    return _this;
  }

  _createClass(BaseBackend, [{
    key: "setTransport",
    // ** NOTE::AVAR write the client transport once
    value: function setTransport(transport) {
      // ** TODO::AVAR check if transport is BaseTransport
      Object.defineProperty(this, 'transport', {
        configurable: false,
        writable: false,
        value: transport
      });
    }
  }, {
    key: "setErrorHandler",
    value: function setErrorHandler(handler) {
      if (typeof handler !== 'function') throw new Error('Handler must be function');
      this.errorHandler = handler;
    } // ** middlewareHandler (req, res, next) => {}
    // ** AVAR::NOTE add global middleware for action or with collection

  }, {
    key: "addMiddleware",
    value: function addMiddleware(path, middlewareHandler, index) {
      if (!_lodash.default.isString(path) || !_lodash.default.isFunction(middlewareHandler)) throw new Error("Arguments should be (string, function)");

      var _scope = _private.get(this);

      var actionMiddlewareMap = _scope.actionMiddlewareMap,
          collectionActionMiddlewareMap = _scope.collectionActionMiddlewareMap,
          handlerIndex = _scope.handlerIndex;
      var result = path.split('.');
      var action = null;
      var collection = null;
      index = _lodash.default.isNumber(index) ? index : handlerIndex;

      if (result.length > 2) {
        throw new Error("Middleware path ".concat(path, " should be <action> or <collection>.<action>"));
      }

      if (result.length === 1) {
        action = result[0];
      }

      if (result.length === 2) {
        collection = result[0];
        action = result[1];
      }

      if (!collection) {
        // ** if we just have the action in path
        if (!actionMiddlewareMap.has(action)) {
          actionMiddlewareMap.set(action, []);
        }

        var actionMiddlewares = actionMiddlewareMap.get(action);
        actionMiddlewares.push({
          handler: middlewareHandler,
          index: index
        });
      } else {
        // ** if we have collection and also action in path
        if (!collectionActionMiddlewareMap.has(path)) {
          collectionActionMiddlewareMap.set(path, []);
        }

        var collectionActionMiddlewares = collectionActionMiddlewareMap.get(path);
        collectionActionMiddlewares.push({
          handler: middlewareHandler,
          index: index
        });
      }

      _scope.handlerIndex++;
    } // ** AVAR::NOTE add global middleware or global middleware for a collection

  }, {
    key: "use",
    value: function use(arg1, arg2, arg3) {
      var _scope = _private.get(this);

      var globalMiddlewareArray = _scope.globalMiddlewareArray,
          collectionMiddlewareMap = _scope.collectionMiddlewareMap,
          handlerIndex = _scope.handlerIndex;
      var collection = null;
      var middlewareHandler = null;
      var index = handlerIndex;

      if (_lodash.default.isFunction(arg1)) {
        middlewareHandler = arg1;
        index = _lodash.default.isNumber(arg2) ? arg2 : handlerIndex;
      }

      if (_lodash.default.isString(arg1) && _lodash.default.isFunction(arg2)) {
        collection = arg1;
        middlewareHandler = arg2;
        index = _lodash.default.isNumber(arg3) ? arg3 : handlerIndex;
      }

      if (!collection) {
        // ** we are attaching the global middleware
        globalMiddlewareArray.push({
          handler: middlewareHandler,
          index: index
        });
      } else {
        // ** we are attaching the global middleware for collection
        if (!collectionMiddlewareMap.has(collection)) {
          collectionMiddlewareMap.set(collection, []);
        }

        var collectionMiddlewares = collectionMiddlewareMap.get(collection);
        collectionMiddlewares.push({
          handler: middlewareHandler,
          index: index
        });
      }

      _scope.handlerIndex++;
    }
  }, {
    key: "getMiddlewares",
    value: function getMiddlewares(action, collection) {
      var _scope = _private.get(this);

      var globalMiddlewareArray = _scope.globalMiddlewareArray,
          collectionMiddlewareMap = _scope.collectionMiddlewareMap,
          actionMiddlewareMap = _scope.actionMiddlewareMap,
          collectionActionMiddlewareMap = _scope.collectionActionMiddlewareMap;
      var actionMiddlewareArray = actionMiddlewareMap.has(action) ? actionMiddlewareMap.get(action) : [];
      var collectionMiddlewareArray = collectionMiddlewareMap.has(collection) ? collectionMiddlewareMap.get(collection) : []; // ** AVAR::NOTE

      var path = "".concat(collection, ".").concat(action);
      var collectionActionMiddlewareArray = collectionActionMiddlewareMap.has(path) ? collectionActionMiddlewareMap.get(path) : [];
      var middlewares = [].concat(_toConsumableArray(globalMiddlewareArray), _toConsumableArray(actionMiddlewareArray), _toConsumableArray(collectionMiddlewareArray), _toConsumableArray(collectionActionMiddlewareArray));
      var sortedMiddlewaresArray = middlewares.sort(function (m1, m2) {
        return m1.index - m2.index;
      });
      return sortedMiddlewaresArray.map(function (m) {
        return m.handler;
      });
    } // ***** Functions to override ****
    // ** NOTE::AVAR the purpose of parse is to parse/map the request to entityAction

  }, {
    key: "parseRequest",
    value: function parseRequest(req, token) {
      if (token === this.masterKey) return {
        auth: req.auth || {
          masterKey: this.masterKey
        }
      };
      return this.checkAuth({
        token: token
      }) ? {
        auth: this.decoded({
          token: token
        })
      } : {};
    } // ** the basic initialize is listening for transport events and running middleware function

  }, {
    key: "bind",
    value: function () {
      var _bind = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _this2 = this;

        var db;
        return _regenerator.default.wrap(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                db = new _lokijs.default("./".concat(this.id, ".db"), {
                  autoSave: true,
                  autoSaveInterval: 5000
                });
                _context2.next = 3;
                return new Promise(function (resolve, reject) {
                  db.loadDatabase({}, function () {
                    _this2.customRules = db.getCollection('customRules');

                    if (!_this2.customRules) {
                      _this2.customRules = db.addCollection('customRules');
                    }

                    resolve();
                  });
                });

              case 3:
                this.transport.on(_enum.TransportEvent.TRANSPORT_REQUEST, function (req, res) {
                  // try {
                  var entityAction = _this2.parseRequest(req);

                  var action = entityAction.action,
                      collection = entityAction.collection;

                  _this2.emit(action, entityAction);

                  var actionMiddlewares = _this2.getMiddlewares(action, collection);

                  if (actionMiddlewares) {
                    res.next = null; // to avoid httpClient parsing error on json response

                    _next.call(_this2, actionMiddlewares, 0, req, res);
                  } // } catch(err) {
                  //     console.log("Myth of errors :: DAVE, AVAR")
                  // }

                });
                this.use(_checkAuthMiddleware.bind(this));
                this.use(_checkPermissions.bind(this));
                this.addMiddleware(_enum.EntityAction.AUTH, _authMiddlewareHandler.bind(this));
                this.addMiddleware(_enum.EntityAction.FETCH_ENTITIES, _fetchMiddlewareHandler.bind(this));
                this.addMiddleware(_enum.EntityAction.DEFINE_RULE, _isMaster.bind(this));
                this.addMiddleware(_enum.EntityAction.REMOVE_RULE, _isMaster.bind(this));
                this.addMiddleware(_enum.EntityAction.GET_RULES, _isMaster.bind(this));
                this.addMiddleware(_enum.EntityAction.DEFINE_RULE, _defineRule.bind(this));
                this.addMiddleware(_enum.EntityAction.REMOVE_RULE, _removeRule.bind(this));
                this.addMiddleware(_enum.EntityAction.GET_RULES, _getRules.bind(this));
                this.addRoute({
                  method: 'POST',
                  action: _enum.EntityAction.AUTH,
                  route: _enum.EntityAction.AUTH,
                  custom: false
                });
                this.addRoute({
                  method: 'POST',
                  action: _enum.EntityAction.FETCH_ENTITIES,
                  route: _enum.EntityAction.FETCH_ENTITIES,
                  custom: false
                });
                this.addRoute({
                  method: 'POST',
                  action: _enum.EntityAction.DEFINE_RULE,
                  route: _enum.EntityAction.DEFINE_RULE,
                  custom: false
                });
                this.addRoute({
                  method: 'POST',
                  action: _enum.EntityAction.REMOVE_RULE,
                  route: _enum.EntityAction.REMOVE_RULE,
                  custom: false
                });
                this.addRoute({
                  method: 'POST',
                  action: _enum.EntityAction.GET_RULES,
                  route: _enum.EntityAction.GET_RULES,
                  custom: false
                });

              case 19:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee, this);
      }));

      function bind() {
        return _bind.apply(this, arguments);
      }

      return bind;
    }()
  }, {
    key: "request",
    value: function request() {}
  }, {
    key: "emitWatch",
    value: function emitWatch() {}
    /**
     *
     * @param payload
     * @return String: token
     */

  }, {
    key: "authClient",
    value: function authClient(credentials) {
      return _jsonwebtoken.default.sign(credentials || {}, process.env.WIRENTITY_JWT_SERCRET || this.config.JWT_SECRET || _enum.JWT_SECRET);
    }
  }, {
    key: "checkAuth",
    value: function checkAuth() {
      var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          token = _ref4.token;

      try {
        _jsonwebtoken.default.verify(token, process.env.WIRENTITY_JWT_SERCRET || this.config.JWT_SECRET || _enum.JWT_SECRET);

        return true;
      } catch (err) {
        return false;
      }
    }
  }, {
    key: "decoded",
    value: function decoded() {
      var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          token = _ref5.token;

      return _jsonwebtoken.default.verify(token, process.env.WIRENTITY_JWT_SERCRET || this.config.JWT_SECRET || _enum.JWT_SECRET).data;
    }
  }, {
    key: "addRoute",
    value: function addRoute() {}
  }, {
    key: "registerEntity",
    value: function registerEntity(entities) {
      var _this3 = this;

      entities = _lodash.default.isArray(entities) ? entities : [entities];

      _lodash.default.each(entities, function (_ref6) {
        var collection = _ref6.collection,
            schema = _ref6.schema,
            idField = _ref6.idField,
            _ref6$tag = _ref6.tag,
            tag = _ref6$tag === void 0 ? _this3.tag : _ref6$tag;
        if (_lodash.default.find(_this3.entities, {
          collection: collection,
          tag: tag
        })) return;

        _this3.entities.push({
          collection: collection,
          schema: schema,
          idField: idField,
          tag: tag
        });

        if (!_this3.watch) return;

        _this3.emitWatch({
          action: _enum.WatchActions.NEW_ENTITY,
          data: {
            collection: collection,
            schema: schema,
            idField: idField,
            tag: tag
          },
          all: true
        });
      });
    }
  }, {
    key: "defineRule",
    value: function defineRule() {
      var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          tag = _ref7.tag,
          collection = _ref7.collection,
          _ref7$rule = _ref7.rule,
          rule = _ref7$rule === void 0 ? {
        write: true,
        read: true,
        include: '*',
        exclude: null
      } : _ref7$rule;

      if (rule.include && rule.exclude) throw new Error('You can define either `include` or `exclude` not both.');
      var ruleName = '';

      if (collection && collection !== _enum.ALL_COLLECTIONS) {
        tag = tag || this.tag;
        ruleName = "".concat(tag, ":").concat(collection);
      } else {
        ruleName = tag || _enum.ALL_COLLECTIONS;
      }

      if (!this.rules[ruleName]) this.rules[ruleName] = [];
      this.rules[ruleName].push(rule);
      this.emitWatch({
        action: _enum.WatchActions.NEW_RULE,
        data: {
          key: ruleName,
          rule: rule
        },
        all: true
      });
    }
  }, {
    key: "defineRules",
    value: function defineRules() {
      var _this4 = this;

      var rules = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      _lodash.default.each(rules, function (_ref8) {
        var tag = _ref8.tag,
            collection = _ref8.collection,
            rule = _ref8.rule;

        _this4.defineRule({
          tag: tag,
          collection: collection,
          rule: rule
        });
      });
    }
  }, {
    key: "startWatch",
    value: function startWatch() {
      this.watch = true;
    }
  }, {
    key: "proxy",
    value: function proxy(client) {
      var _this5 = this;

      // ** AVAR::NOTE::TODO maybe we need some checks for client to be connected
      this.registerEntity(client.entities);
      client.on(_enum.WatchActions.NEW_ENTITY, function (entity) {
        _this5.registerEntity(entity);
      });
      client.on(_enum.WatchActions.NEW_RULE, function (_ref9) {
        var key = _ref9.key,
            rule = _ref9.rule;

        _this5.emitWatch({
          action: _enum.WatchActions.NEW_RULE,
          data: {
            key: key,
            rule: rule
          },
          all: true
        });
      });
      this.use(
      /*#__PURE__*/
      function () {
        var _ref10 = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee2(req, res, next) {
          var entityAction, result;
          return _regenerator.default.wrap(function _callee2$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.prev = 0;
                  entityAction = _this5.parseRequest(req);

                  if (!(entityAction.action === _enum.EntityAction.AUTH)) {
                    _context3.next = 4;
                    break;
                  }

                  return _context3.abrupt("return", next());

                case 4:
                  if (!(entityAction.action === _enum.EntityAction.GET_RULES)) {
                    _context3.next = 6;
                    break;
                  }

                  return _context3.abrupt("return", next());

                case 6:
                  if (!(entityAction.action === _enum.EntityAction.FETCH_ENTITIES)) {
                    _context3.next = 11;
                    break;
                  }

                  if (!(entityAction.auth.masterKey !== _this5.masterKey)) {
                    _context3.next = 9;
                    break;
                  }

                  return _context3.abrupt("return", next());

                case 9:
                  _lodash.default.each(client.rules, function (rule, ruleKey) {
                    if (!res.next.rules[ruleKey]) return res.next.rules[ruleKey] = rule;
                    res.next.rules[ruleKey] = res.next.rules[ruleKey].concat(rule);
                  });

                  return _context3.abrupt("return", next());

                case 11:
                  if (entityAction.auth && entityAction.auth.masterKey === _this5.masterKey) {
                    delete entityAction.auth;
                  }

                  _context3.t0 = entityAction.action;
                  _context3.next = _context3.t0 === _enum.EntityAction.CREATE ? 15 : _context3.t0 === _enum.EntityAction.UPDATE_BY_ID ? 15 : _context3.t0 === _enum.EntityAction.UPDATE ? 15 : _context3.t0 === _enum.EntityAction.REMOVE_BY_ID ? 15 : _context3.t0 === _enum.EntityAction.REMOVE_BY_QUERY ? 15 : _context3.t0 === _enum.EntityAction.RUN_COMMAND ? 15 : _context3.t0 === _enum.EntityAction.LOAD_ALL ? 15 : _context3.t0 === _enum.EntityAction.LOAD_BY_QUERY ? 15 : _context3.t0 === _enum.EntityAction.LOAD_BY_ID ? 15 : _context3.t0 === _enum.EntityAction.LOAD_ONE ? 15 : 17;
                  break;

                case 15:
                  if (_lodash.default.find(client.entities, {
                    tag: entityAction.tag,
                    collection: entityAction.collection
                  })) {
                    _context3.next = 17;
                    break;
                  }

                  return _context3.abrupt("return", next());

                case 17:
                  _context3.next = 19;
                  return client.request(entityAction);

                case 19:
                  result = _context3.sent;

                  if (entityAction.action !== _enum.EntityAction.DEFINE_RULE && entityAction.action !== _enum.EntityAction.REMOVE_RULE) {
                    if (result) res.next = result;
                  }

                  next();
                  _context3.next = 27;
                  break;

                case 24:
                  _context3.prev = 24;
                  _context3.t1 = _context3["catch"](0);
                  next(_context3.t1);

                case 27:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee2, null, [[0, 24]]);
        }));

        return function (_x25, _x26, _x27) {
          return _ref10.apply(this, arguments);
        };
      }());
      client.on(_enum.TransportEvent.WATCH_RESPONSE, function (data) {
        if (!_this5.watch) return;

        _this5.emitWatch(data, client.rules);
      });
      this.on(_enum.TransportEvent.PROXY_WATCH_REQUEST, function (data) {
        client.requestWatch(data);
      });
      this.on(_enum.TransportEvent.PROXY_UNWATCH_REQUEST, function (data) {
        client.requestUnwatch(data);
      });
    }
  }, {
    key: "errorHandler",
    value: function errorHandler(req, res, error) {
      var message = _lodash.default.isObject(error) ? error.message : error;

      var response = _objectSpread({
        error: true,
        message: message
      }, _lodash.default.isObject(error) ? error : {});

      res.json(response);
    }
  }, {
    key: "getEntity",
    value: function getEntity() {
      var _ref11 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref11.collection,
          _ref11$tag = _ref11.tag,
          tag = _ref11$tag === void 0 ? _enum.DEFAULT_TAG : _ref11$tag;

      return _lodash.default.find(this.entities, {
        collection: collection,
        tag: tag
      });
    }
  }, {
    key: "getRule",
    value: function getRule() {
      var _ref12 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref12$tag = _ref12.tag,
          tag = _ref12$tag === void 0 ? _enum.DEFAULT_TAG : _ref12$tag,
          collection = _ref12.collection;

      return this.rules["".concat(tag, ":").concat(collection)];
    }
  }, {
    key: "getMyRules",
    value: function getMyRules() {
      var _ref13 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref13.collection;

      return this.getRules({
        collection: collection
      });
    }
  }, {
    key: "getRules",
    value: function getRules() {
      var _ref14 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref14.collection,
          _ref14$tag = _ref14.tag,
          tag = _ref14$tag === void 0 ? this.tag : _ref14$tag,
          _ref14$rules = _ref14.rules,
          rules = _ref14$rules === void 0 ? this.rules : _ref14$rules;

      var tagRules = rules[tag] || [];
      var collectionRules = rules["".concat(tag, ":").concat(collection)] || [];
      var allRules = rules[_enum.ALL_COLLECTIONS] || [];
      var tagCustomRules = this.customRules.find({
        $and: [{
          tag: {
            $in: [tag, _enum.ALL_COLLECTIONS]
          }
        }, {
          collection: {
            $eq: undefined
          }
        }]
      });
      var collectionCustomRules = this.customRules.find({
        tag: tag,
        collection: collection
      });

      var customRules = _lodash.default.map([].concat(_toConsumableArray(tagCustomRules), _toConsumableArray(collectionCustomRules)), function (rule) {
        return rule.rule;
      });

      return [].concat(_toConsumableArray(allRules), _toConsumableArray(tagRules), _toConsumableArray(collectionRules), _toConsumableArray(customRules));
    }
  }, {
    key: "getAllWatchIds",
    value: function getAllWatchIds() {
      var _ref15 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          data = _ref15.data,
          tag = _ref15.tag,
          collection = _ref15.collection,
          idField = _ref15.idField;

      var allCollectionsSocketIds = this.watchMap.get(_enum.ALL_COLLECTIONS) || [];
      var collectionSocketIds = tag && collection ? this.watchMap.get("".concat(tag, ":").concat(collection)) || [] : [];
      var entitySocketIds = data && idField ? this.watchMap.get("".concat(tag, ":").concat(collection, ":").concat(data[idField])) || [] : [];

      var allSockets = _toConsumableArray(new Set([].concat(_toConsumableArray(allCollectionsSocketIds), _toConsumableArray(collectionSocketIds), _toConsumableArray(entitySocketIds))));

      return {
        allCollectionsSocketIds: allCollectionsSocketIds,
        collectionSocketIds: collectionSocketIds,
        entitySocketIds: entitySocketIds,
        allSockets: allSockets
      };
    }
  }, {
    key: "id",
    get: function get() {
      return _private.get(this).id;
    }
  }, {
    key: "config",
    get: function get() {
      return _private.get(this).config;
    }
  }, {
    key: "tag",
    get: function get() {
      return _private.get(this).tag;
    }
  }, {
    key: "entities",
    get: function get() {
      return _private.get(this).entities;
    }
  }, {
    key: "rules",
    get: function get() {
      return _private.get(this).rules;
    }
  }, {
    key: "masterKey",
    get: function get() {
      return _private.get(this).masterKey;
    }
  }, {
    key: "handlerIndex",
    get: function get() {
      return _private.get(this).handlerIndex;
    }
  }]);

  return BaseBackend;
}(_events.default);

exports.default = BaseBackend;