"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _path = _interopRequireDefault(require("path"));

var _express = _interopRequireDefault(require("express"));

var _socket = _interopRequireDefault(require("socket.io"));

var _bodyParser = _interopRequireDefault(require("body-parser"));

var _cors = _interopRequireDefault(require("cors"));

var _baseBackend = _interopRequireDefault(require("./baseBackend"));

var _enum = require("../enum");

var _helpers = require("../utils/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ROUTES = {
  count: {
    route: '/:collection/count',
    method: 'GET'
  },
  create: {
    route: '/:collection',
    method: 'POST'
  },
  loadById: {
    route: '/:collection/:id',
    method: 'GET'
  },
  loadAll: {
    route: '/:collection',
    method: 'GET'
  },
  updateById: {
    route: '/:collection/:id',
    method: 'PUT'
  },
  removeById: {
    route: '/:collection/:id',
    method: 'DELETE'
  },
  actionByQuery: {
    route: '/:collection/:action',
    method: 'POST'
  },
  command: {
    route: '/:collection/command/:action',
    method: 'POST'
  }
};

function _handleNewConnection(socket) {
  var _this = this;

  try {
    socket.on(_enum.TransportEvent.WATCH_REQUEST, function (_ref) {
      var collection = _ref.collection,
          entityId = _ref.entityId,
          filter = _ref.filter,
          tag = _ref.tag;

      try {
        _this.handleWatchrequest({
          collection: collection,
          entityId: entityId,
          filter: filter,
          tag: tag,
          id: socket.id
        });

        if (!collection) {
          return socket.join(_enum.ALL_COLLECTIONS);
        }

        if (!entityId) {
          return socket.join("".concat(tag, ":").concat(collection));
        }

        return socket.join("".concat(tag, ":").concat(collection, ":").concat(entityId));
      } catch (err) {
        console.error('Error while handling watch request', socket.id, err);
      }
    });
    socket.on(_enum.TransportEvent.UNWATCH_REQUEST, function (_ref2) {
      var collection = _ref2.collection,
          entityId = _ref2.entityId,
          tag = _ref2.tag;

      try {
        _this.handleUnwatchrequest({
          collection: collection,
          entityId: entityId,
          tag: tag,
          id: socket.id
        });

        if (!collection) {
          return socket.leave(_enum.ALL_COLLECTIONS);
        }

        if (!entityId) {
          return socket.leave("".concat(tag, ":").concat(collection));
        }

        return socket.leave("".concat(tag, ":").concat(collection, ":").concat(entityId));
      } catch (err) {
        console.error('Error while handling watch request', socket.id, err);
      }
    });
    socket.on('disconnect', function () {// TODO:: discuss what to do here
    });
  } catch (err) {
    console.error('Error while handling socket connection', socket.id, err);
  }
}

function fetchPayload(action, req) {
  // ** AVAR::TODO more detailed parser
  switch (action) {
    case _enum.EntityAction.CREATE:
    case _enum.EntityAction.UPDATE_BY_ID:
    case _enum.EntityAction.UPDATE:
    case _enum.EntityAction.REMOVE_BY_QUERY:
    case _enum.EntityAction.LOAD_BY_QUERY:
    case _enum.EntityAction.LOAD_ONE:
    case _enum.EntityAction.COUNT:
    case _enum.EntityAction.RUN_COMMAND:
      return req.body;

    case _enum.EntityAction.LOAD_ALL:
      return {};

    case _enum.EntityAction.LOAD_BY_ID:
    case _enum.EntityAction.REMOVE_BY_ID:
      var id = req.params.id;
      return _objectSpread({
        query: {
          id: id
        }
      }, req.query);

    default:
      return req.method === 'GET' ? req.query : req.body;
  }
}

var HTTPBackend =
/*#__PURE__*/
function (_BaseBackend) {
  _inherits(HTTPBackend, _BaseBackend);

  function HTTPBackend() {
    var _this2;

    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        id = _ref3.id,
        config = _ref3.config,
        host = _ref3.host,
        port = _ref3.port,
        basePath = _ref3.basePath,
        entities = _ref3.entities,
        rules = _ref3.rules,
        masterKey = _ref3.masterKey;

    _classCallCheck(this, HTTPBackend);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(HTTPBackend).call(this, {
      id: id,
      config: config,
      entities: entities,
      rules: rules,
      masterKey: masterKey
    }));
    _this2.basePath = basePath || '/';
    _this2.host = host || '127.0.0.1';
    _this2.port = port || 3008;
    _this2.app = (0, _express.default)();
    _this2.server = null;
    return _this2;
  }

  _createClass(HTTPBackend, [{
    key: "addRoute",
    value: function addRoute(_ref4) {
      var _this3 = this;

      var route = _ref4.route,
          method = _ref4.method,
          action = _ref4.action,
          _ref4$custom = _ref4.custom,
          custom = _ref4$custom === void 0 ? true : _ref4$custom;
      var routeMethod = method.toLowerCase();

      var routePath = _path.default.join(this.basePath, custom ? '/wirentity/custom' : '', route);

      this.app[routeMethod](routePath, function (req, res, next) {
        if ((!req.get(_enum.HttpHeaders.ACTION) || req.get(_enum.HttpHeaders.ACTION) === 'undefined') && (req.params.action || action)) req.headers[_enum.HttpHeaders.ACTION.toLowerCase()] = req.params.action || action;

        _this3.transport.emit(_enum.TransportEvent.TRANSPORT_REQUEST, req, res);
      });
    }
  }, {
    key: "parseRequest",
    value: function parseRequest(req) {
      // ** AVAR::TODO very generic parser for http
      var action = req.get(_enum.HttpHeaders.ACTION);
      var collection = req.get(_enum.HttpHeaders.COLLECTION);
      var tag = req.get(_enum.HttpHeaders.TAG);
      var payload = fetchPayload(action, req); // ** console.log(`AVAR ${action}, ${collection} payload = `, payload)

      var token = req.get('authorization');

      if (typeof token === 'string') {
        token = token.split(' ')[1];
      }

      var _get$call = _get(_getPrototypeOf(HTTPBackend.prototype), "parseRequest", this).call(this, req, token),
          auth = _get$call.auth;

      return {
        action: action,
        collection: collection,
        tag: tag,
        payload: payload,
        token: token,
        auth: auth
      };
    }
  }, {
    key: "bind",
    value: function () {
      var _bind = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _this4 = this;

        var host, port, basePath, app;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                host = this.host, port = this.port, basePath = this.basePath, app = this.app;
                app.use((0, _cors.default)({
                  credentials: true,
                  origin: function origin(_origin, callback) {
                    return callback(null, _origin);
                  }
                }));
                app.use(_bodyParser.default.json());
                app.use(_bodyParser.default.urlencoded({
                  extended: true
                }));
                _context.next = 6;
                return _get(_getPrototypeOf(HTTPBackend.prototype), "bind", this).call(this);

              case 6:
                _lodash.default.each(ROUTES, function (route) {
                  return _this4.addRoute(_objectSpread({}, route, {
                    custom: false
                  }));
                });

                this.server = app.listen(port, host);
                return _context.abrupt("return", this.server);

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function bind() {
        return _bind.apply(this, arguments);
      }

      return bind;
    }()
  }, {
    key: "startWatch",
    value: function startWatch() {
      var _this5 = this;

      if (!this.server) {
        throw new Error('Need to bind backend, before starting watch');
      }

      _get(_getPrototypeOf(HTTPBackend.prototype), "startWatch", this).call(this);

      this.io = (0, _socket.default)(this.server);
      this.io.set('authorization', function (handshake, accept) {
        try {
          if (_this5.masterKey === handshake._query.token || _this5.checkAuth({
            token: handshake._query.token
          })) {
            return accept(null, true);
          }

          accept({
            message: 'Unauthorized.',
            status: 401
          }, false);
        } catch (err) {
          accept({
            message: 'Internal Server Error.',
            status: 500
          }, false);
        }
      });
      this.io.on('connection', _handleNewConnection.bind(this));
    }
  }, {
    key: "emitWatch",
    value: function emitWatch() {
      var _this6 = this;

      var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          action = _ref5.action,
          _ref5$data = _ref5.data,
          data = _ref5$data === void 0 ? {} : _ref5$data,
          collection = _ref5.collection,
          tag = _ref5.tag,
          _ref5$all = _ref5.all,
          all = _ref5$all === void 0 ? false : _ref5$all;

      var proxyRules = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      if (!this.io) {
        throw new Error('Need to start Watch, before emitting');
      }

      if (all) return this.io.emit(_enum.TransportEvent.WATCH_RESPONSE, {
        action: action,
        data: data,
        collection: collection,
        tag: tag
      });
      var entity = this.getEntity({
        collection: collection,
        tag: tag
      });

      var _this$getAllWatchIds = this.getAllWatchIds({
        data: data,
        tag: tag,
        collection: collection,
        idField: entity.idField
      }),
          allSockets = _this$getAllWatchIds.allSockets;

      var checkData = null;
      var newData = null;
      var entityAction = _enum.EntityAction.REMOVE_BY_ID;

      switch (action) {
        case _enum.WatchActions.UPDATE:
          checkData = _objectSpread(_defineProperty({}, entity.idField, data[entity.idField]), data.update, data.set);
          entityAction = _enum.EntityAction.UPDATE_BY_ID;
          break;

        case _enum.WatchActions.CREATE:
          newData = data;
          entityAction = _enum.EntityAction.CREATE;
          break;

        case _enum.WatchActions.DELETE:
          checkData = {};
          entityAction = _enum.EntityAction.REMOVE_BY_ID;
      }

      _lodash.default.each(_toConsumableArray(allSockets), function (socketId) {
        var socket = _this6.io.sockets.connected[socketId];
        if (!socket) return;
        var token = socket.handshake.query.token;
        if (token === _this6.masterKey) return socket.emit(_enum.TransportEvent.WATCH_RESPONSE, {
          action: action,
          data: data,
          collection: collection,
          tag: tag
        });
        if (!_this6.checkAuth({
          token: token
        })) return;

        var myRules = _this6.getRules({
          collection: collection,
          tag: tag
        });

        var rules = [].concat(_toConsumableArray(myRules), _toConsumableArray(_this6.getRules({
          collection: collection,
          tag: tag,
          rules: proxyRules
        })));
        if (!rules.length) return socket.emit(_enum.TransportEvent.WATCH_RESPONSE, {
          action: action,
          data: data,
          collection: collection,
          tag: tag
        });
        var checkResponse = (0, _helpers.checkPermissionWithData)({
          data: [checkData],
          action: entityAction,
          collection: collection,
          schema: _objectSpread({}, entity.schema, _defineProperty({}, data.__association, 1)),
          auth: _this6.decoded({
            token: token
          }),
          newData: newData,
          op: _enum.READ,
          rules: rules,
          tag: tag
        });
        if (!checkResponse.status || action !== _enum.WatchActions.DELETE && _lodash.default.isEmpty(checkResponse.data[0])) return;
        socket.emit(_enum.TransportEvent.WATCH_RESPONSE, {
          action: action,
          data: _objectSpread({}, _this6.transformWatchData({
            action: action,
            oldData: data,
            newData: checkResponse.data[0],
            idField: entity.idField
          }), {
            forceFetch: _lodash.default.get('checkData', 'forceFetch'),
            keys: _lodash.default.get('checkData', 'keys')
          }),
          collection: collection,
          tag: tag
        });
      }); // this.io.to(ALL_COLLECTIONS).emit(TransportEvent.WATCH_RESPONSE, { action, data, collection, tag })
      // this.io.to(`${tag}:${collection}`).emit(TransportEvent.WATCH_RESPONSE, { action, data, collection, tag })
      // this.io.to(`${tag}${collection}:${data._id}`).emit(TransportEvent.WATCH_RESPONSE, { action, data, collection, tag })

    }
  }, {
    key: "transformWatchData",
    value: function transformWatchData(_ref6) {
      var _ref7;

      var action = _ref6.action,
          idField = _ref6.idField,
          newData = _ref6.newData,
          oldData = _ref6.oldData;

      switch (action) {
        case _enum.WatchActions.UPDATE:
          return _ref7 = {}, _defineProperty(_ref7, idField, oldData[idField]), _defineProperty(_ref7, "update", _lodash.default.pick(newData, Object.keys(oldData.update || {}))), _defineProperty(_ref7, "remove", oldData.remove), _defineProperty(_ref7, "set", _lodash.default.pick(newData, Object.keys(oldData.set || {}))), _defineProperty(_ref7, "__association", oldData.__association), _defineProperty(_ref7, "__event", oldData.__event), _ref7;

        case _enum.WatchActions.CREATE:
          return _objectSpread(_defineProperty({}, idField, oldData[idField]), newData, {
            __association: oldData.__association,
            __event: oldData.__event
          });
      }

      return oldData;
    }
  }, {
    key: "getApp",
    value: function getApp() {
      return this.app;
    }
  }, {
    key: "errorHandler",
    value: function errorHandler(req, res, error) {
      if (_lodash.default.isObject(error)) {
        return res.status(error.status || 500).send(error.message);
      }

      res.status(500).send(error);
    }
  }]);

  return HTTPBackend;
}(_baseBackend.default);

exports.default = HTTPBackend;