"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "BaseBackend", {
  enumerable: true,
  get: function get() {
    return _baseBackend.default;
  }
});
Object.defineProperty(exports, "HTTPBackend", {
  enumerable: true,
  get: function get() {
    return _httpBackend.default;
  }
});
Object.defineProperty(exports, "KitooBackend", {
  enumerable: true,
  get: function get() {
    return _kitooBackend.default;
  }
});
Object.defineProperty(exports, "ZeronodeBackend", {
  enumerable: true,
  get: function get() {
    return _zeronodeBackend.default;
  }
});
Object.defineProperty(exports, "MongoBackend", {
  enumerable: true,
  get: function get() {
    return _mongoBackend.default;
  }
});
Object.defineProperty(exports, "SequalizeBackend", {
  enumerable: true,
  get: function get() {
    return _sequelizeBackend.default;
  }
});
Object.defineProperty(exports, "ProcessBackend", {
  enumerable: true,
  get: function get() {
    return _processBackend.default;
  }
});
Object.defineProperty(exports, "AerospikeBackend", {
  enumerable: true,
  get: function get() {
    return _aerospikeBackend.default;
  }
});
exports.default = void 0;

var _baseBackend = _interopRequireDefault(require("./baseBackend"));

var _httpBackend = _interopRequireDefault(require("./httpBackend"));

var _kitooBackend = _interopRequireDefault(require("./kitooBackend"));

var _zeronodeBackend = _interopRequireDefault(require("./zeronodeBackend"));

var _mongoBackend = _interopRequireDefault(require("./mongoBackend"));

var _sequelizeBackend = _interopRequireDefault(require("./sequelizeBackend"));

var _processBackend = _interopRequireDefault(require("./processBackend"));

var _aerospikeBackend = _interopRequireDefault(require("./aerospikeBackend"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  BaseBackend: _baseBackend.default,
  HTTPBackend: _httpBackend.default,
  KitooBackend: _kitooBackend.default,
  ZeronodeBackend: _zeronodeBackend.default,
  MongoBackend: _mongoBackend.default,
  SequalizeBackend: _sequelizeBackend.default,
  ProcessBackend: _processBackend.default,
  AerospikeBackend: _aerospikeBackend.default
};
exports.default = _default;