"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _baseBackend = _interopRequireDefault(require("./baseBackend"));

var _enum = require("../enum");

var _requireLib = _interopRequireDefault(require("../utils/requireLib"));

var _helpers = require("../utils/helpers");

var _kitooError = _interopRequireDefault(require("../utils/kitooError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var KitooNetwork = null;
var ROUTES = ['create', 'loadById', 'loadByQuery', 'count', 'loadOne', 'loadAll', 'updateById', 'update', 'removeById', 'removeByQuery', 'runCommand', _enum.EntityAction.PING];

var KitooBackend =
/*#__PURE__*/
function (_BaseBackend) {
  _inherits(KitooBackend, _BaseBackend);

  function KitooBackend() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        router = _ref.router,
        id = _ref.id,
        tag = _ref.tag,
        name = _ref.name,
        _ref$entities = _ref.entities,
        entities = _ref$entities === void 0 ? [] : _ref$entities,
        rules = _ref.rules,
        config = _ref.config,
        masterKey = _ref.masterKey,
        initialStatus = _ref.initialStatus;

    _classCallCheck(this, KitooBackend);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(KitooBackend).call(this, {
      id: id,
      config: config,
      tag: tag,
      entities: entities,
      rules: rules,
      masterKey: masterKey
    }));
    _this.name = name;
    _this.router = router;
    _this.kitooNetwork = null;
    _this.__initialStatus = initialStatus || _enum.NODE_STATUSES.STARTED;
    return _this;
  }

  _createClass(KitooBackend, [{
    key: "getDefaultFilters",
    value: function getDefaultFilters() {
      return {
        __status: {
          $eq: _enum.NODE_STATUSES.STARTED
        }
      };
    }
  }, {
    key: "setStatus",
    value: function setStatus(status) {
      var node = this.kitooNetwork.node;
      return node.setOptions(_objectSpread({}, node.getOptions(), {
        __status: status
      }));
    }
  }, {
    key: "addRoute",
    value: function addRoute(_ref2) {
      var _this2 = this;

      var action = _ref2.action;

      if (action === _enum.EntityAction.FETCH_ENTITIES) {
        this.kitooNetwork.onTick(_enum.EntityAction.FETCH_ENTITIES, function (_ref3) {
          var event = _ref3.event,
              token = _ref3.token;

          _this2.transport.emit(_enum.TransportEvent.TRANSPORT_REQUEST, {
            headers: {
              action: action,
              token: token
            },
            payload: {}
          }, {
            json: function json(response) {
              _this2.kitooNetwork.proxyTickAll({
                event: event,
                data: response,
                filter: _this2.getDefaultFilters()
              });
            }
          });
        });
        return;
      }

      if (action === _enum.EntityAction.DEFINE_RULE || action === _enum.EntityAction.REMOVE_RULE) {
        this.kitooNetwork.onTick(action, function (body) {
          _this2.transport.emit(_enum.TransportEvent.TRANSPORT_REQUEST, body, {
            json: function json() {}
          });
        });
        return;
      }

      if (action === _enum.EntityAction.PING) {
        return this.kitooNetwork.onRequest(action, function (_ref4) {
          var body = _ref4.body,
              reply = _ref4.reply;
          return reply();
        });
      }

      this.kitooNetwork.onRequest(action, function (req) {
        var body = req.body,
            reply = req.reply;

        _this2.transport.emit(_enum.TransportEvent.TRANSPORT_REQUEST, body, {
          json: reply
        });
      });
    }
  }, {
    key: "parseRequest",
    value: function parseRequest(req, res, next) {
      var _get$call = _get(_getPrototypeOf(KitooBackend.prototype), "parseRequest", this).call(this, req, req.headers.token),
          auth = _get$call.auth;

      return {
        action: req.headers.action,
        collection: req.headers.collection,
        payload: req.payload,
        token: req.headers.token,
        tag: req.headers.tag,
        auth: auth
      };
    }
  }, {
    key: "bind",
    value: function () {
      var _bind = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _this3 = this;

        var entities, options;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                entities = _lodash.default.map(this.entities, function (entity) {
                  return "".concat(entity.tag, ":").concat(entity.collection);
                });

                if (this.transport.getClient()) {
                  _context.next = 7;
                  break;
                }

                if (!KitooNetwork) KitooNetwork = (0, _requireLib.default)('kitoo-core').Network;
                this.kitooNetwork = new KitooNetwork({
                  id: this.id,
                  name: this.name,
                  router: this.router,
                  config: this.config,
                  options: {
                    entities: entities,
                    backend: true,
                    __status: this.__initialStatus
                  }
                });
                this.kitooNetwork.node.on('error', _kitooError.default);
                _context.next = 14;
                break;

              case 7:
                this.kitooNetwork = this.transport.getClient().kitooNetwork;
                options = this.kitooNetwork.node.getOptions();
                options.entities = [].concat(_toConsumableArray(options.entities), _toConsumableArray(entities));
                options.backend = true;
                options.__status = this.__initialStatus;
                _context.next = 14;
                return this.kitooNetwork.node.setOptions(options);

              case 14:
                _context.next = 16;
                return this.kitooNetwork.start();

              case 16:
                _context.next = 18;
                return _get(_getPrototypeOf(KitooBackend.prototype), "bind", this).call(this);

              case 18:
                _lodash.default.each(ROUTES, function (action) {
                  return _this3.addRoute({
                    action: action
                  });
                });

              case 19:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function bind() {
        return _bind.apply(this, arguments);
      }

      return bind;
    }()
  }, {
    key: "registerEntity",
    value: function () {
      var _registerEntity = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(entities) {
        var nodeOptions;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _get(_getPrototypeOf(KitooBackend.prototype), "registerEntity", this).call(this, entities);

                nodeOptions = this.kitooNetwork.node.getOptions();
                nodeOptions.entities = _lodash.default.map(this.entities, function (entity) {
                  return "".concat(entity.tag, ":").concat(entity.collection);
                });
                _context2.next = 5;
                return this.kitooNetwork.node.setOptions(nodeOptions);

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function registerEntity(_x) {
        return _registerEntity.apply(this, arguments);
      }

      return registerEntity;
    }()
  }, {
    key: "reinitializeWatchClients",
    value: function reinitializeWatchClients() {
      try {
        this.kitooNetwork.proxyTickAll({
          event: _enum.TransportEvent.REINITIALIZE_WATCH,
          filter: this.getDefaultFilters()
        });
      } catch (err) {}
    }
  }, {
    key: "startWatch",
    value: function () {
      var _startWatch = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3() {
        var _this4 = this;

        var options;
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (this.kitooNetwork) {
                  _context3.next = 2;
                  break;
                }

                throw new Error('Need to bind backend before enabling watch.');

              case 2:
                if (!this.watch) {
                  _context3.next = 4;
                  break;
                }

                return _context3.abrupt("return");

              case 4:
                _get(_getPrototypeOf(KitooBackend.prototype), "startWatch", this).call(this);

                this.kitooNetwork.onTick(_enum.TransportEvent.WATCH_REQUEST, function (_ref5, _ref6) {
                  var tag = _ref5.tag,
                      collection = _ref5.collection,
                      entityId = _ref5.entityId,
                      filter = _ref5.filter;
                  var id = _ref6.id;

                  _this4.handleWatchrequest({
                    id: id,
                    tag: tag,
                    collection: collection,
                    entityId: entityId,
                    filter: filter
                  });
                });
                this.kitooNetwork.onTick(_enum.TransportEvent.UNWATCH_REQUEST, function (_ref7, _ref8) {
                  var tag = _ref7.tag,
                      collection = _ref7.collection,
                      entityId = _ref7.entityId,
                      filter = _ref7.filter;
                  var id = _ref8.id;

                  _this4.handleUnwatchrequest({
                    id: id,
                    tag: tag,
                    collection: collection,
                    entityId: entityId,
                    filter: filter
                  });
                });
                options = this.kitooNetwork.node.getOptions();
                options.watchEnabled = true;
                _context3.next = 11;
                return this.kitooNetwork.node.setOptions(options);

              case 11:
                this.reinitializeWatchClients();

              case 12:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function startWatch() {
        return _startWatch.apply(this, arguments);
      }

      return startWatch;
    }()
  }, {
    key: "emitWatch",
    value: function emitWatch() {
      var _this5 = this;

      var _ref9 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          action = _ref9.action,
          _ref9$data = _ref9.data,
          data = _ref9$data === void 0 ? {} : _ref9$data,
          collection = _ref9.collection,
          tag = _ref9.tag,
          _ref9$all = _ref9.all,
          all = _ref9$all === void 0 ? false : _ref9$all;

      var proxyRules = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      if (!this.watch) {
        throw new Error('Need to start Watch, before emitting');
      }

      var entity = _lodash.default.find(this.entities, function (ent) {
        return ent.collection === collection && ent.tag === tag;
      });

      var _this$getAllWatchIds = this.getAllWatchIds({
        data: data,
        tag: tag,
        collection: collection,
        idField: _lodash.default.get(entity, 'idField')
      }),
          allSockets = _this$getAllWatchIds.allSockets;

      var watchFilter = !all ? {
        $containsAny: [_enum.ALL_COLLECTIONS, "".concat(tag, ":").concat(collection), "".concat(tag, ":").concat(collection, ":").concat(data[entity.idField])]
      } : undefined;

      try {
        this.kitooNetwork.proxyTickAll({
          event: _enum.TransportEvent.WATCH_RESPONSE,
          data: {
            action: action,
            data: data,
            collection: collection,
            tag: tag
          },
          filter: _objectSpread({}, this.getDefaultFilters(), {
            watch: watchFilter,
            _id: {
              $in: allSockets
            },
            token: function token(_token) {
              try {
                if (_token === _this5.masterKey) return true;
                if (!_this5.checkAuth({
                  token: _token
                })) return false;

                var myRules = _this5.getRules({
                  collection: collection,
                  tag: tag
                });

                var rules = [].concat(_toConsumableArray(myRules), [proxyRules]);
                if (!rules.length) return true;
                return !!_lodash.default.find(rules, function (rule) {
                  // TODO:: here data is not full data (discuss what to do here)
                  return (0, _helpers.checkRule)({
                    collection: collection,
                    tag: tag,
                    data: data,
                    auth: _this5.decoded({
                      token: _token
                    }),
                    rule: rule.read
                  });
                });
              } catch (err) {
                return false;
              }
            }
          })
        });
      } catch (e) {// No backends watching
      }
    }
  }]);

  return KitooBackend;
}(_baseBackend.default);

exports.default = KitooBackend;