"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _mongoose = _interopRequireDefault(require("mongoose"));

var _mongomanager = require("@sfast/mongomanager");

var _enum = require("../enum");

var _helpers = require("../utils/helpers");

var _stringToDate = _interopRequireDefault(require("../utils/stringToDate"));

var _processBackend = _interopRequireDefault(require("./processBackend"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var MongoBackend =
/*#__PURE__*/
function (_ProcessBackend) {
  _inherits(MongoBackend, _ProcessBackend);

  function MongoBackend() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        manager = _ref.manager,
        id = _ref.id,
        config = _ref.config,
        entities = _ref.entities,
        url = _ref.url,
        options = _ref.options,
        _ref$tag = _ref.tag,
        tag = _ref$tag === void 0 ? 'wirentity' : _ref$tag,
        rules = _ref.rules,
        masterKey = _ref.masterKey;

    _classCallCheck(this, MongoBackend);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(MongoBackend).call(this, {
      id: id,
      config: config,
      tag: tag,
      rules: rules,
      masterKey: masterKey
    }));
    _this.manager = manager || new _mongomanager.MongoManager(options);
    _this.url = url;
    _this.proxy = _this.proxy.bind(_assertThisInitialized(_this));

    _this.registerEntity(entities);

    return _this;
  }

  _createClass(MongoBackend, [{
    key: "bind",
    value: function () {
      var _bind = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var _this2 = this;

        var id, url;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return _get(_getPrototypeOf(MongoBackend.prototype), "bind", this).call(this);

              case 2:
                id = this.id, url = this.url; // ** adding the root middleware

                this.use(
                /*#__PURE__*/
                function () {
                  var _ref2 = _asyncToGenerator(
                  /*#__PURE__*/
                  _regenerator.default.mark(function _callee(req, res, next) {
                    var _this2$parseRequest, action, collection, payload, auth, tag, actionHandler, responseSent, result;

                    return _regenerator.default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _this2$parseRequest = _this2.parseRequest(req), action = _this2$parseRequest.action, collection = _this2$parseRequest.collection, payload = _this2$parseRequest.payload, auth = _this2$parseRequest.auth, tag = _this2$parseRequest.tag; // ** console.log(`AVAR::MONGOBACKEND::MIDDLEWARE::1  ${action} ${collection} payload = `, payload)

                            _context.t0 = action;
                            _context.next = _context.t0 === _enum.EntityAction.AUTH ? 4 : _context.t0 === _enum.EntityAction.FETCH_ENTITIES ? 4 : _context.t0 === _enum.EntityAction.DEFINE_RULE ? 4 : _context.t0 === _enum.EntityAction.REMOVE_RULE ? 4 : _context.t0 === _enum.EntityAction.GET_RULES ? 4 : 5;
                            break;

                          case 4:
                            return _context.abrupt("return", next());

                          case 5:
                            if (!(tag !== _this2.tag)) {
                              _context.next = 7;
                              break;
                            }

                            return _context.abrupt("return", next());

                          case 7:
                            actionHandler = _this2[action];

                            if (actionHandler) {
                              _context.next = 10;
                              break;
                            }

                            return _context.abrupt("return", res.error(new Error("Handler for action ".concat(action, " is not defined"))));

                          case 10:
                            responseSent = false;
                            _context.prev = 11;
                            _context.next = 14;
                            return actionHandler.call(_this2, collection, payload, auth, function (err) {
                              responseSent = true;
                              next(err);
                            });

                          case 14:
                            result = _context.sent;
                            !responseSent && res.json(result);
                            _context.next = 22;
                            break;

                          case 18:
                            _context.prev = 18;
                            _context.t1 = _context["catch"](11);
                            console.error(_context.t1);
                            next(_context.t1);

                          case 22:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, null, [[11, 18]]);
                  }));

                  return function (_x, _x2, _x3) {
                    return _ref2.apply(this, arguments);
                  };
                }());
                _context2.next = 6;
                return this.manager.connect({
                  id: id,
                  url: url,
                  config: {
                    useNewUrlParser: true
                  }
                });

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function bind() {
        return _bind.apply(this, arguments);
      }

      return bind;
    }()
  }, {
    key: "registerEntity",
    value: function registerEntity(entities) {
      var _this3 = this;

      entities = _lodash.default.isArray(entities) ? entities : [entities];

      _lodash.default.each(entities, function (entity) {
        var schema = entity.schema,
            collection = entity.collection,
            idField = entity.idField,
            label = entity.label;

        var entitySchema = _lodash.default.mapValues(schema.tree, function (value) {
          switch (value) {
            case _mongoose.default.Types.ObjectId:
            case String:
              return 'string';

            case _mongoose.default.Types.Decimal128:
            case Number:
              return 'number';

            case Date:
              return 'date';

            case Buffer:
              return 'buffer';

            case Boolean:
              return 'boolean';

            case _mongoose.default.Types.Mixed:
              return 'mixed';

            case Array:
              return 'array';
          }

          if (_lodash.default.isObject(value) && value.type) {
            switch (value.type) {
              case _mongoose.default.Types.ObjectId:
              case String:
                return 'string';

              case _mongoose.default.Types.Decimal128:
              case Number:
                return 'number';

              case Date:
                return 'date';

              case Buffer:
                return 'buffer';

              case Boolean:
                return 'boolean';

              case _mongoose.default.Types.Mixed:
                return 'mixed';

              case Array:
                return 'array';
            }
          }

          if (_lodash.default.isObject(value) && _lodash.default.isEmpty(value)) return 'object';
          if (_lodash.default.isArray(value)) return 'array';
          return 'mixed';
        });

        _this3.manager.registerSchema({
          schema: schema,
          name: collection,
          pk: idField,
          label: label
        });

        _get(_getPrototypeOf(MongoBackend.prototype), "registerEntity", _this3).call(_this3, {
          collection: collection,
          idField: idField,
          schema: entitySchema
        });
      });
    }
  }, {
    key: "getModel",
    value: function getModel(collection) {
      var model = this.manager.getModel(this.id, collection);
      if (!model) throw new Error("No model exists for colection '".concat(collection, "' "));
      return model;
    }
  }, {
    key: "create",
    value: function () {
      var _create = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(collection) {
        var payload,
            auth,
            next,
            _ref3,
            status,
            _args3 = arguments;

        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                payload = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
                auth = _args3.length > 2 ? _args3[2] : undefined;
                next = _args3.length > 3 ? _args3[3] : undefined;
                _context3.next = 5;
                return this.checkPermission({
                  action: _enum.EntityAction.CREATE,
                  collection: collection,
                  newData: payload,
                  op: _enum.WRITE,
                  auth: auth
                });

              case 5:
                _ref3 = _context3.sent;
                status = _ref3.status;

                if (status) {
                  _context3.next = 9;
                  break;
                }

                return _context3.abrupt("return", next({
                  message: 'Forbidden.',
                  status: 403
                }));

              case 9:
                return _context3.abrupt("return", this.getModel(collection).create(payload));

              case 10:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function create(_x4) {
        return _create.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: "updateById",
    value: function () {
      var _updateById = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4(collection) {
        var payload,
            auth,
            next,
            query,
            update,
            id,
            Model,
            pkName,
            _args4 = arguments;
        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                payload = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : {};
                auth = _args4.length > 2 ? _args4[2] : undefined;
                next = _args4.length > 3 ? _args4[3] : undefined;
                query = payload.query, update = payload.update;
                id = query.id;
                Model = this.getModel(collection);
                pkName = Model.getPrimaryKeyName();
                _context4.next = 9;
                return this.update(collection, {
                  query: _defineProperty({}, pkName, id),
                  update: update
                }, auth, next);

              case 9:
                return _context4.abrupt("return", this.loadById(collection, {
                  query: query
                }, auth, next));

              case 10:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function updateById(_x5) {
        return _updateById.apply(this, arguments);
      }

      return updateById;
    }()
  }, {
    key: "update",
    value: function () {
      var _update = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5(collection) {
        var payload,
            auth,
            next,
            query,
            update,
            Model,
            pkName,
            _ref4,
            status,
            data,
            ids,
            _args5 = arguments;

        return _regenerator.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                payload = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : {};
                auth = _args5.length > 2 ? _args5[2] : undefined;
                next = _args5.length > 3 ? _args5[3] : undefined;
                query = payload.query, update = payload.update;
                Model = this.getModel(collection);
                pkName = Model.getPrimaryKeyName();
                _context5.next = 8;
                return this.checkPermission({
                  action: _enum.EntityAction.UPDATE,
                  collection: collection,
                  newData: update,
                  op: _enum.WRITE,
                  auth: auth,
                  query: query
                });

              case 8:
                _ref4 = _context5.sent;
                status = _ref4.status;
                data = _ref4.data;

                if (status) {
                  _context5.next = 13;
                  break;
                }

                return _context5.abrupt("return", next({
                  message: 'Forbidden.',
                  status: 403
                }));

              case 13:
                if (data.length) {
                  _context5.next = 15;
                  break;
                }

                return _context5.abrupt("return", next({
                  message: 'Not Found.',
                  status: 404
                }));

              case 15:
                ids = _lodash.default.map(data, function (row) {
                  return row[pkName];
                });
                return _context5.abrupt("return", this.getModel(collection).updateMany(_defineProperty({}, pkName, {
                  $in: ids
                }), update));

              case 17:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function update(_x6) {
        return _update.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "removeById",
    value: function () {
      var _removeById = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee6(collection) {
        var payload,
            auth,
            next,
            query,
            id,
            Model,
            pkName,
            removeQuery,
            _args6 = arguments;
        return _regenerator.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                payload = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : {};
                auth = _args6.length > 2 ? _args6[2] : undefined;
                next = _args6.length > 3 ? _args6[3] : undefined;
                query = payload.query;
                id = query.id;
                Model = this.getModel(collection);
                pkName = Model.getPrimaryKeyName();
                removeQuery = _lodash.default.isArray(id) ? _defineProperty({}, pkName, {
                  $in: id
                }) : _defineProperty({}, pkName, id);
                return _context6.abrupt("return", this.removeByQuery(collection, {
                  query: removeQuery
                }, auth, next));

              case 9:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function removeById(_x7) {
        return _removeById.apply(this, arguments);
      }

      return removeById;
    }()
  }, {
    key: "removeByQuery",
    value: function () {
      var _removeByQuery = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee7(collection) {
        var payload,
            auth,
            next,
            _payload$query,
            query,
            _ref7,
            status,
            data,
            _args7 = arguments;

        return _regenerator.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                payload = _args7.length > 1 && _args7[1] !== undefined ? _args7[1] : {};
                auth = _args7.length > 2 ? _args7[2] : undefined;
                next = _args7.length > 3 ? _args7[3] : undefined;
                _payload$query = payload.query, query = _payload$query === void 0 ? {} : _payload$query;
                _context7.next = 6;
                return this.checkPermission({
                  action: _enum.EntityAction.REMOVE_BY_QUERY,
                  collection: collection,
                  newData: null,
                  op: _enum.WRITE,
                  auth: auth,
                  query: query
                });

              case 6:
                _ref7 = _context7.sent;
                status = _ref7.status;
                data = _ref7.data;

                if (status) {
                  _context7.next = 11;
                  break;
                }

                return _context7.abrupt("return", next({
                  message: 'Forbidden.',
                  status: 403
                }));

              case 11:
                return _context7.abrupt("return", Promise.all(_lodash.default.map(data, function (row) {
                  return row.remove();
                })));

              case 12:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function removeByQuery(_x8) {
        return _removeByQuery.apply(this, arguments);
      }

      return removeByQuery;
    }()
  }, {
    key: "loadById",
    value: function () {
      var _loadById = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee8(collection) {
        var payload,
            auth,
            next,
            query,
            select,
            id,
            selectArray,
            idArray,
            Model,
            pkName,
            _ref8,
            status,
            data,
            _args8 = arguments;

        return _regenerator.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                payload = _args8.length > 1 && _args8[1] !== undefined ? _args8[1] : {};
                auth = _args8.length > 2 ? _args8[2] : undefined;
                next = _args8.length > 3 ? _args8[3] : undefined;
                query = payload.query, select = payload.select;
                id = query.id; // ** NOTE::AVAR creating {prop1:1, prop2:1} like object

                selectArray = _lodash.default.isArray(select) ? select : _lodash.default.isString(select) ? [select] : null;
                idArray = _lodash.default.isArray(id) ? id.slice(0, 1) : [id];
                Model = this.getModel(collection);
                pkName = Model.getPrimaryKeyName();
                _context8.next = 11;
                return this.checkPermission({
                  action: _enum.EntityAction.LOAD_BY_ID,
                  collection: collection,
                  op: _enum.READ,
                  query: _defineProperty({}, pkName, {
                    $in: idArray
                  }),
                  select: selectArray,
                  auth: auth
                });

              case 11:
                _ref8 = _context8.sent;
                status = _ref8.status;
                data = _ref8.data;

                if (status) {
                  _context8.next = 16;
                  break;
                }

                return _context8.abrupt("return", next({
                  message: 'Forbidden.',
                  status: 403
                }));

              case 16:
                if (!(idArray.length === 1 && data.length < 1)) {
                  _context8.next = 18;
                  break;
                }

                return _context8.abrupt("return", next({
                  message: 'Not Found.',
                  status: 404
                }));

              case 18:
                return _context8.abrupt("return", idArray.length === 1 ? data[0] : data);

              case 19:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function loadById(_x9) {
        return _loadById.apply(this, arguments);
      }

      return loadById;
    }()
  }, {
    key: "loadAll",
    value: function () {
      var _loadAll = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee9(collection) {
        var payload,
            auth,
            next,
            select,
            _ref9,
            data,
            status,
            _args9 = arguments;

        return _regenerator.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                payload = _args9.length > 1 && _args9[1] !== undefined ? _args9[1] : {};
                auth = _args9.length > 2 ? _args9[2] : undefined;
                next = _args9.length > 3 ? _args9[3] : undefined;
                select = payload.select;
                _context9.next = 6;
                return this.loadByQuery(collection, {
                  select: select,
                  query: {}
                }, auth, next, _enum.EntityAction.LOAD_ALL);

              case 6:
                _ref9 = _context9.sent;
                data = _ref9.data;
                status = _ref9.status;
                return _context9.abrupt("return", status ? data : null);

              case 10:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function loadAll(_x10) {
        return _loadAll.apply(this, arguments);
      }

      return loadAll;
    }()
  }, {
    key: "loadByQuery",
    value: function () {
      var _loadByQuery = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee10(collection) {
        var payload,
            auth,
            next,
            action,
            _payload$query2,
            query,
            select,
            limit,
            skip,
            sort,
            selectArray,
            _ref10,
            data,
            status,
            _args10 = arguments;

        return _regenerator.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                payload = _args10.length > 1 && _args10[1] !== undefined ? _args10[1] : {};
                auth = _args10.length > 2 ? _args10[2] : undefined;
                next = _args10.length > 3 ? _args10[3] : undefined;
                action = _args10.length > 4 && _args10[4] !== undefined ? _args10[4] : _enum.EntityAction.LOAD_BY_QUERY;
                _payload$query2 = payload.query, query = _payload$query2 === void 0 ? {} : _payload$query2, select = payload.select, limit = payload.limit, skip = payload.skip, sort = payload.sort; // ** NOTE::AVAR creating {prop1:1, prop2:1} like object

                selectArray = _lodash.default.isArray(select) ? select : _lodash.default.isString(select) ? [select] : null;
                _context10.next = 8;
                return this.checkPermission({
                  action: action,
                  collection: collection,
                  op: _enum.READ,
                  query: query,
                  select: selectArray,
                  auth: auth,
                  limit: limit,
                  skip: skip,
                  sort: sort
                });

              case 8:
                _ref10 = _context10.sent;
                data = _ref10.data;
                status = _ref10.status;
                if (!status) next({
                  message: 'Forbidden.',
                  status: 403
                });
                return _context10.abrupt("return", action === _enum.EntityAction.LOAD_BY_QUERY ? data : {
                  data: data,
                  status: status
                });

              case 13:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function loadByQuery(_x11) {
        return _loadByQuery.apply(this, arguments);
      }

      return loadByQuery;
    }()
  }, {
    key: "count",
    value: function count(collection) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var auth = arguments.length > 2 ? arguments[2] : undefined;
      var query = payload.query;
      var model = this.getModel(collection);
      if (_lodash.default.isEmpty(query)) return model.estimatedDocumentCount();
      return model.countDocuments(query || {});
    }
  }, {
    key: "loadOne",
    value: function () {
      var _loadOne = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee11(collection) {
        var payload,
            auth,
            next,
            _ref11,
            data,
            status,
            _args11 = arguments;

        return _regenerator.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                payload = _args11.length > 1 && _args11[1] !== undefined ? _args11[1] : {};
                auth = _args11.length > 2 ? _args11[2] : undefined;
                next = _args11.length > 3 ? _args11[3] : undefined;
                _context11.next = 5;
                return this.loadByQuery(collection, _objectSpread({}, payload, {
                  limit: 1
                }), auth, next, _enum.EntityAction.LOAD_ONE);

              case 5:
                _ref11 = _context11.sent;
                data = _ref11.data;
                status = _ref11.status;
                return _context11.abrupt("return", status ? data[0] : null);

              case 9:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function loadOne(_x12) {
        return _loadOne.apply(this, arguments);
      }

      return loadOne;
    }()
  }, {
    key: "findAndModify",
    value: function () {
      var _findAndModify = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee12(collection, data) {
        return _regenerator.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                return _context12.abrupt("return", this.getModel(collection).findOneAndUpdate(data.query, data.update, data.options));

              case 1:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function findAndModify(_x13, _x14) {
        return _findAndModify.apply(this, arguments);
      }

      return findAndModify;
    }()
  }, {
    key: "replaceOne",
    value: function () {
      var _replaceOne = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee13(collection, data) {
        return _regenerator.default.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                return _context13.abrupt("return", this.getModel(collection).replaceOne(data.query, data.replacement, data.options));

              case 1:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function replaceOne(_x15, _x16) {
        return _replaceOne.apply(this, arguments);
      }

      return replaceOne;
    }()
  }, {
    key: "aggregate",
    value: function aggregate(collection, aggregation) {
      // TODO:: check permissions
      return this.getModel(collection).aggregate((0, _stringToDate.default)(aggregation));
    }
  }, {
    key: "runCommand",
    value: function runCommand(collection, payload) {
      var command = payload.command,
          data = payload.data;

      switch (command) {
        case 'aggregate':
          return this.aggregate(collection, data);

        case 'findAndModify':
          return this.findAndModify(collection, data);

        case 'replaceOne ':
          return this.replaceOne(collection, data);

        default:
          return null;
      }
    }
  }, {
    key: "checkPermission",
    value: function () {
      var _checkPermission = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee14(_ref12) {
        var _this4 = this;

        var action, collection, newData, auth, query, _ref12$op, op, _ref12$select, select, _ref12$limit, limit, _ref12$skip, skip, _ref12$sort, sort, rules, entity, data, shouldNotGetData, status, pickAttributes, responseData;

        return _regenerator.default.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                action = _ref12.action, collection = _ref12.collection, newData = _ref12.newData, auth = _ref12.auth, query = _ref12.query, _ref12$op = _ref12.op, op = _ref12$op === void 0 ? _enum.READ : _ref12$op, _ref12$select = _ref12.select, select = _ref12$select === void 0 ? null : _ref12$select, _ref12$limit = _ref12.limit, limit = _ref12$limit === void 0 ? Number.MAX_SAFE_INTEGER : _ref12$limit, _ref12$skip = _ref12.skip, skip = _ref12$skip === void 0 ? 0 : _ref12$skip, _ref12$sort = _ref12.sort, sort = _ref12$sort === void 0 ? {} : _ref12$sort;
                rules = this.getMyRules({
                  collection: collection
                });
                entity = this.getEntity({
                  collection: collection,
                  tag: this.tag
                });
                data = null;

                if (op !== _enum.READ) {
                  op = _enum.WRITE;
                }

                shouldNotGetData = (0, _helpers.rulesDontNeedData)(rules, op);
                status = !!_lodash.default.find(rules, function (rule) {
                  return (0, _helpers.checkRule)({
                    newData: newData,
                    rule: rule[op],
                    auth: auth,
                    collection: collection,
                    tag: _this4.tag,
                    action: action
                  });
                });

                if (!(shouldNotGetData && !status)) {
                  _context14.next = 9;
                  break;
                }

                return _context14.abrupt("return", {
                  status: status
                });

              case 9:
                if (!query) {
                  _context14.next = 15;
                  break;
                }

                _context14.next = 12;
                return this.getModel(collection).find(query).limit(limit).skip(skip).sort(sort);

              case 12:
                data = _context14.sent;

                if (data.length) {
                  _context14.next = 15;
                  break;
                }

                return _context14.abrupt("return", {
                  status: true,
                  data: []
                });

              case 15:
                if (!(!rules.length || auth.masterKey === this.masterKey)) {
                  _context14.next = 19;
                  break;
                }

                pickAttributes = _lodash.default.get(select, 'length') ? select : [];
                responseData = data && pickAttributes.length ? data.map(function (elem) {
                  return _lodash.default.pick(elem, pickAttributes);
                }) : data;
                return _context14.abrupt("return", {
                  status: true,
                  data: responseData || []
                });

              case 19:
                if (!data) {
                  _context14.next = 21;
                  break;
                }

                return _context14.abrupt("return", (0, _helpers.checkPermissionWithData)({
                  data: data,
                  newData: newData,
                  action: action,
                  op: op,
                  schema: entity.schema,
                  auth: auth,
                  collection: collection,
                  rules: rules,
                  tag: this.tag,
                  select: select ? Object.keys(select) : null
                }));

              case 21:
                return _context14.abrupt("return", {
                  status: status
                });

              case 22:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function checkPermission(_x17) {
        return _checkPermission.apply(this, arguments);
      }

      return checkPermission;
    }()
  }]);

  return MongoBackend;
}(_processBackend.default);

exports.default = MongoBackend;