"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _baseBackend = _interopRequireDefault(require("./baseBackend"));

var _enum = require("../enum");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ProcessBackend =
/*#__PURE__*/
function (_BaseBackend) {
  _inherits(ProcessBackend, _BaseBackend);

  function ProcessBackend() {
    _classCallCheck(this, ProcessBackend);

    return _possibleConstructorReturn(this, _getPrototypeOf(ProcessBackend).apply(this, arguments));
  }

  _createClass(ProcessBackend, [{
    key: "parseRequest",
    value: function parseRequest(req) {
      return Object.assign(req.inProcessBody, {
        token: req.headers.token
      }, _get(_getPrototypeOf(ProcessBackend.prototype), "parseRequest", this).call(this, req.inProcessBody, req.headers.token));
    }
  }, {
    key: "startWatch",
    value: function startWatch() {
      _get(_getPrototypeOf(ProcessBackend.prototype), "startWatch", this).call(this);

      this.on(_enum.TransportEvent.WATCH_REQUEST, this.handleWatchrequest);
      this.on(_enum.TransportEvent.UNWATCH_REQUEST, this.handleUnwatchrequest);
    }
  }, {
    key: "emitWatch",
    value: function emitWatch() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          action = _ref.action,
          data = _ref.data,
          collection = _ref.collection,
          tag = _ref.tag,
          _ref$all = _ref.all,
          all = _ref$all === void 0 ? false : _ref$all;

      if (all) return this.emit(_enum.TransportEvent.WATCH_RESPONSE, {
        action: action,
        data: data,
        collection: collection,
        tag: tag
      });

      if (!collection || !tag) {
        throw new Error('must depcify collection while emiiting watch event');
      }

      var allCollectionWatchers = this.watchMap.get(_enum.ALL_COLLECTIONS);

      if (allCollectionWatchers && allCollectionWatchers.size) {
        return this.emit(_enum.TransportEvent.WATCH_RESPONSE, {
          action: action,
          data: data,
          collection: collection,
          tag: tag
        });
      }

      var collectionWatchers = this.watchMap.get("".concat(tag, ":").concat(collection));

      if (collectionWatchers && collectionWatchers.size) {
        return this.emit(_enum.TransportEvent.WATCH_RESPONSE, {
          action: action,
          data: data,
          collection: collection,
          tag: tag
        });
      }

      var entity = this.getEntity({
        collection: collection,
        tag: tag
      });
      if (!entity) return;
      var entityWatchers = this.watchMap.get("".concat(tag, ":").concat(collection, ":").concat(data[entity.idField]));

      if (entityWatchers && entityWatchers.size) {
        this.emit(_enum.TransportEvent.WATCH_RESPONSE, {
          action: action,
          data: data,
          collection: collection,
          tag: tag
        });
      }
    }
  }, {
    key: "errorHandler",
    value: function errorHandler(req, res, error) {
      res.error(error);
    }
  }]);

  return ProcessBackend;
}(_baseBackend.default);

exports.default = ProcessBackend;