"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _enum = require("../enum");

var _requireLib = _interopRequireDefault(require("../utils/requireLib"));

var _processBackend = _interopRequireDefault(require("./processBackend"));

var _addMissingColumns = _interopRequireDefault(require("../utils/addMissingColumns"));

var _createDatabase = _interopRequireDefault(require("../utils/createDatabase"));

var _makePostgresQuery = _interopRequireDefault(require("../utils/makePostgresQuery"));

var _helpers = require("../utils/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var Sequelize = null;
var _privateInterface = {
  create: create,
  loadById: loadById,
  loadAll: loadAll,
  loadByQuery: loadByQuery,
  count: count,
  loadOne: loadOne,
  updateById: updateById,
  update: update,
  removeById: removeById,
  removeByQuery: removeByQuery,
  runCommand: runCommand
};
var forbiddenError = {
  message: 'Forbidden.',
  status: 403
};
var internalError = {
  message: 'Internal Server Error',
  status: 500
}; // ** NOTE::AVAR BACKEND actions to override

function create(_x) {
  return _create.apply(this, arguments);
}

function _create() {
  _create = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee5(collection) {
    var payload,
        auth,
        next,
        _ref5,
        status,
        response,
        _args5 = arguments;

    return _regenerator.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            payload = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : {};
            auth = _args5.length > 2 ? _args5[2] : undefined;
            next = _args5.length > 3 ? _args5[3] : undefined;
            _context5.next = 5;
            return this.checkPermission({
              collection: collection,
              newData: payload,
              auth: auth,
              op: _enum.WRITE,
              action: _enum.EntityAction.CREATE
            });

          case 5:
            _ref5 = _context5.sent;
            status = _ref5.status;

            if (status) {
              _context5.next = 9;
              break;
            }

            return _context5.abrupt("return", next(forbiddenError));

          case 9:
            _context5.next = 11;
            return this.getModel(collection).model.create(payload);

          case 11:
            response = _context5.sent;
            return _context5.abrupt("return", response ? response.toJSON() : null);

          case 13:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));
  return _create.apply(this, arguments);
}

function updateById(_x2) {
  return _updateById.apply(this, arguments);
}

function _updateById() {
  _updateById = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee6(collection) {
    var payload,
        auth,
        next,
        query,
        update,
        id,
        _args6 = arguments;
    return _regenerator.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            payload = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : {};
            auth = _args6.length > 2 ? _args6[2] : undefined;
            next = _args6.length > 3 ? _args6[3] : undefined;
            query = payload.query, update = payload.update;
            id = query.id;
            _context6.next = 7;
            return _privateInterface.update.call(this, collection, {
              update: update,
              query: _defineProperty({}, this.getModel(collection).idField, id)
            }, auth, next);

          case 7:
            return _context6.abrupt("return", _privateInterface.loadById.call(this, collection, payload, auth, next));

          case 8:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));
  return _updateById.apply(this, arguments);
}

function update(_x3) {
  return _update.apply(this, arguments);
}

function _update() {
  _update = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee7(collection) {
    var payload,
        auth,
        next,
        query,
        update,
        _ref6,
        status,
        modelInfo,
        _args7 = arguments;

    return _regenerator.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            payload = _args7.length > 1 && _args7[1] !== undefined ? _args7[1] : {};
            auth = _args7.length > 2 ? _args7[2] : undefined;
            next = _args7.length > 3 ? _args7[3] : undefined;
            query = payload.query, update = payload.update;
            _context7.next = 6;
            return this.checkPermission({
              collection: collection,
              newData: update,
              query: query,
              auth: auth,
              op: _enum.WRITE,
              action: _enum.EntityAction.UPDATE
            });

          case 6:
            _ref6 = _context7.sent;
            status = _ref6.status;

            if (status) {
              _context7.next = 10;
              break;
            }

            return _context7.abrupt("return", next(forbiddenError));

          case 10:
            modelInfo = this.getModel(collection);
            _context7.next = 13;
            return modelInfo.model.update(update, {
              where: (0, _makePostgresQuery.default)(Sequelize, query)
            });

          case 13:
            return _context7.abrupt("return", _context7.sent);

          case 14:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));
  return _update.apply(this, arguments);
}

function removeById(collection) {
  var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var auth = arguments.length > 2 ? arguments[2] : undefined;
  var next = arguments.length > 3 ? arguments[3] : undefined;
  var query = payload.query;
  var id = query.id;
  var modelInfo = this.getModel(collection);
  return _privateInterface.removeByQuery.call(this, collection, {
    query: _defineProperty({}, modelInfo.idField, id)
  }, auth, next);
}

function removeByQuery(_x4) {
  return _removeByQuery.apply(this, arguments);
}

function _removeByQuery() {
  _removeByQuery = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee8(collection) {
    var payload,
        auth,
        next,
        _payload$query,
        query,
        modelInfo,
        _ref7,
        status,
        data,
        _args8 = arguments;

    return _regenerator.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            payload = _args8.length > 1 && _args8[1] !== undefined ? _args8[1] : {};
            auth = _args8.length > 2 ? _args8[2] : undefined;
            next = _args8.length > 3 ? _args8[3] : undefined;
            _payload$query = payload.query, query = _payload$query === void 0 ? {} : _payload$query;
            modelInfo = this.getModel(collection);
            _context8.next = 7;
            return this.checkPermission({
              collection: collection,
              query: query,
              auth: auth,
              op: _enum.WRITE,
              action: _enum.EntityAction.REMOVE_BY_QUERY
            });

          case 7:
            _ref7 = _context8.sent;
            status = _ref7.status;
            data = _ref7.data;

            if (status) {
              _context8.next = 12;
              break;
            }

            return _context8.abrupt("return", next(forbiddenError));

          case 12:
            _context8.next = 14;
            return modelInfo.model.destroy({
              where: (0, _makePostgresQuery.default)(Sequelize, query)
            });

          case 14:
            return _context8.abrupt("return", _context8.sent);

          case 15:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8, this);
  }));
  return _removeByQuery.apply(this, arguments);
}

function loadById(_x5) {
  return _loadById.apply(this, arguments);
}

function _loadById() {
  _loadById = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee9(collection) {
    var payload,
        auth,
        next,
        query,
        select,
        id,
        modelInfo,
        sqlQuery,
        _ref8,
        status,
        data,
        _args9 = arguments;

    return _regenerator.default.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            payload = _args9.length > 1 && _args9[1] !== undefined ? _args9[1] : {};
            auth = _args9.length > 2 ? _args9[2] : undefined;
            next = _args9.length > 3 ? _args9[3] : undefined;
            query = payload.query, select = payload.select;
            id = query.id;
            modelInfo = this.getModel(collection);
            sqlQuery = _defineProperty({}, modelInfo.idField, id);
            _context9.next = 9;
            return this.checkPermission({
              collection: collection,
              query: sqlQuery,
              auth: auth,
              attributes: select,
              action: _enum.EntityAction.LOAD_BY_ID,
              limit: 1
            });

          case 9:
            _ref8 = _context9.sent;
            status = _ref8.status;
            data = _ref8.data;

            if (status) {
              _context9.next = 14;
              break;
            }

            return _context9.abrupt("return", next(forbiddenError));

          case 14:
            return _context9.abrupt("return", data[0]);

          case 15:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9, this);
  }));
  return _loadById.apply(this, arguments);
}

function loadAll(_x6) {
  return _loadAll.apply(this, arguments);
}

function _loadAll() {
  _loadAll = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee10(collection) {
    var payload,
        auth,
        next,
        select,
        _args10 = arguments;
    return _regenerator.default.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            payload = _args10.length > 1 && _args10[1] !== undefined ? _args10[1] : {};
            auth = _args10.length > 2 ? _args10[2] : undefined;
            next = _args10.length > 3 ? _args10[3] : undefined;
            select = payload.select;
            return _context10.abrupt("return", _privateInterface.loadByQuery.call(this, collection, {
              select: select,
              query: {}
            }, auth, next));

          case 5:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10, this);
  }));
  return _loadAll.apply(this, arguments);
}

function loadByQuery(_x7) {
  return _loadByQuery.apply(this, arguments);
}

function _loadByQuery() {
  _loadByQuery = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee11(collection) {
    var payload,
        auth,
        next,
        _payload$query2,
        query,
        select,
        limit,
        skip,
        options,
        _ref9,
        status,
        data,
        _args11 = arguments;

    return _regenerator.default.wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            payload = _args11.length > 1 && _args11[1] !== undefined ? _args11[1] : {};
            auth = _args11.length > 2 ? _args11[2] : undefined;
            next = _args11.length > 3 ? _args11[3] : undefined;
            _payload$query2 = payload.query, query = _payload$query2 === void 0 ? {} : _payload$query2, select = payload.select, limit = payload.limit, skip = payload.skip, options = payload.options;
            _context11.next = 6;
            return this.checkPermission(_objectSpread({
              collection: collection,
              query: query,
              auth: auth,
              attributes: select,
              offset: skip,
              limit: limit
            }, options, {
              action: _enum.EntityAction.LOAD_BY_QUERY
            }));

          case 6:
            _ref9 = _context11.sent;
            status = _ref9.status;
            data = _ref9.data;

            if (status) {
              _context11.next = 11;
              break;
            }

            return _context11.abrupt("return", next(forbiddenError));

          case 11:
            return _context11.abrupt("return", data);

          case 12:
          case "end":
            return _context11.stop();
        }
      }
    }, _callee11, this);
  }));
  return _loadByQuery.apply(this, arguments);
}

function count(_x8) {
  return _count.apply(this, arguments);
}

function _count() {
  _count = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee12(collection) {
    var payload,
        auth,
        next,
        query,
        _ref10,
        status,
        _args12 = arguments;

    return _regenerator.default.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            payload = _args12.length > 1 && _args12[1] !== undefined ? _args12[1] : {};
            auth = _args12.length > 2 ? _args12[2] : undefined;
            next = _args12.length > 3 ? _args12[3] : undefined;
            query = payload.query;
            _context12.next = 6;
            return this.checkPermission({
              collection: collection,
              auth: auth,
              action: _enum.EntityAction.COUNT
            });

          case 6:
            _ref10 = _context12.sent;
            status = _ref10.status;

            if (status) {
              _context12.next = 10;
              break;
            }

            return _context12.abrupt("return", next(forbiddenError));

          case 10:
            return _context12.abrupt("return", this.getModel(collection).model.count({
              where: (0, _makePostgresQuery.default)(Sequelize, query) || {}
            }));

          case 11:
          case "end":
            return _context12.stop();
        }
      }
    }, _callee12, this);
  }));
  return _count.apply(this, arguments);
}

function loadOne(_x9) {
  return _loadOne.apply(this, arguments);
}

function _loadOne() {
  _loadOne = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee13(collection) {
    var payload,
        auth,
        next,
        _payload$query3,
        query,
        select,
        _ref11,
        status,
        data,
        _args13 = arguments;

    return _regenerator.default.wrap(function _callee13$(_context13) {
      while (1) {
        switch (_context13.prev = _context13.next) {
          case 0:
            payload = _args13.length > 1 && _args13[1] !== undefined ? _args13[1] : {};
            auth = _args13.length > 2 ? _args13[2] : undefined;
            next = _args13.length > 3 ? _args13[3] : undefined;
            _payload$query3 = payload.query, query = _payload$query3 === void 0 ? {} : _payload$query3, select = payload.select;
            _context13.next = 6;
            return this.checkPermission({
              collection: collection,
              query: query,
              auth: auth,
              attributes: select,
              action: _enum.EntityAction.LOAD_ONE,
              limit: 1
            });

          case 6:
            _ref11 = _context13.sent;
            status = _ref11.status;
            data = _ref11.data;

            if (status) {
              _context13.next = 11;
              break;
            }

            return _context13.abrupt("return", next(forbiddenError));

          case 11:
            return _context13.abrupt("return", data[0]);

          case 12:
          case "end":
            return _context13.stop();
        }
      }
    }, _callee13, this);
  }));
  return _loadOne.apply(this, arguments);
}

function runCommand(collection, payload) {
  // Dangerous function must be handled with middleware
  var command = payload.command,
      data = payload.data;
  var fn = this.getModel(collection).model[command];
  if (!_lodash.default.isFunction(fn)) throw new Error('No such method on model');
  return fn(data);
}

var SequelizeBackend =
/*#__PURE__*/
function (_ProcessBackend) {
  _inherits(SequelizeBackend, _ProcessBackend);

  function SequelizeBackend() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        id = _ref.id,
        client = _ref.client,
        entities = _ref.entities,
        options = _ref.options,
        config = _ref.config,
        rules = _ref.rules,
        masterKey = _ref.masterKey,
        _ref$tag = _ref.tag,
        tag = _ref$tag === void 0 ? 'wirentity' : _ref$tag;

    _classCallCheck(this, SequelizeBackend);

    Sequelize = (0, _requireLib.default)('sequelize');
    _this = _possibleConstructorReturn(this, _getPrototypeOf(SequelizeBackend).call(this, {
      id: id,
      config: config,
      tag: tag,
      rules: rules,
      masterKey: masterKey
    }));
    _this._options = _objectSpread({
      dialect: 'postgres'
    }, options);
    _this._models = new Map();
    _this.client = client || new Sequelize(options.db, options.username, options.password, _this._options);
    _this.proxy = _this.proxy.bind(_assertThisInitialized(_this));

    _this.registerEntity(entities);

    return _this;
  }

  _createClass(SequelizeBackend, [{
    key: "bind",
    value: function () {
      var _bind = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var _this2 = this;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return _get(_getPrototypeOf(SequelizeBackend.prototype), "bind", this).call(this);

              case 2:
                // ** adding the root middleware
                this.use(
                /*#__PURE__*/
                function () {
                  var _ref2 = _asyncToGenerator(
                  /*#__PURE__*/
                  _regenerator.default.mark(function _callee(req, res, next) {
                    var _this2$parseRequest, action, collection, payload, tag, auth, actionHandler, result;

                    return _regenerator.default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _this2$parseRequest = _this2.parseRequest(req), action = _this2$parseRequest.action, collection = _this2$parseRequest.collection, payload = _this2$parseRequest.payload, tag = _this2$parseRequest.tag, auth = _this2$parseRequest.auth;
                            _context.t0 = action;
                            _context.next = _context.t0 === _enum.EntityAction.AUTH ? 4 : _context.t0 === _enum.EntityAction.FETCH_ENTITIES ? 4 : _context.t0 === _enum.EntityAction.DEFINE_RULE ? 4 : _context.t0 === _enum.EntityAction.REMOVE_RULE ? 4 : _context.t0 === _enum.EntityAction.GET_RULES ? 4 : 5;
                            break;

                          case 4:
                            return _context.abrupt("return", next());

                          case 5:
                            if (!(tag !== _this2.tag)) {
                              _context.next = 7;
                              break;
                            }

                            return _context.abrupt("return", next());

                          case 7:
                            actionHandler = _privateInterface[action];

                            if (actionHandler) {
                              _context.next = 10;
                              break;
                            }

                            return _context.abrupt("return", next(new Error("Handler for action ".concat(action, " is not defined"))));

                          case 10:
                            _context.prev = 10;
                            _context.next = 13;
                            return actionHandler.call(_this2, collection, payload, auth, next);

                          case 13:
                            result = _context.sent;
                            res.json(result);
                            _context.next = 21;
                            break;

                          case 17:
                            _context.prev = 17;
                            _context.t1 = _context["catch"](10);
                            console.error(_context.t1);
                            next(internalError);

                          case 21:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, null, [[10, 17]]);
                  }));

                  return function (_x10, _x11, _x12) {
                    return _ref2.apply(this, arguments);
                  };
                }());
                _context2.t0 = this._options.dialect === 'postgres';

                if (!_context2.t0) {
                  _context2.next = 7;
                  break;
                }

                _context2.next = 7;
                return (0, _createDatabase.default)(this._options);

              case 7:
                _context2.next = 9;
                return this.syncModels();

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function bind() {
        return _bind.apply(this, arguments);
      }

      return bind;
    }()
  }, {
    key: "syncModels",
    value: function () {
      var _syncModels = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3() {
        var queryInterface;
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.client.sync();

              case 2:
                queryInterface = this.client.getQueryInterface();
                _context3.next = 5;
                return Promise.all(Array.from(this._models).map(function (schemaData) {
                  return (0, _addMissingColumns.default)(queryInterface, schemaData[0], schemaData[1].schema);
                }));

              case 5:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function syncModels() {
        return _syncModels.apply(this, arguments);
      }

      return syncModels;
    }()
  }, {
    key: "registerEntity",
    value: function registerEntity(entities) {
      var _this3 = this;

      entities = _lodash.default.isArray(entities) ? entities : [entities];

      _lodash.default.each(entities, function (entity) {
        var schema = entity.schema,
            collection = entity.collection,
            idField = entity.idField;
        idField = idField || _lodash.default.findKey(schema, {
          primaryKey: true
        }) || 'id'; // this.addAssociations(schema, collection, entities)

        var model = _this3.client.define(collection, schema, {
          freezeTableName: true
        });

        _this3._models.set(collection, {
          idField: idField,
          model: model,
          schema: schema
        });

        var entitySchema = _lodash.default.mapValues(schema, function (value) {
          return value.type ? value.type.key : value.key;
        });

        _get(_getPrototypeOf(SequelizeBackend.prototype), "registerEntity", _this3).call(_this3, {
          collection: collection,
          idField: idField,
          schema: entitySchema
        });
      });

      this._models.forEach(function (_ref3, key) {
        var schema = _ref3.schema,
            model = _ref3.model;

        _this3.addAssociations(schema, model);
      });
    }
  }, {
    key: "addAssociations",
    value: function addAssociations(schema, model) {
      var _this4 = this;

      // one to many associations
      _lodash.default.each(schema, function (value, key) {
        if (!_lodash.default.get(value, 'references.model') && !_lodash.default.get(value, 'hasMany') && !_lodash.default.get(value, 'belongsTo')) return;

        if (value.belongsTo) {
          var referenceModel = _this4.getModel(value.references.model);

          if (!referenceModel) return;
          return model.belongsTo(referenceModel.model, {
            foreignKey: key,
            as: value.references.as
          });
        }

        var parent = _this4.getModel(value.references.model);

        if (!parent) return;
        parent.model.hasMany(model, {
          foreignKey: key
        });
      });
    }
  }, {
    key: "getModel",
    value: function getModel(table) {
      var model = this._models.get(table);

      if (!model) throw new Error("No model exists for table '".concat(table, "' "));
      return model;
    }
  }, {
    key: "checkPermission",
    value: function () {
      var _checkPermission = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4(_ref4) {
        var _this5 = this;

        var action, collection, newData, auth, query, _ref4$op, op, queryOptions, rules, entity, data, model, shouldNotGetData, status, include, pickAttributes;

        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                action = _ref4.action, collection = _ref4.collection, newData = _ref4.newData, auth = _ref4.auth, query = _ref4.query, _ref4$op = _ref4.op, op = _ref4$op === void 0 ? _enum.READ : _ref4$op, queryOptions = _objectWithoutProperties(_ref4, ["action", "collection", "newData", "auth", "query", "op"]);
                rules = this.getMyRules({
                  collection: collection
                });
                entity = this.getEntity({
                  collection: collection,
                  tag: this.tag
                });
                data = null;

                if (op !== _enum.READ) {
                  op = _enum.WRITE;
                }

                model = this.getModel(collection).model;
                shouldNotGetData = (0, _helpers.rulesDontNeedData)(rules, op);
                status = !!_lodash.default.find(rules, function (rule) {
                  return (0, _helpers.checkRule)({
                    newData: newData,
                    rule: rule[op],
                    auth: auth,
                    collection: collection,
                    tag: _this5.tag,
                    action: action
                  });
                });

                if (!(shouldNotGetData && !status)) {
                  _context4.next = 10;
                  break;
                }

                return _context4.abrupt("return", {
                  status: status
                });

              case 10:
                if (!query) {
                  _context4.next = 18;
                  break;
                }

                if (queryOptions.order === 'random()') queryOptions.order = this.client.random();
                include = queryOptions.attributes ? _lodash.default.pickBy(model.associations, function (val, key) {
                  return queryOptions.attributes.indexOf(key) !== -1;
                }) : model.associations;
                _context4.next = 15;
                return model.findAll(_objectSpread({
                  where: (0, _makePostgresQuery.default)(Sequelize, query)
                }, _lodash.default.omit(queryOptions, 'attributes'), {
                  include: _lodash.default.toArray(include)
                }));

              case 15:
                data = _context4.sent;
                pickAttributes = _lodash.default.get(queryOptions.attributes, 'length') ? queryOptions.attributes : [];
                data = data.map(function (elem) {
                  if (!elem) return null;
                  elem = elem.toJSON();
                  return pickAttributes.length ? _lodash.default.pick(elem, pickAttributes) : elem;
                });

              case 18:
                if (!(!rules.length || auth.masterKey === this.masterKey)) {
                  _context4.next = 20;
                  break;
                }

                return _context4.abrupt("return", {
                  status: true,
                  data: data
                });

              case 20:
                if (!data) {
                  _context4.next = 22;
                  break;
                }

                return _context4.abrupt("return", (0, _helpers.checkPermissionWithData)({
                  data: data,
                  newData: newData,
                  action: action,
                  op: op,
                  schema: _objectSpread({}, entity.schema, model.associations),
                  auth: auth,
                  collection: collection,
                  rules: rules,
                  tag: this.tag,
                  select: queryOptions.attributes
                }));

              case 22:
                return _context4.abrupt("return", {
                  status: status
                });

              case 23:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function checkPermission(_x13) {
        return _checkPermission.apply(this, arguments);
      }

      return checkPermission;
    }()
  }]);

  return SequelizeBackend;
}(_processBackend.default);

exports.default = SequelizeBackend;