"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _baseBackend = _interopRequireDefault(require("./baseBackend"));

var _enum = require("../enum");

var _requireLib = _interopRequireDefault(require("../utils/requireLib"));

var _helpers = require("../utils/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Node = null;
var ROUTES = ['create', 'loadById', 'loadByQuery', 'count', 'loadOne', 'loadAll', 'updateById', 'update', 'removeById', 'removeByQuery', 'runCommand'];

var ZeronodeBackend =
/*#__PURE__*/
function (_BaseBackend) {
  _inherits(ZeronodeBackend, _BaseBackend);

  function ZeronodeBackend() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        address = _ref.address,
        id = _ref.id,
        _ref$options = _ref.options,
        options = _ref$options === void 0 ? {} : _ref$options,
        config = _ref.config,
        entities = _ref.entities,
        rules = _ref.rules,
        tag = _ref.tag,
        masterKey = _ref.masterKey;

    _classCallCheck(this, ZeronodeBackend);

    if (!Node) Node = (0, _requireLib.default)('zeronode').Node;
    _this = _possibleConstructorReturn(this, _getPrototypeOf(ZeronodeBackend).call(this, {
      config: config,
      entities: entities,
      rules: rules,
      tag: tag,
      masterKey: masterKey
    }));
    options.entities = _lodash.default.map(_this.entities, function (entity) {
      return "".concat(entity.tag, ":").concat(entity.collection);
    });
    _this.node = new Node({
      id: id,
      options: options,
      config: config,
      bind: address
    });
    return _this;
  }

  _createClass(ZeronodeBackend, [{
    key: "addRoute",
    value: function addRoute(_ref2) {
      var _this2 = this;

      var action = _ref2.action;
      this.node.onRequest(action, function (req) {
        var body = req.body,
            reply = req.reply;

        _this2.transport.emit(_enum.TransportEvent.TRANSPORT_REQUEST, body, {
          json: reply
        });
      });
    }
  }, {
    key: "parseRequest",
    value: function parseRequest(req, res, next) {
      var _get$call = _get(_getPrototypeOf(ZeronodeBackend.prototype), "parseRequest", this).call(this, req),
          auth = _get$call.auth;

      return {
        action: req.headers.action,
        collection: req.headers.collection,
        tag: req.headers.tag,
        token: req.headers.token,
        payload: req.payload,
        auth: auth
      };
    }
  }, {
    key: "bind",
    value: function () {
      var _bind = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _this3 = this;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.node.bind();

              case 2:
                _context.next = 4;
                return _get(_getPrototypeOf(ZeronodeBackend.prototype), "bind", this).call(this);

              case 4:
                _lodash.default.each(ROUTES, function (action) {
                  return _this3.addRoute({
                    action: action
                  });
                });

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function bind() {
        return _bind.apply(this, arguments);
      }

      return bind;
    }()
  }, {
    key: "registerEntity",
    value: function () {
      var _registerEntity = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(entities) {
        var nodeOptions;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _get(_getPrototypeOf(ZeronodeBackend.prototype), "registerEntity", this).call(this, entities);

                nodeOptions = this.node.getOptions();
                nodeOptions.entities = _lodash.default.map(this.entities, function (entity) {
                  return "".concat(entity.tag, ":").concat(entity.collection);
                });
                _context2.next = 5;
                return this.node.setOptions(nodeOptions);

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function registerEntity(_x) {
        return _registerEntity.apply(this, arguments);
      }

      return registerEntity;
    }()
  }, {
    key: "startWatch",
    value: function startWatch() {
      var _this4 = this;

      if (this.watch) return;

      _get(_getPrototypeOf(ZeronodeBackend.prototype), "startWatch", this).call(this);

      this.node.onTick(_enum.TransportEvent.WATCH_REQUEST, function (_ref3, _ref4) {
        var tag = _ref3.tag,
            collection = _ref3.collection,
            entityId = _ref3.entityId,
            filter = _ref3.filter;
        var id = _ref4.id;

        _this4.handleWatchrequest({
          id: id,
          tag: tag,
          collection: collection,
          entityId: entityId,
          filter: filter
        });
      });
      this.node.onTick(_enum.TransportEvent.UNWATCH_REQUEST, function (_ref5, _ref6) {
        var tag = _ref5.tag,
            collection = _ref5.collection,
            entityId = _ref5.entityId,
            filter = _ref5.filter;
        var id = _ref6.id;

        _this4.handleUnwatchrequest({
          id: id,
          tag: tag,
          collection: collection,
          entityId: entityId,
          filter: filter
        });
      });
    }
  }, {
    key: "emitWatch",
    value: function emitWatch() {
      var _this5 = this;

      var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          action = _ref7.action,
          _ref7$data = _ref7.data,
          data = _ref7$data === void 0 ? {} : _ref7$data,
          collection = _ref7.collection,
          tag = _ref7.tag,
          _ref7$all = _ref7.all,
          all = _ref7$all === void 0 ? false : _ref7$all;

      var proxyRules = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      if (!this.watch) {
        throw new Error('Need to start Watch, before emitting');
      }

      var watchFilter = !all ? {
        $containsAny: [_enum.ALL_COLLECTIONS, "".concat(tag, ":").concat(collection), "".concat(tag, ":").concat(collection, ":").concat(data._id)]
      } : undefined;
      this.node.tickAll({
        event: _enum.TransportEvent.WATCH_RESPONSE,
        data: {
          data: data,
          action: action,
          collection: collection,
          tag: tag
        },
        filter: {
          watch: watchFilter,
          token: function token(_token) {
            try {
              if (_token === _this5.masterKey) return true;
              if (!_this5.checkAuth({
                token: _token
              })) return false;

              var myRules = _this5.getRules({
                collection: collection,
                tag: tag
              });

              var rules = [].concat(_toConsumableArray(myRules), [proxyRules]);
              if (!rules.length) return true;
              return !!_lodash.default.find(rules, function (rule) {
                // TODO:: here data is not full data (discuss what to do here)
                return (0, _helpers.checkRule)({
                  collection: collection,
                  tag: tag,
                  data: data,
                  auth: _this5.decoded({
                    token: _token
                  }),
                  rule: rule.read,
                  action: action
                });
              });
            } catch (err) {
              return false;
            }
          }
        }
      });
    }
  }]);

  return ZeronodeBackend;
}(_baseBackend.default);

exports.default = ZeronodeBackend;