"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _events = _interopRequireDefault(require("events"));

var _uuid = _interopRequireDefault(require("uuid"));

var _enum = require("../enum");

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _watchListener(resp) {
  var action = resp.action,
      data = resp.data;

  if (action === _enum.WatchActions.NEW_ENTITY) {
    this.entities.push(data);
    this.emit(_enum.WatchActions.NEW_ENTITY, data);
    return;
  }

  if (action === _enum.WatchActions.NEW_RULE) {
    if (this.rules[data.key]) this.rules[data.key] = [];
    if (!this.rules[data.key]) this.rules[data.key] = [];
    this.rules[data.key].push(data.rule);
    return;
  }

  this.emit(_enum.TransportEvent.WATCH_RESPONSE, resp);
}

var BaseClient =
/*#__PURE__*/
function (_EventEmitter) {
  _inherits(BaseClient, _EventEmitter);

  function BaseClient() {
    var _context;

    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$id = _ref.id,
        id = _ref$id === void 0 ? (0, _uuid.default)() : _ref$id,
        token = _ref.token;

    _classCallCheck(this, BaseClient);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BaseClient).call(this));
    _this.headers = {};
    _this.id = id;
    _this.watchListener = (_context = _assertThisInitialized(_this), _watchListener).bind(_context);
    _this.entities = [];
    if (_lodash.default.isString(token)) _this.setToken(token);
    return _this;
  } // ** NOTE::AVAR write the client transport once


  _createClass(BaseClient, [{
    key: "setTransport",
    value: function setTransport(transport) {
      // ** TODO::AVAR check if transport is BaseTransport
      Object.defineProperty(this, 'transport', {
        configurable: false,
        writable: false,
        value: transport
      });
    }
  }, {
    key: "setToken",
    value: function setToken(token) {
      return this.setHeaders({
        token: token
      });
    }
  }, {
    key: "setHeaders",
    value: function setHeaders(headers) {
      Object.assign(this.headers, headers);
    }
  }, {
    key: "getHeaders",
    value: function getHeaders() {
      return this.headers;
    }
  }, {
    key: "getId",
    value: function getId() {
      return this.id;
    }
  }, {
    key: "setId",
    value: function setId(id) {
      this.id = id;
    }
  }, {
    key: "request",
    value: function request(entityAction) {
      throw new Error('Implement request for child classes');
    }
  }, {
    key: "connect",
    value: function connect() {
      throw new Error('Implement connect for child classes');
    }
  }, {
    key: "auth",
    value: function () {
      var _auth = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(credentials, masterKey) {
        var _this2 = this;

        var _ref2, token, entities, rules;

        return _regenerator.default.wrap(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.request({
                  action: _enum.EntityAction.AUTH,
                  payload: {
                    credentials: credentials,
                    masterKey: masterKey
                  }
                });

              case 2:
                _ref2 = _context2.sent;
                token = _ref2.token;
                entities = _ref2.entities;
                rules = _ref2.rules;
                this.setToken(token);
                this.token = token;
                this.entities = entities;
                this.rules = rules;

                if (rules) {
                  _lodash.default.each(rules, function (rule, key) {
                    _this2.emit(_enum.WatchActions.NEW_RULE, {
                      key: key,
                      rule: rule
                    });
                  });
                }

                _lodash.default.each(entities, function (entity) {
                  _this2.emit(_enum.WatchActions.NEW_ENTITY, entity);
                });

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee, this);
      }));

      function auth(_x, _x2) {
        return _auth.apply(this, arguments);
      }

      return auth;
    }()
  }, {
    key: "fetchEntities",
    value: function () {
      var _fetchEntities = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var _this3 = this;

        var _ref3, entities, rules;

        return _regenerator.default.wrap(function _callee2$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.request({
                  action: _enum.EntityAction.FETCH_ENTITIES,
                  payload: {}
                });

              case 2:
                _ref3 = _context3.sent;
                entities = _ref3.entities;
                rules = _ref3.rules;
                this.entities = entities;
                this.rules = rules;

                _lodash.default.each(this.entities, function (entity) {
                  _this3.emit(_enum.WatchActions.NEW_ENTITY, entity);
                });

              case 8:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee2, this);
      }));

      function fetchEntities() {
        return _fetchEntities.apply(this, arguments);
      }

      return fetchEntities;
    }()
  }, {
    key: "defineRule",
    value: function () {
      var _defineRule = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3() {
        var _ref4,
            collection,
            tag,
            rule,
            _args3 = arguments;

        return _regenerator.default.wrap(function _callee3$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _ref4 = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {}, collection = _ref4.collection, tag = _ref4.tag, rule = _ref4.rule;
                _context4.next = 3;
                return this.request({
                  action: _enum.EntityAction.DEFINE_RULE,
                  payload: {
                    collection: collection,
                    tag: tag,
                    rule: rule
                  }
                });

              case 3:
                return _context4.abrupt("return", _context4.sent);

              case 4:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee3, this);
      }));

      function defineRule() {
        return _defineRule.apply(this, arguments);
      }

      return defineRule;
    }()
  }, {
    key: "removeRule",
    value: function () {
      var _removeRule = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4() {
        var _ref5,
            id,
            _args4 = arguments;

        return _regenerator.default.wrap(function _callee4$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _ref5 = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : {}, id = _ref5.id;
                _context5.next = 3;
                return this.request({
                  action: _enum.EntityAction.REMOVE_RULE,
                  payload: {
                    id: id
                  }
                });

              case 3:
                return _context5.abrupt("return", _context5.sent);

              case 4:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee4, this);
      }));

      function removeRule() {
        return _removeRule.apply(this, arguments);
      }

      return removeRule;
    }()
  }, {
    key: "getRules",
    value: function () {
      var _getRules = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5() {
        var _ref6,
            count,
            skip,
            _args5 = arguments;

        return _regenerator.default.wrap(function _callee5$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _ref6 = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : {}, count = _ref6.count, skip = _ref6.skip;
                _context6.next = 3;
                return this.request({
                  action: _enum.EntityAction.GET_RULES,
                  payload: {
                    skip: skip,
                    count: count
                  }
                });

              case 3:
                return _context6.abrupt("return", _context6.sent);

              case 4:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee5, this);
      }));

      function getRules() {
        return _getRules.apply(this, arguments);
      }

      return getRules;
    }()
  }, {
    key: "startWatch",
    value: function startWatch() {
      this.watch = true;
    }
  }, {
    key: "stopWatch",
    value: function stopWatch() {
      this.watch = false;
    }
  }, {
    key: "getEntity",
    value: function getEntity() {
      var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          collection = _ref7.collection,
          _ref7$tag = _ref7.tag,
          tag = _ref7$tag === void 0 ? _enum.DEFAULT_TAG : _ref7$tag;

      return _lodash.default.find(this.entities, {
        collection: collection,
        tag: tag
      });
    }
  }]);

  return BaseClient;
}(_events.default);

exports.default = BaseClient;