"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _request2 = _interopRequireDefault(require("../utils/request"));

var _baseClient = _interopRequireDefault(require("./baseClient"));

var _enum = require("../enum");

var _socket = _interopRequireDefault(require("socket.io-client"));

var _url = _interopRequireDefault(require("url"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _privateInterface = {
  create: create,
  loadById: loadById,
  loadAll: loadAll,
  loadByQuery: loadByQuery,
  loadOne: loadOne,
  count: count,
  updateById: updateById,
  update: update,
  removeById: removeById,
  removeByQuery: removeByQuery,
  runCommand: runCommand,
  auth: auth,
  fetchEntities: fetchEntities,
  defineRule: defineRule,
  removeRule: removeRule,
  getRules: getRules
}; // ** CREATE(NEW) ACTION

var makeUrl = function makeUrl(url, collection) {
  return collection ? "".concat(url, "/").concat(collection) : url;
};

function auth(_x) {
  return _auth.apply(this, arguments);
}

function _auth() {
  _auth = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3(_ref) {
    var payload, resp;
    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            payload = _ref.payload;
            _context3.next = 3;
            return _request2.default.post("".concat(this.url, "/").concat(_enum.EntityAction.AUTH), {
              headers: this.getHeaders(),
              json: payload
            });

          case 3:
            resp = _context3.sent;
            return _context3.abrupt("return", resp.json());

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));
  return _auth.apply(this, arguments);
}

function fetchEntities(_x2) {
  return _fetchEntities.apply(this, arguments);
}

function _fetchEntities() {
  _fetchEntities = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee4(_ref2) {
    var payload, resp;
    return _regenerator.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            payload = _ref2.payload;
            _context4.next = 3;
            return _request2.default.post("".concat(this.url, "/").concat(_enum.EntityAction.FETCH_ENTITIES), {
              headers: this.getHeaders(),
              json: payload
            });

          case 3:
            resp = _context4.sent;
            return _context4.abrupt("return", resp.json());

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));
  return _fetchEntities.apply(this, arguments);
}

function defineRule(_x3) {
  return _defineRule.apply(this, arguments);
}

function _defineRule() {
  _defineRule = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee5(_ref3) {
    var payload, resp;
    return _regenerator.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            payload = _ref3.payload;
            _context5.next = 3;
            return _request2.default.post("".concat(this.url, "/").concat(_enum.EntityAction.DEFINE_RULE), {
              headers: this.getHeaders(),
              json: payload
            });

          case 3:
            resp = _context5.sent;
            return _context5.abrupt("return", resp.json());

          case 5:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));
  return _defineRule.apply(this, arguments);
}

function removeRule(_x4) {
  return _removeRule.apply(this, arguments);
}

function _removeRule() {
  _removeRule = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee6(_ref4) {
    var payload, resp;
    return _regenerator.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            payload = _ref4.payload;
            _context6.next = 3;
            return _request2.default.post("".concat(this.url, "/").concat(_enum.EntityAction.REMOVE_RULE), {
              headers: this.getHeaders(),
              json: payload
            });

          case 3:
            resp = _context6.sent;
            return _context6.abrupt("return", resp.json());

          case 5:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));
  return _removeRule.apply(this, arguments);
}

function getRules(_x5) {
  return _getRules.apply(this, arguments);
}

function _getRules() {
  _getRules = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee7(_ref5) {
    var payload, resp;
    return _regenerator.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            payload = _ref5.payload;
            _context7.next = 3;
            return _request2.default.post("".concat(this.url, "/").concat(_enum.EntityAction.GET_RULES), {
              headers: this.getHeaders(),
              json: payload
            });

          case 3:
            resp = _context7.sent;
            return _context7.abrupt("return", resp.json());

          case 5:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7, this);
  }));
  return _getRules.apply(this, arguments);
}

function create() {
  return _create.apply(this, arguments);
} // ** UPDATE(EXISTING) ACTIONS


function _create() {
  _create = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee8() {
    var _ref10,
        action,
        collection,
        payload,
        resp,
        _args8 = arguments;

    return _regenerator.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            _ref10 = _args8.length > 0 && _args8[0] !== undefined ? _args8[0] : {}, action = _ref10.action, collection = _ref10.collection, payload = _ref10.payload;
            _context8.next = 3;
            return _request2.default.post("".concat(makeUrl(this.url, collection)), {
              headers: this.getHeaders(),
              json: payload
            });

          case 3:
            resp = _context8.sent;
            return _context8.abrupt("return", resp.json());

          case 5:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8, this);
  }));
  return _create.apply(this, arguments);
}

function updateById() {
  return _updateById.apply(this, arguments);
}

function _updateById() {
  _updateById = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee9() {
    var _ref11,
        action,
        collection,
        payload,
        query,
        id,
        resp,
        _args9 = arguments;

    return _regenerator.default.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            _ref11 = _args9.length > 0 && _args9[0] !== undefined ? _args9[0] : {}, action = _ref11.action, collection = _ref11.collection, payload = _ref11.payload;
            // ** AVAR::NOTE parse updateById data
            query = payload.query;
            id = query.id;
            _context9.next = 5;
            return _request2.default.put("".concat(makeUrl(this.url, collection), "/").concat(id), {
              headers: this.getHeaders(),
              method: 'PUT',
              json: payload
            });

          case 5:
            resp = _context9.sent;
            return _context9.abrupt("return", resp.json());

          case 7:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9, this);
  }));
  return _updateById.apply(this, arguments);
}

function update() {
  return _update.apply(this, arguments);
} // ** REMOVE ACTIONS


function _update() {
  _update = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee10() {
    var _ref12,
        action,
        collection,
        payload,
        _args10 = arguments;

    return _regenerator.default.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            _ref12 = _args10.length > 0 && _args10[0] !== undefined ? _args10[0] : {}, action = _ref12.action, collection = _ref12.collection, payload = _ref12.payload;
            return _context10.abrupt("return", actionByQuery.call(this, 'update', collection, payload));

          case 2:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10, this);
  }));
  return _update.apply(this, arguments);
}

function removeById() {
  return _removeById.apply(this, arguments);
}

function _removeById() {
  _removeById = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee11() {
    var _ref13,
        action,
        collection,
        payload,
        query,
        id,
        resp,
        _args11 = arguments;

    return _regenerator.default.wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            _ref13 = _args11.length > 0 && _args11[0] !== undefined ? _args11[0] : {}, action = _ref13.action, collection = _ref13.collection, payload = _ref13.payload;
            query = payload.query;
            id = query.id;
            _context11.next = 5;
            return _request2.default.delete("".concat(makeUrl(this.url, collection), "/").concat(id), {
              headers: this.getHeaders(),
              method: 'DELETE'
            });

          case 5:
            resp = _context11.sent;
            return _context11.abrupt("return", resp.json());

          case 7:
          case "end":
            return _context11.stop();
        }
      }
    }, _callee11, this);
  }));
  return _removeById.apply(this, arguments);
}

function removeByQuery() {
  return _removeByQuery.apply(this, arguments);
} // ** LOAD ACTIONS


function _removeByQuery() {
  _removeByQuery = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee12() {
    var _ref14,
        action,
        collection,
        payload,
        query,
        _args12 = arguments;

    return _regenerator.default.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            _ref14 = _args12.length > 0 && _args12[0] !== undefined ? _args12[0] : {}, action = _ref14.action, collection = _ref14.collection, payload = _ref14.payload;
            query = payload.query;
            return _context12.abrupt("return", actionByQuery.call(this, 'removeByQuery', collection, {
              query: query
            }));

          case 3:
          case "end":
            return _context12.stop();
        }
      }
    }, _callee12, this);
  }));
  return _removeByQuery.apply(this, arguments);
}

function loadById() {
  return _loadById.apply(this, arguments);
}

function _loadById() {
  _loadById = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee13() {
    var _ref15,
        action,
        collection,
        payload,
        query,
        select,
        id,
        resp,
        _args13 = arguments;

    return _regenerator.default.wrap(function _callee13$(_context13) {
      while (1) {
        switch (_context13.prev = _context13.next) {
          case 0:
            _ref15 = _args13.length > 0 && _args13[0] !== undefined ? _args13[0] : {}, action = _ref15.action, collection = _ref15.collection, payload = _ref15.payload;
            query = payload.query, select = payload.select;
            id = query.id;
            _context13.next = 5;
            return _request2.default.get("".concat(makeUrl(this.url, collection), "/").concat(id), {
              headers: this.getHeaders(),
              qs: {
                select: select
              }
            });

          case 5:
            resp = _context13.sent;
            return _context13.abrupt("return", resp.json());

          case 7:
          case "end":
            return _context13.stop();
        }
      }
    }, _callee13, this);
  }));
  return _loadById.apply(this, arguments);
}

function loadAll() {
  return _loadAll.apply(this, arguments);
}

function _loadAll() {
  _loadAll = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee14() {
    var _ref16,
        action,
        collection,
        payload,
        select,
        resp,
        _args14 = arguments;

    return _regenerator.default.wrap(function _callee14$(_context14) {
      while (1) {
        switch (_context14.prev = _context14.next) {
          case 0:
            _ref16 = _args14.length > 0 && _args14[0] !== undefined ? _args14[0] : {}, action = _ref16.action, collection = _ref16.collection, payload = _ref16.payload;
            select = payload.select;
            _context14.next = 4;
            return _request2.default.get("".concat(makeUrl(this.url, collection)), {
              headers: this.getHeaders(),
              qs: {
                select: select
              }
            });

          case 4:
            resp = _context14.sent;
            return _context14.abrupt("return", resp.json());

          case 6:
          case "end":
            return _context14.stop();
        }
      }
    }, _callee14, this);
  }));
  return _loadAll.apply(this, arguments);
}

function loadByQuery() {
  return _loadByQuery.apply(this, arguments);
}

function _loadByQuery() {
  _loadByQuery = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee15() {
    var _ref17,
        action,
        collection,
        payload,
        query,
        select,
        _args15 = arguments;

    return _regenerator.default.wrap(function _callee15$(_context15) {
      while (1) {
        switch (_context15.prev = _context15.next) {
          case 0:
            _ref17 = _args15.length > 0 && _args15[0] !== undefined ? _args15[0] : {}, action = _ref17.action, collection = _ref17.collection, payload = _ref17.payload;
            query = payload.query, select = payload.select;
            return _context15.abrupt("return", actionByQuery.call(this, 'loadByQuery', collection, {
              query: query,
              select: select
            }));

          case 3:
          case "end":
            return _context15.stop();
        }
      }
    }, _callee15, this);
  }));
  return _loadByQuery.apply(this, arguments);
}

function count() {
  return _count.apply(this, arguments);
}

function _count() {
  _count = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee16() {
    var _ref18,
        action,
        collection,
        payload,
        query,
        _args16 = arguments;

    return _regenerator.default.wrap(function _callee16$(_context16) {
      while (1) {
        switch (_context16.prev = _context16.next) {
          case 0:
            _ref18 = _args16.length > 0 && _args16[0] !== undefined ? _args16[0] : {}, action = _ref18.action, collection = _ref18.collection, payload = _ref18.payload;
            query = payload.query;
            return _context16.abrupt("return", actionByQuery.call(this, 'count', collection, {
              query: query
            }));

          case 3:
          case "end":
            return _context16.stop();
        }
      }
    }, _callee16, this);
  }));
  return _count.apply(this, arguments);
}

function loadOne() {
  return _loadOne.apply(this, arguments);
}

function _loadOne() {
  _loadOne = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee17() {
    var _ref19,
        action,
        collection,
        payload,
        query,
        select,
        _args17 = arguments;

    return _regenerator.default.wrap(function _callee17$(_context17) {
      while (1) {
        switch (_context17.prev = _context17.next) {
          case 0:
            _ref19 = _args17.length > 0 && _args17[0] !== undefined ? _args17[0] : {}, action = _ref19.action, collection = _ref19.collection, payload = _ref19.payload;
            query = payload.query, select = payload.select;
            return _context17.abrupt("return", actionByQuery.call(this, 'loadByOne', collection, {
              query: query,
              select: select
            }));

          case 3:
          case "end":
            return _context17.stop();
        }
      }
    }, _callee17, this);
  }));
  return _loadOne.apply(this, arguments);
}

function runCommand() {
  return _runCommand.apply(this, arguments);
} // **  ACTIONS BY QUERY


function _runCommand() {
  _runCommand = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee18() {
    var _ref20,
        action,
        collection,
        payload,
        command,
        resp,
        _args18 = arguments;

    return _regenerator.default.wrap(function _callee18$(_context18) {
      while (1) {
        switch (_context18.prev = _context18.next) {
          case 0:
            _ref20 = _args18.length > 0 && _args18[0] !== undefined ? _args18[0] : {}, action = _ref20.action, collection = _ref20.collection, payload = _ref20.payload;
            command = payload.command;
            _context18.next = 4;
            return _request2.default.post("".concat(makeUrl(this.url, collection), "/command/").concat(command), {
              headers: this.getHeaders(),
              method: 'POST',
              json: payload
            });

          case 4:
            resp = _context18.sent;
            return _context18.abrupt("return", resp.json());

          case 6:
          case "end":
            return _context18.stop();
        }
      }
    }, _callee18, this);
  }));
  return _runCommand.apply(this, arguments);
}

function actionByQuery(_x6, _x7, _x8) {
  return _actionByQuery.apply(this, arguments);
} //* * CUSTOM REQUEST


function _actionByQuery() {
  _actionByQuery = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee19(action, collection, payload) {
    var resp;
    return _regenerator.default.wrap(function _callee19$(_context19) {
      while (1) {
        switch (_context19.prev = _context19.next) {
          case 0:
            _context19.next = 2;
            return _request2.default.post("".concat(makeUrl(this.url, collection), "/").concat(action), {
              headers: this.getHeaders(),
              method: 'POST',
              json: payload
            });

          case 2:
            resp = _context19.sent;
            return _context19.abrupt("return", resp.json());

          case 4:
          case "end":
            return _context19.stop();
        }
      }
    }, _callee19, this);
  }));
  return _actionByQuery.apply(this, arguments);
}

function customRequest(_x9, _x10, _x11, _x12) {
  return _customRequest.apply(this, arguments);
}

function _customRequest() {
  _customRequest = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee20(action, collection, payload, options) {
    var _objectSpread2;

    var requestFn, resp;
    return _regenerator.default.wrap(function _callee20$(_context20) {
      while (1) {
        switch (_context20.prev = _context20.next) {
          case 0:
            requestFn = options.method ? _request2.default[options.method.toLowerCase()] : _request2.default.post;
            _context20.next = 3;
            return requestFn("".concat(makeUrl(this.url, collection), "/wirentity/custom").concat(options.route), _objectSpread((_objectSpread2 = {
              headers: this.getHeaders()
            }, _defineProperty(_objectSpread2, options.method && options.method.toLowerCase() === 'get' ? 'qs' : 'json', payload), _defineProperty(_objectSpread2, "method", 'POST'), _objectSpread2), options));

          case 3:
            resp = _context20.sent;
            return _context20.abrupt("return", options.jsonResponse === false ? resp.text() : resp.json());

          case 5:
          case "end":
            return _context20.stop();
        }
      }
    }, _callee20, this);
  }));
  return _customRequest.apply(this, arguments);
}

var HTTPClient =
/*#__PURE__*/
function (_BaseClient) {
  _inherits(HTTPClient, _BaseClient);

  function HTTPClient() {
    var _this;

    var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        host = _ref6.host,
        port = _ref6.port,
        token = _ref6.token,
        id = _ref6.id;

    _classCallCheck(this, HTTPClient);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(HTTPClient).call(this, {
      id: id,
      token: token
    }));
    _this.host = host;
    _this.port = port;
    _this.url = _this.port ? "".concat(_this.host, ":").concat(_this.port) : _this.host;
    return _this;
  }

  _createClass(HTTPClient, [{
    key: "setToken",
    value: function setToken(token) {
      if (!_lodash.default.isString(token)) throw new Error("JWT must by type of string");
      this.setHeaders(_defineProperty({}, _enum.HttpHeaders.AUTHORIZATION, "Bearer ".concat(token)));
    } // ** NOTE::AVAR no need to connect http, always true

  }, {
    key: "connect",
    value: function () {
      var _connect = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(credentials, masterKey) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.auth(credentials, masterKey);

              case 2:
                return _context.abrupt("return", true);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function connect(_x13, _x14) {
        return _connect.apply(this, arguments);
      }

      return connect;
    }()
  }, {
    key: "startWatch",
    value: function startWatch() {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        if (_this2.watch) return resolve();

        _get(_getPrototypeOf(HTTPClient.prototype), "startWatch", _this2).call(_this2);

        var parsed = _url.default.parse(_this2.url);

        var path = parsed.path === '/' ? '' : parsed.path;

        var socket = _socket.default.connect("".concat(parsed.protocol, "//").concat(parsed.host), {
          path: "".concat(path, "/socket.io"),
          query: "token=".concat(_this2.getHeaders()[_enum.HttpHeaders.AUTHORIZATION].split(' ')[1]),
          transports: ['websocket']
        });

        socket.once(_enum.SocketEvents.CONNECT, function () {
          resolve();
        });
        socket.once(_enum.SocketEvents.CONNECT_ERROR, reject);
        socket.on(_enum.SocketEvents.DISCONNECT, function (reason) {
          _this2.emit(_enum.SocketEvents.DISCONNECT, reason);

          console.info('Socket disconnected from server:', reason);
        });
        socket.on(_enum.SocketEvents.RECONNECT_ATTEMPT, function (attemptNumber) {
          _this2.emit(_enum.SocketEvents.RECONNECT_ATTEMPT, attemptNumber);

          console.info('Trying to reconnect, attempt number:', attemptNumber);
        });
        socket.on(_enum.SocketEvents.RECONNECT, function () {
          _this2.socket.connected = true;

          _this2.emit(_enum.SocketEvents.RECONNECT); // TODO: send all watch data (need to store in client first)


          console.info('Successfully reconnected to server.');
        });
        socket.on(_enum.SocketEvents.ERROR, function (err) {
          console.warn('Error in watch socket', err);
        });
        socket.on(_enum.TransportEvent.WATCH_RESPONSE, function (resp) {
          return _this2.emit(_enum.TransportEvent.WATCH_RESPONSE, resp);
        });
        _this2.socket = socket;
      });
    }
  }, {
    key: "requestWatch",
    value: function requestWatch() {
      var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          tag = _ref7.tag,
          collection = _ref7.collection,
          entityId = _ref7.entityId,
          filter = _ref7.filter;

      if (!this.watch || !this.socket.connected) {
        throw new Error('Watch is not enabled, or socket is disconnected');
      }

      this.socket.emit(_enum.TransportEvent.WATCH_REQUEST, {
        tag: tag,
        collection: collection,
        entityId: entityId,
        filter: filter
      });
    }
  }, {
    key: "requestUnwatch",
    value: function requestUnwatch() {
      var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          tag = _ref8.tag,
          collection = _ref8.collection,
          entityId = _ref8.entityId,
          filter = _ref8.filter;

      if (!this.watch || !this.socket.connected) {
        throw new Error('Watch is not enabled, or socket is disconnected');
      }

      this.socket.emit(_enum.TransportEvent.UNWATCH_REQUEST, {
        tag: tag,
        collection: collection,
        entityId: entityId,
        filter: filter
      });
    }
  }, {
    key: "stopWatch",
    value: function stopWatch() {
      if (!this.watch && !this.socket) return;

      _get(_getPrototypeOf(HTTPClient.prototype), "stopWatch", this).call(this);

      this.socket.disconnect();
      this.socket = null;
    }
  }, {
    key: "request",
    value: function () {
      var _request = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var _headers;

        var _ref9,
            action,
            payload,
            collection,
            tag,
            requestOptions,
            headers,
            actionHandler,
            _args2 = arguments;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _ref9 = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : {}, action = _ref9.action, payload = _ref9.payload, collection = _ref9.collection, tag = _ref9.tag, requestOptions = _ref9.requestOptions;
                headers = (_headers = {}, _defineProperty(_headers, _enum.HttpHeaders.ACTION, action === 'actionByQuery' ? payload.action : action), _defineProperty(_headers, _enum.HttpHeaders.COLLECTION, collection), _defineProperty(_headers, _enum.HttpHeaders.TAG, tag), _headers);
                this.setHeaders(headers);

                if (_lodash.default.isEmpty(requestOptions)) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt("return", customRequest.call(this, action, collection, payload, requestOptions));

              case 5:
                actionHandler = _privateInterface[action];
                return _context2.abrupt("return", actionHandler.call(this, {
                  action: action,
                  collection: collection,
                  payload: payload
                }));

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function request() {
        return _request.apply(this, arguments);
      }

      return request;
    }()
  }]);

  return HTTPClient;
}(_baseClient.default);

exports.default = HTTPClient;