"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _uuid = _interopRequireDefault(require("uuid"));

var _baseClient = _interopRequireDefault(require("./baseClient"));

var _requireLib = _interopRequireDefault(require("../utils/requireLib"));

var _kitooError = _interopRequireDefault(require("../utils/kitooError"));

var _entity = _interopRequireDefault(require("../entity"));

var _enum = require("../enum");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var KitooNetwork = null;
var watchFilter = {
  backend: {
    $eq: true
  },
  watchEnabled: {
    $eq: true
  }
};

var kitooClient =
/*#__PURE__*/
function (_BaseClient) {
  _inherits(kitooClient, _BaseClient);

  function kitooClient(_ref) {
    var _this;

    var id = _ref.id,
        config = _ref.config,
        _ref$host = _ref.host,
        host = _ref$host === void 0 ? '127.0.0.1' : _ref$host,
        _ref$port = _ref.port,
        port = _ref$port === void 0 ? 3000 : _ref$port,
        token = _ref.token,
        name = _ref.name,
        router = _ref.router,
        initialStatus = _ref.initialStatus;

    _classCallCheck(this, kitooClient);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(kitooClient).call(this, {
      id: id,
      token: token
    }));
    _this.router = router || "tcp://".concat(host, ":").concat(port);
    _this.name = name;
    _this.config = _objectSpread({
      REQUEST_TIMEOUT: 5000,
      INTERNAL_REQUEST_TIMEOUT: 5000
    }, config);
    _this.kitooNetwork = null;
    _this.__initialStatus = initialStatus || _enum.NODE_STATUSES.STARTED;
    return _this;
  }

  _createClass(kitooClient, [{
    key: "getDefaultFilters",
    value: function getDefaultFilters() {
      return {
        __status: {
          $eq: _enum.NODE_STATUSES.STARTED
        }
      };
    }
  }, {
    key: "setStatus",
    value: function setStatus(status) {
      var node = this.kitooNetwork.node;
      return node.setOptions(_objectSpread({}, node.getOptions(), {
        __status: status
      }));
    }
  }, {
    key: "waitToConnect",
    value: function () {
      var _waitToConnect = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                _context.next = 3;
                return this.request({
                  action: _enum.EntityAction.PING
                });

              case 3:
                _context.next = 10;
                break;

              case 5:
                _context.prev = 5;
                _context.t0 = _context["catch"](0);
                _context.next = 9;
                return new Promise(function (r) {
                  return setTimeout(r, 500);
                });

              case 9:
                return _context.abrupt("return", this.waitToConnect());

              case 10:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 5]]);
      }));

      function waitToConnect() {
        return _waitToConnect.apply(this, arguments);
      }

      return waitToConnect;
    }()
  }, {
    key: "connect",
    value: function () {
      var _connect = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(credentials, masterKey) {
        var waitToConnect,
            _args2 = arguments;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                waitToConnect = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : false;

                if (!this.transport.getBackend()) {
                  if (!KitooNetwork) KitooNetwork = (0, _requireLib.default)('kitoo-core').Network;
                  this.kitooNetwork = new KitooNetwork({
                    id: this.id,
                    router: this.router,
                    config: this.config,
                    options: {
                      entities: []
                    }
                  });
                  this.kitooNetwork.node.on('error', _kitooError.default);
                } else {
                  this.kitooNetwork = this.transport.getBackend().kitooNetwork;
                }

                this.setId(this.kitooNetwork.getId());
                _context2.next = 5;
                return this.kitooNetwork.start();

              case 5:
                _context2.t0 = waitToConnect;

                if (!_context2.t0) {
                  _context2.next = 9;
                  break;
                }

                _context2.next = 9;
                return this.waitToConnect();

              case 9:
                _context2.next = 11;
                return this.auth(credentials, masterKey);

              case 11:
                _context2.next = 13;
                return this.kitooNetwork.node.setOptions(Object.assign(this.kitooNetwork.node.getOptions(), {
                  token: this.getHeaders().token,
                  __status: this.__initialStatus
                }));

              case 13:
                _context2.next = 15;
                return this.fetchEntities();

              case 15:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function connect(_x, _x2) {
        return _connect.apply(this, arguments);
      }

      return connect;
    }()
  }, {
    key: "getEntityClass",
    value: function getEntityClass(collection, idField) {
      var tag = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'wirentity';
      return _entity.default.generateClass(this.transport, collection, tag);
    }
  }, {
    key: "request",
    value: function () {
      var _request = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(entityAction) {
        var _context3,
            _this2 = this;

        var action, collection, payload, _entityAction$filter, clientFilter, tag, name, auth, defaultFilter, filter, tickAllFn, customEvent, entities, rules, requestFn, response;

        return _regenerator.default.wrap(function _callee3$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                action = entityAction.action, collection = entityAction.collection, payload = entityAction.payload, _entityAction$filter = entityAction.filter, clientFilter = _entityAction$filter === void 0 ? {} : _entityAction$filter, tag = entityAction.tag, name = entityAction.name, auth = entityAction.auth;
                name = name || this.name;
                defaultFilter = name ? {
                  service: name
                } : {};
                filter = _objectSpread({}, this.getDefaultFilters(), defaultFilter, clientFilter);
                tickAllFn = (_context3 = this.kitooNetwork, this.kitooNetwork.proxyTickAll).bind(_context3);

                if (!(action === _enum.EntityAction.FETCH_ENTITIES)) {
                  _context4.next = 15;
                  break;
                }

                customEvent = (0, _uuid.default)();
                entities = [];
                rules = [];
                this.kitooNetwork.onTick(customEvent, function (response) {
                  _lodash.default.each(response.entities, function (entity) {
                    entities["".concat(entity.tag, ":").concat(entity.collection)] = entity;
                  });

                  if (!response.rules) return;

                  _lodash.default.each(response.rules, function (rule, key) {
                    if (!rules[key]) rules[key] = [];
                    rules[key] = [].concat(_toConsumableArray(rules[key]), _toConsumableArray(rule));
                  });
                });
                tickAllFn({
                  event: _enum.EntityAction.FETCH_ENTITIES,
                  data: _objectSpread({}, this.getHeaders(), {
                    event: customEvent
                  }),
                  filter: filter
                }); //TODO::get service count and resolve when all services have responded

                _context4.next = 13;
                return new Promise(function (resolve) {
                  return setTimeout(resolve, _this2.config.INTERNAL_REQUEST_TIMEOUT);
                });

              case 13:
                this.kitooNetwork.offTick(customEvent);
                return _context4.abrupt("return", {
                  entities: Object.values(entities),
                  rules: rules
                });

              case 15:
                if (!(action === _enum.EntityAction.DEFINE_RULE || action === _enum.EntityAction.REMOVE_RULE)) {
                  _context4.next = 18;
                  break;
                }

                tickAllFn({
                  event: action,
                  filter: filter,
                  data: {
                    headers: _objectSpread({}, this.getHeaders(), {
                      action: action,
                      collection: collection,
                      tag: tag
                    }),
                    payload: payload
                  }
                });
                return _context4.abrupt("return");

              case 18:
                requestFn = (_context3 = this.kitooNetwork, this.kitooNetwork.proxyRequestAny).bind(_context3);

                if (!name) {
                  filter.entities = {
                    $contains: "".concat(tag, ":").concat(collection)
                  };
                }

                if (action === _enum.EntityAction.AUTH) {
                  filter.backend = {
                    $eq: true
                  };
                }

                _context4.next = 23;
                return requestFn({
                  event: action,
                  data: {
                    headers: _objectSpread({}, this.getHeaders(), {
                      action: action,
                      collection: collection,
                      tag: tag
                    }),
                    payload: payload,
                    auth: auth
                  },
                  filter: filter,
                  timeout: action === _enum.EntityAction.PING ? this.config.INTERNAL_REQUEST_TIMEOUT : this.config.REQUEST_TIMEOUT
                });

              case 23:
                response = _context4.sent;

                if (!(response && response.error)) {
                  _context4.next = 26;
                  break;
                }

                throw response;

              case 26:
                return _context4.abrupt("return", response);

              case 27:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee3, this);
      }));

      function request(_x3) {
        return _request.apply(this, arguments);
      }

      return request;
    }()
  }, {
    key: "reinitializeWatch",
    value: function () {
      var _reinitializeWatch = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5() {
        var _this3 = this;

        var options, watchOptions;
        return _regenerator.default.wrap(function _callee5$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.prev = 0;

                if (!this.reinitializingWatch) {
                  _context6.next = 3;
                  break;
                }

                return _context6.abrupt("return");

              case 3:
                this.reinitializingWatch = true;
                options = this.kitooNetwork.node.getOptions();

                if (options.watch) {
                  _context6.next = 7;
                  break;
                }

                return _context6.abrupt("return");

              case 7:
                watchOptions = options.watch;
                _context6.next = 10;
                return _lodash.default.reduce(watchOptions,
                /*#__PURE__*/
                function () {
                  var _ref2 = _asyncToGenerator(
                  /*#__PURE__*/
                  _regenerator.default.mark(function _callee4(promise, watchString) {
                    var _watchString$split, _watchString$split2, tag, collection, entityId;

                    return _regenerator.default.wrap(function _callee4$(_context5) {
                      while (1) {
                        switch (_context5.prev = _context5.next) {
                          case 0:
                            _context5.next = 2;
                            return promise;

                          case 2:
                            _watchString$split = watchString.split(':'), _watchString$split2 = _slicedToArray(_watchString$split, 3), tag = _watchString$split2[0], collection = _watchString$split2[1], entityId = _watchString$split2[2];
                            _context5.next = 5;
                            return _this3.requestUnwatch({
                              tag: tag,
                              collection: collection,
                              entityId: entityId
                            });

                          case 5:
                            _context5.next = 7;
                            return new Promise(function (r) {
                              return setTimeout(r, _this3.config.INTERNAL_REQUEST_TIMEOUT);
                            });

                          case 7:
                            _context5.next = 9;
                            return _this3.requestWatch({
                              tag: tag,
                              collection: collection,
                              entityId: entityId
                            });

                          case 9:
                          case "end":
                            return _context5.stop();
                        }
                      }
                    }, _callee4);
                  }));

                  return function (_x4, _x5) {
                    return _ref2.apply(this, arguments);
                  };
                }(), Promise.resolve());

              case 10:
                _context6.next = 15;
                break;

              case 12:
                _context6.prev = 12;
                _context6.t0 = _context6["catch"](0);
                console.error(_context6.t0);

              case 15:
                _context6.prev = 15;
                this.reinitializingWatch = false;
                return _context6.finish(15);

              case 18:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee5, this, [[0, 12, 15, 18]]);
      }));

      function reinitializeWatch() {
        return _reinitializeWatch.apply(this, arguments);
      }

      return reinitializeWatch;
    }()
  }, {
    key: "startWatch",
    value: function startWatch() {
      if (!this.kitooNetwork) {
        throw new Error('Need to connect to backend before starting watch.');
      }

      if (this.watch) return;

      _get(_getPrototypeOf(kitooClient.prototype), "startWatch", this).call(this);

      this.kitooNetwork.offTick(_enum.TransportEvent.REINITIALIZE_WATCH);
      this.kitooNetwork.offTick(_enum.TransportEvent.WATCH_RESPONSE);
      this.kitooNetwork.onTick(_enum.TransportEvent.WATCH_RESPONSE, this.watchListener);
      this.kitooNetwork.onTick(_enum.TransportEvent.REINITIALIZE_WATCH, this.reinitializeWatch.bind(this));
    }
  }, {
    key: "stopWatch",
    value: function stopWatch() {
      if (!this.watch) return;

      _get(_getPrototypeOf(kitooClient.prototype), "stopWatch", this).call(this);

      this.kitooNetwork.offTick(_enum.TransportEvent.WATCH_RESPONSE, this.watchListener);
      this.kitooNetwork.offTick(_enum.TransportEvent.REINITIALIZE_WATCH);
    }
  }, {
    key: "requestWatch",
    value: function () {
      var _requestWatch = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee6() {
        var _ref3,
            tag,
            collection,
            entityId,
            filter,
            options,
            _args6 = arguments;

        return _regenerator.default.wrap(function _callee6$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _ref3 = _args6.length > 0 && _args6[0] !== undefined ? _args6[0] : {}, tag = _ref3.tag, collection = _ref3.collection, entityId = _ref3.entityId, filter = _ref3.filter;

                if (this.watch) {
                  _context7.next = 3;
                  break;
                }

                throw new Error('Need to start Watch, before watch request');

              case 3:
                options = this.kitooNetwork.node.getOptions();

                if (!options.watch) {
                  options.watch = [];
                }

                if (!collection) {
                  options.watch.indexOf(_enum.ALL_COLLECTIONS) === -1 && options.watch.push(_enum.ALL_COLLECTIONS);
                } else if (!entityId) {
                  options.watch.indexOf("".concat(tag, ":").concat(collection)) === -1 && options.watch.push("".concat(tag, ":").concat(collection));
                } else {
                  options.watch.indexOf("".concat(tag, ":").concat(collection, ":").concat(entityId)) === -1 && options.watch.push("".concat(tag, ":").concat(collection, ":").concat(entityId));
                }

                _context7.next = 8;
                return this.kitooNetwork.node.setOptions(options);

              case 8:
                this.kitooNetwork.proxyTickAny({
                  event: _enum.TransportEvent.WATCH_REQUEST,
                  data: {
                    tag: tag,
                    collection: collection,
                    entityId: entityId,
                    filter: filter
                  },
                  filter: _objectSpread({}, this.getDefaultFilters(), watchFilter)
                });

              case 9:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee6, this);
      }));

      function requestWatch() {
        return _requestWatch.apply(this, arguments);
      }

      return requestWatch;
    }()
  }, {
    key: "requestUnwatch",
    value: function () {
      var _requestUnwatch = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee7() {
        var _ref4,
            tag,
            collection,
            entityId,
            filter,
            options,
            index,
            _args7 = arguments;

        return _regenerator.default.wrap(function _callee7$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _ref4 = _args7.length > 0 && _args7[0] !== undefined ? _args7[0] : {}, tag = _ref4.tag, collection = _ref4.collection, entityId = _ref4.entityId, filter = _ref4.filter;

                if (this.watch) {
                  _context8.next = 3;
                  break;
                }

                throw new Error('Need to start Watch, before unwatch request');

              case 3:
                options = this.kitooNetwork.node.getOptions();

                if (!options.watch) {
                  options.watch = [];
                }

                index = -1;

                if (!collection) {
                  index = options.watch.indexOf(_enum.ALL_COLLECTIONS);
                  index !== -1 && options.watch.splice(index, 1);
                } else if (!entityId) {
                  index = options.watch.indexOf("".concat(tag, ":").concat(collection));
                  index !== -1 && options.watch.splice(index, 1);
                } else {
                  index = options.watch.indexOf("".concat(tag, ":").concat(collection, ":").concat(entityId));
                  index !== -1 && options.watch.splice(index, 1);
                }

                _context8.next = 9;
                return this.kitooNetwork.node.setOptions(options);

              case 9:
                this.kitooNetwork.proxyTickAll({
                  event: _enum.TransportEvent.UNWATCH_REQUEST,
                  data: {
                    tag: tag,
                    collection: collection,
                    entityId: entityId,
                    filter: filter
                  },
                  filter: _objectSpread({}, this.getDefaultFilters(), watchFilter)
                });

              case 10:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee7, this);
      }));

      function requestUnwatch() {
        return _requestUnwatch.apply(this, arguments);
      }

      return requestUnwatch;
    }()
  }]);

  return kitooClient;
}(_baseClient.default);

exports.default = kitooClient;