"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _baseClient = _interopRequireDefault(require("./baseClient"));

var _enum = require("../enum");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ProcessClient =
/*#__PURE__*/
function (_BaseClient) {
  _inherits(ProcessClient, _BaseClient);

  function ProcessClient() {
    _classCallCheck(this, ProcessClient);

    return _possibleConstructorReturn(this, _getPrototypeOf(ProcessClient).apply(this, arguments));
  }

  _createClass(ProcessClient, [{
    key: "connect",
    value: function () {
      var _connect = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(credentials, masterKey) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.auth(credentials, masterKey);

              case 2:
                return _context.abrupt("return", true);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function connect(_x, _x2) {
        return _connect.apply(this, arguments);
      }

      return connect;
    }()
  }, {
    key: "request",
    value: function request(entityAction) {
      var _this = this;

      // TODO::AVAR what if there is no transport set, actually clients are created from transport
      return new _bluebird.default(function (resolve, reject) {
        // ** AVAR::NOTE the default request
        var req = {
          inProcessBody: entityAction,
          headers: _this.getHeaders()
        }; // ** AVAR::NOTE the default response

        var res = {
          json: resolve,
          error: reject
        };

        _this.transport.emit(_enum.TransportEvent.TRANSPORT_REQUEST, req, res);
      });
    }
  }, {
    key: "startWatch",
    value: function startWatch() {
      if (this.watch) return;

      _get(_getPrototypeOf(ProcessClient.prototype), "startWatch", this).call(this);

      this.transport.getBackend().on(_enum.TransportEvent.WATCH_RESPONSE, this.watchListener);
    }
  }, {
    key: "stopWatch",
    value: function stopWatch() {
      _get(_getPrototypeOf(ProcessClient.prototype), "stopWatch", this).call(this);

      this.transport.getBackend.removeListener(_enum.TransportEvent.WATCH_RESPONSE, this.watchListener);
    }
  }, {
    key: "requestWatch",
    value: function requestWatch() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          tag = _ref.tag,
          collection = _ref.collection,
          entityId = _ref.entityId,
          filter = _ref.filter;

      if (!this.watch) throw new Error('Watch is not enabled');
      this.transport.getBackend().emit(_enum.TransportEvent.WATCH_REQUEST, {
        tag: tag,
        collection: collection,
        entityId: entityId,
        filter: filter,
        id: this.getId()
      });
    }
  }, {
    key: "requestUnwatch",
    value: function requestUnwatch() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          tag = _ref2.tag,
          collection = _ref2.collection,
          entityId = _ref2.entityId,
          filter = _ref2.filter;

      if (!this.watch) throw new Error('Watch is not enabled');
      this.transport.getBackend().emit(_enum.TransportEvent.WATCH_REQUEST, {
        tag: tag,
        collection: collection,
        entityId: entityId,
        filter: filter,
        id: this.getId()
      });
    }
  }]);

  return ProcessClient;
}(_baseClient.default);

exports.default = ProcessClient;