"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _zeronode = require("zeronode");

var _baseClient = _interopRequireDefault(require("./baseClient"));

var _enum = require("../enum");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ZeronodeClient =
/*#__PURE__*/
function (_BaseClient) {
  _inherits(ZeronodeClient, _BaseClient);

  function ZeronodeClient() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        host = _ref.host,
        port = _ref.port,
        token = _ref.token,
        config = _ref.config,
        id = _ref.id;

    _classCallCheck(this, ZeronodeClient);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ZeronodeClient).call(this, {
      id: id,
      token: token
    }));
    _this.host = host.replace(/http(s?):\/\//, '');
    _this.port = port;
    _this.node = new _zeronode.Node();
    _this.node = new _zeronode.Node({
      id: id,
      config: config
    });

    _this.setId(_this.node.getId());

    return _this;
  }

  _createClass(ZeronodeClient, [{
    key: "connect",
    value: function () {
      var _connect = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(credentials, masterKey) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.node.connect({
                  address: "tcp://".concat(this.host, ":").concat(this.port)
                });

              case 2:
                _context.next = 4;
                return this.auth(credentials, masterKey);

              case 4:
                _context.next = 6;
                return this.node.setOptions(Object.assign(this.node.getOptions(), {
                  token: this.getHeaders().token
                }));

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function connect(_x, _x2) {
        return _connect.apply(this, arguments);
      }

      return connect;
    }()
  }, {
    key: "request",
    value: function request(entityAction) {
      var action = entityAction.action,
          collection = entityAction.collection,
          payload = entityAction.payload,
          tag = entityAction.tag,
          auth = entityAction.auth;
      var response = this.node.requestAny({
        event: action,
        data: {
          headers: _objectSpread({}, this.getHeaders(), {
            action: action,
            collection: collection,
            tag: tag
          }),
          payload: payload,
          auth: auth
        }
      });
      if (response && response.error) throw response;
      return response;
    }
  }, {
    key: "startWatch",
    value: function startWatch() {
      _get(_getPrototypeOf(ZeronodeClient.prototype), "startWatch", this).call(this);

      this.node.onTick(_enum.TransportEvent.WATCH_RESPONSE, this.watchListener);
    }
  }, {
    key: "stopWatch",
    value: function stopWatch() {
      _get(_getPrototypeOf(ZeronodeClient.prototype), "stopWatch", this).call(this);

      this.node.offTick(_enum.TransportEvent.WATCH_RESPONSE, this.watchListener);
    }
  }, {
    key: "requestWatch",
    value: function () {
      var _requestWatch = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var _ref2,
            tag,
            collection,
            entityId,
            filter,
            options,
            _args2 = arguments;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _ref2 = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : {}, tag = _ref2.tag, collection = _ref2.collection, entityId = _ref2.entityId, filter = _ref2.filter;
                options = this.node.getOptions();

                if (!options.watch) {
                  options.watch = [];
                }

                if (!collection) {
                  options.watch.indexOf(_enum.ALL_COLLECTIONS) === -1 && options.watch.push(_enum.ALL_COLLECTIONS);
                } else if (!entityId) {
                  options.watch.indexOf("".concat(tag, ":").concat(collection)) === -1 && options.watch.push("".concat(tag, ":").concat(collection));
                } else {
                  options.watch.indexOf("".concat(tag, ":").concat(collection, ":").concat(entityId)) === -1 && options.watch.push("".concat(tag, ":").concat(collection, ":").concat(entityId));
                }

                _context2.next = 6;
                return this.node.setOptions(options);

              case 6:
                this.node.tickAll({
                  event: _enum.TransportEvent.WATCH_REQUEST,
                  data: {
                    tag: tag,
                    collection: collection,
                    entityId: entityId,
                    filter: filter
                  }
                });

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function requestWatch() {
        return _requestWatch.apply(this, arguments);
      }

      return requestWatch;
    }()
  }, {
    key: "requestUnwatch",
    value: function () {
      var _requestUnwatch = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3() {
        var _ref3,
            tag,
            collection,
            entityId,
            filter,
            options,
            index,
            _args3 = arguments;

        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _ref3 = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {}, tag = _ref3.tag, collection = _ref3.collection, entityId = _ref3.entityId, filter = _ref3.filter;
                options = this.node.getOptions();

                if (!options.watch) {
                  options.watch = [];
                }

                index = -1;

                if (!collection) {
                  index = options.watch.indexOf(_enum.ALL_COLLECTIONS);
                  index !== -1 && options.watch.splice(index, 1);
                } else if (!entityId) {
                  index = options.watch.indexOf("".concat(tag, ":").concat(collection));
                  index !== -1 && options.watch.splice(index, 1);
                } else {
                  index = options.watch.indexOf("".concat(tag, ":").concat(collection, ":").concat(entityId));
                  index !== -1 && options.watch.splice(index, 1);
                }

                _context3.next = 7;
                return this.node.setOptions(options);

              case 7:
                this.node.tickAll({
                  event: _enum.TransportEvent.UNWATCH_REQUEST,
                  data: {
                    tag: tag,
                    collection: collection,
                    entityId: entityId,
                    filter: filter
                  }
                });

              case 8:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function requestUnwatch() {
        return _requestUnwatch.apply(this, arguments);
      }

      return requestUnwatch;
    }()
  }]);

  return ZeronodeClient;
}(_baseClient.default);

exports.default = ZeronodeClient;