"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _events = _interopRequireDefault(require("events"));

var _helpers = require("./utils/helpers");

var _enum = require("./enum");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function Enumerable(arr) {
  arr.value = function () {
    return _lodash.default.map(this, function (entity) {
      return entity.value();
    });
  };

  return arr;
}

function _handleWatch(_ref) {
  var _this = this;

  var action = _ref.action,
      data = _ref.data,
      collection = _ref.collection,
      tag = _ref.tag;

  try {
    var isInstance = false;

    if (this instanceof Entity) {
      isInstance = true;
    }

    if (collection !== this.collection || tag !== this.tag || action !== _enum.WatchActions.CUSTOM && isInstance && data[this.idField] !== this.get(this.idField)) return;
    var emitter = isInstance ? this : this.watchEvents;

    switch (action) {
      case _enum.WatchActions.CREATE:
        if (isInstance) return;
        var newEntity = new this({
          object: data
        });
        emitter.emit(_enum.WatchActions.CREATE, newEntity);
        break;

      case _enum.WatchActions.UPDATE:
        if (isInstance && this.autoSyncStatus) {
          if (data.set) {
            this.savedObject = (0, _helpers.deepestClone)(data.set);
          }

          Object.assign(this.savedObject, data.update);

          _lodash.default.each(data.remove, function (ign, key) {
            delete _this.savedObject[key];
          });
        }

        emitter.emit(_enum.WatchActions.UPDATE, data);
        break;

      case _enum.WatchActions.DELETE:
        emitter.emit(_enum.WatchActions.DELETE, _objectSpread({}, data, _defineProperty({}, this.idField, data[this.idField])));
        break;

      case _enum.WatchActions.CUSTOM:
        emitter.emit(_enum.WatchActions.CUSTOM, data);
    }
  } catch (err) {
    console.error('Error while handling watch', err);
  }
}

var Entity =
/*#__PURE__*/
function (_EventEmitter) {
  _inherits(Entity, _EventEmitter);

  _createClass(Entity, null, [{
    key: "generateClass",
    value: function generateClass(transport, collection) {
      var tag = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _enum.DEFAULT_TAG;
      var client = transport.getClient();
      var entityInfo = client.getEntity({
        tag: tag,
        collection: collection
      });
      if (!entityInfo) throw new Error('this transports client doesn\'t support this entity');
      var idField = entityInfo.idField,
          schema = entityInfo.schema;

      var EntityClass =
      /*#__PURE__*/
      function (_this3) {
        _inherits(EntityClass, _this3);

        function EntityClass(_ref2) {
          var object = _ref2.object;

          _classCallCheck(this, EntityClass);

          return _possibleConstructorReturn(this, _getPrototypeOf(EntityClass).call(this, {
            object: object,
            transport: transport,
            collection: collection,
            idField: idField,
            tag: tag,
            watchStatus: EntityClass.watchStatus,
            autoSyncStatus: EntityClass.autoSyncStatus
          }));
        }

        return EntityClass;
      }(this);

      Object.defineProperty(EntityClass, 'transport', {
        configurable: false,
        writable: false,
        value: transport
      });
      Object.defineProperty(EntityClass, 'client', {
        configurable: false,
        writable: false,
        value: transport.getClient()
      });
      Object.defineProperty(EntityClass, 'collection', {
        configurable: false,
        writable: false,
        value: collection
      });
      Object.defineProperty(EntityClass, 'idField', {
        configurable: false,
        writable: false,
        value: idField
      });
      Object.defineProperty(EntityClass, 'tag', {
        configurable: false,
        writable: false,
        value: tag
      });
      Object.defineProperty(EntityClass, 'handleWatch', {
        configurable: false,
        writable: false,
        value: _handleWatch.bind(EntityClass)
      });
      Object.defineProperty(EntityClass, 'watchEvents', {
        configurable: false,
        writable: false,
        value: new _events.default()
      });
      Object.defineProperty(EntityClass, 'schema', {
        configurable: true,
        writable: false,
        value: schema
      });
      return EntityClass;
    }
  }]);

  function Entity() {
    var _context;

    var _this2;

    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        object = _ref3.object,
        collection = _ref3.collection,
        transport = _ref3.transport,
        client = _ref3.client,
        idField = _ref3.idField,
        tag = _ref3.tag,
        autoSyncStatus = _ref3.autoSyncStatus,
        watchStatus = _ref3.watchStatus;

    _classCallCheck(this, Entity);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(Entity).call(this));
    _this2.object = (0, _helpers.deepestClone)(object);
    _this2.collection = collection;
    _this2.savedObject = (0, _helpers.deepestClone)(object);
    _this2.transport = transport;
    _this2.client = client;
    _this2.idField = idField;
    _this2.tag = tag;
    _this2.handleWatch = (_context = _assertThisInitialized(_this2), _handleWatch).bind(_context);
    _this2.autoSyncStatus = !!autoSyncStatus; // this.constructor.watchEvents.on(EntityInnerEvents.START_WATCH, this::this.startWatch)
    // this.constructor.watchEvents.on(EntityInnerEvents.STOP_WATCH, this::this.stopWatch)
    // this.constructor.watchEvents.on(EntityInnerEvents.AUTO_SYNC, this::this.autoSync)
    // console.log('watch status:::', watchStatus);
    // if (watchStatus) this.startWatch()

    return _this2;
  }

  _createClass(Entity, [{
    key: "getIdProp",
    value: function getIdProp() {
      return this.idField;
    }
  }, {
    key: "getId",
    value: function getId() {
      return this.get(this.getIdProp());
    }
    /** Actions */

  }, {
    key: "get",
    value: function get(key) {
      var object = this.object;
      return object[key];
    }
  }, {
    key: "value",
    value: function value() {
      var object = this.object;
      return object;
    }
  }, {
    key: "isDirty",
    value: function isDirty() {
      var object = this.object,
          savedObject = this.savedObject;
      return !!(0, _helpers.difference)(object, savedObject).length;
    }
    /** Setters */

  }, {
    key: "set",
    value: function set(key, value) {
      var object = this.object;

      if (_lodash.default.isString(key)) {
        object[key] = value;
        return;
      }

      if (_lodash.default.isObject(key)) {
        _lodash.default.each(key, function (val, _key) {
          object[_key] = val;
        });

        return;
      }

      throw new Error('Unsupported type for first argument');
    }
  }, {
    key: "unset",
    value: function unset(key) {
      var object = this.object;
      if (!_lodash.default.isString(key) || !_lodash.default.isArray(key)) throw new Error('Unsupported type for first argument - should be String or Array');
      var keys = _lodash.default.isString(key) ? [key] : key;

      _lodash.default.each(keys, function (key) {
        delete object[key];
      });
    }
  }, {
    key: "reset",
    value: function reset(key) {
      var object = this.object,
          savedObject = this.savedObject;
      if (!_lodash.default.isString(key) || !_lodash.default.isArray(key)) throw new Error('Unsupported type for first argument - should be String or Array');
      var keys = _lodash.default.isString(key) ? [key] : key;

      _lodash.default.each(keys, function (key, value) {
        object[key] = savedObject[key];
      });
    }
    /** Instance Actions */

  }, {
    key: "save",
    value: function () {
      var _save = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var full,
            object,
            savedObject,
            update,
            idProp,
            id,
            _args = arguments;
        return _regenerator.default.wrap(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                full = _args.length > 0 && _args[0] !== undefined ? _args[0] : false;
                object = this.object, savedObject = this.savedObject;
                update = full ? object : (0, _helpers.difference)(object, savedObject); // let dontHaveAccess = _.find(update, (value, key) => {
                //   return !this.constructor.schema.hasOwnProperty(key)
                // })
                //
                // if (dontHaveAccess) throw new Error('don\'t have access to update some keys.')
                // ** AVAR::NOTE removing the idProp from the update payload
                // ** i.e in mongo we need that

                idProp = this.getIdProp();
                delete update[idProp];
                id = this.getId();
                _context2.next = 8;
                return id ? this.constructor.updateById(id, update) : this.constructor.create(update);

              case 8:
                object = _context2.sent;
                this.savedObject = (0, _helpers.deepestClone)(object.value());
                this.object = (0, _helpers.deepestClone)(object.value());
                return _context2.abrupt("return", this);

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee, this);
      }));

      function save() {
        return _save.apply(this, arguments);
      }

      return save;
    }()
  }, {
    key: "remove",
    value: function () {
      var _remove = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2() {
        var id;
        return _regenerator.default.wrap(function _callee2$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                id = this.getId();
                return _context3.abrupt("return", this.constructor.removeById(id));

              case 2:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee2, this);
      }));

      function remove() {
        return _remove.apply(this, arguments);
      }

      return remove;
    }()
  }, {
    key: "runCommand",
    value: function () {
      var _runCommand = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(command, payload) {
        return _regenerator.default.wrap(function _callee3$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt("return", this.constructor.runCommand(command, payload));

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee3, this);
      }));

      function runCommand(_x, _x2) {
        return _runCommand.apply(this, arguments);
      }

      return runCommand;
    }()
  }, {
    key: "sync",
    value: function () {
      var _sync = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4(select) {
        var object, updatedObject;
        return _regenerator.default.wrap(function _callee4$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                object = this.object;
                _context5.next = 3;
                return this.constructor.loadById(this.getId(), select);

              case 3:
                updatedObject = _context5.sent;

                if (select) {
                  Object.assign(object, updatedObject.value());
                } else {
                  this.object = updatedObject.value();
                }

                this.savedObject = (0, _helpers.deepestClone)(object);

              case 6:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee4, this);
      }));

      function sync(_x3) {
        return _sync.apply(this, arguments);
      }

      return sync;
    }()
  }, {
    key: "startWatch",
    value: function () {
      var _startWatch = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5() {
        return _regenerator.default.wrap(function _callee5$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.constructor.client.startWatch();

              case 2:
                this.constructor.client.removeListener(_enum.TransportEvent.WATCH_RESPONSE, this.handleWatch);
                this.constructor.client.on(_enum.TransportEvent.WATCH_RESPONSE, this.handleWatch);

              case 4:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee5, this);
      }));

      function startWatch() {
        return _startWatch.apply(this, arguments);
      }

      return startWatch;
    }()
  }, {
    key: "stopWatch",
    value: function () {
      var _stopWatch = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee6() {
        return _regenerator.default.wrap(function _callee6$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                this.constructor.client.removeListener(_enum.TransportEvent.WATCH_RESPONSE, this.handleWatch);

              case 1:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee6, this);
      }));

      function stopWatch() {
        return _stopWatch.apply(this, arguments);
      }

      return stopWatch;
    }()
  }, {
    key: "autoSync",
    value: function autoSync(status) {
      this.autoSyncStatus = !!status;
    }
  }, {
    key: "watch",
    value: function watch() {
      return this.constructor.watch({
        id: this.getId()
      });
    }
  }, {
    key: "unwatch",
    value: function unwatch() {
      return this.constructor.unwatch({
        id: this.getId()
      });
    } // ** STATIC ACTIONS
    // ** CREATE

  }], [{
    key: "create",
    value: function () {
      var _create = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee7(payload) {
        var collection, transport, client, idField, tag, entityAction, object;
        return _regenerator.default.wrap(function _callee7$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                collection = this.collection, transport = this.transport, client = this.client, idField = this.idField, tag = this.tag;
                entityAction = this.createAction({
                  action: _enum.EntityAction.CREATE,
                  payload: payload
                });
                _context8.next = 4;
                return client.request(entityAction);

              case 4:
                object = _context8.sent;
                return _context8.abrupt("return", new this({
                  object: object
                }));

              case 6:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee7, this);
      }));

      function create(_x4) {
        return _create.apply(this, arguments);
      }

      return create;
    }() // ** LOAD DATA
    // ** NOTE::AVAR id could be a String or Array of ids

  }, {
    key: "loadById",
    value: function () {
      var _loadById = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee8(id, select) {
        var _this4 = this;

        var collection, transport, client, idField, tag, entityAction, docs, entities;
        return _regenerator.default.wrap(function _callee8$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                collection = this.collection, transport = this.transport, client = this.client, idField = this.idField, tag = this.tag;
                entityAction = this.createAction({
                  action: _enum.EntityAction.LOAD_BY_ID,
                  payload: {
                    query: {
                      id: id
                    },
                    select: select
                  }
                });
                _context9.next = 4;
                return client.request(entityAction);

              case 4:
                docs = _context9.sent;
                docs = _lodash.default.isArray(docs) ? docs : docs ? [docs] : [];
                entities = _lodash.default.map(docs, function (object) {
                  return new _this4({
                    object: object
                  });
                });
                return _context9.abrupt("return", _lodash.default.isArray(id) ? Enumerable(entities) : entities[0]);

              case 8:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee8, this);
      }));

      function loadById(_x5, _x6) {
        return _loadById.apply(this, arguments);
      }

      return loadById;
    }()
  }, {
    key: "loadAll",
    value: function () {
      var _loadAll = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee9(select) {
        var _this5 = this;

        var collection, transport, client, idField, tag, entityAction, docs;
        return _regenerator.default.wrap(function _callee9$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                collection = this.collection, transport = this.transport, client = this.client, idField = this.idField, tag = this.tag;
                entityAction = this.createAction({
                  action: _enum.EntityAction.LOAD_ALL,
                  payload: {
                    select: select
                  }
                });
                _context10.next = 4;
                return client.request(entityAction);

              case 4:
                docs = _context10.sent;
                return _context10.abrupt("return", Enumerable(_lodash.default.map(docs, function (object) {
                  return new _this5({
                    object: object
                  });
                })));

              case 6:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee9, this);
      }));

      function loadAll(_x7) {
        return _loadAll.apply(this, arguments);
      }

      return loadAll;
    }()
  }, {
    key: "loadByQuery",
    value: function () {
      var _loadByQuery = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee10() {
        var _this6 = this;

        var _ref4,
            query,
            select,
            limit,
            skip,
            sort,
            options,
            collection,
            transport,
            client,
            idField,
            tag,
            entityAction,
            docs,
            _args10 = arguments;

        return _regenerator.default.wrap(function _callee10$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _ref4 = _args10.length > 0 && _args10[0] !== undefined ? _args10[0] : {};
                query = _ref4.query, select = _ref4.select, limit = _ref4.limit, skip = _ref4.skip, sort = _ref4.sort, options = _objectWithoutProperties(_ref4, ["query", "select", "limit", "skip", "sort"]);
                collection = this.collection, transport = this.transport, client = this.client, idField = this.idField, tag = this.tag;
                entityAction = this.createAction({
                  action: _enum.EntityAction.LOAD_BY_QUERY,
                  payload: {
                    query: query,
                    select: select,
                    limit: limit,
                    skip: skip,
                    sort: sort,
                    options: options
                  }
                });
                _context11.next = 6;
                return client.request(entityAction);

              case 6:
                docs = _context11.sent;
                return _context11.abrupt("return", Enumerable(_lodash.default.map(docs, function (object) {
                  return new _this6({
                    object: object
                  });
                })));

              case 8:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee10, this);
      }));

      function loadByQuery() {
        return _loadByQuery.apply(this, arguments);
      }

      return loadByQuery;
    }()
  }, {
    key: "loadOne",
    value: function () {
      var _loadOne = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee11() {
        var _ref5,
            query,
            select,
            collection,
            transport,
            client,
            idField,
            tag,
            entityAction,
            object,
            _args11 = arguments;

        return _regenerator.default.wrap(function _callee11$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _ref5 = _args11.length > 0 && _args11[0] !== undefined ? _args11[0] : {}, query = _ref5.query, select = _ref5.select;
                collection = this.collection, transport = this.transport, client = this.client, idField = this.idField, tag = this.tag;
                entityAction = this.createAction({
                  action: _enum.EntityAction.LOAD_ONE,
                  payload: {
                    query: query,
                    select: select
                  }
                });
                _context12.next = 5;
                return client.request(entityAction);

              case 5:
                object = _context12.sent;
                return _context12.abrupt("return", object ? new this({
                  object: object
                }) : null);

              case 7:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee11, this);
      }));

      function loadOne() {
        return _loadOne.apply(this, arguments);
      }

      return loadOne;
    }()
  }, {
    key: "count",
    value: function () {
      var _count = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee12() {
        var query,
            client,
            entityAction,
            resp,
            _args12 = arguments;
        return _regenerator.default.wrap(function _callee12$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                query = _args12.length > 0 && _args12[0] !== undefined ? _args12[0] : {};
                client = this.client;
                entityAction = this.createAction({
                  action: _enum.EntityAction.COUNT,
                  payload: {
                    query: query
                  }
                });
                _context13.next = 5;
                return client.request(entityAction);

              case 5:
                resp = _context13.sent;
                return _context13.abrupt("return", resp || 0);

              case 7:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee12, this);
      }));

      function count() {
        return _count.apply(this, arguments);
      }

      return count;
    }() // ** UPDATE DATA

  }, {
    key: "updateById",
    value: function () {
      var _updateById = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee13(id, update) {
        var collection, transport, client, idField, tag, entityAction, object;
        return _regenerator.default.wrap(function _callee13$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                collection = this.collection, transport = this.transport, client = this.client, idField = this.idField, tag = this.tag; // let dontHaveAccess = _.find(update, (value, key) => {
                //   return !this.schema.hasOwnProperty(key)
                // })
                //
                // if (dontHaveAccess) throw new Error('don\'t have access to update some keys.')

                entityAction = this.createAction({
                  action: _enum.EntityAction.UPDATE_BY_ID,
                  payload: {
                    query: {
                      id: id
                    },
                    update: update
                  }
                });
                _context14.next = 4;
                return client.request(entityAction);

              case 4:
                object = _context14.sent;
                return _context14.abrupt("return", new this({
                  object: object
                }));

              case 6:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee13, this);
      }));

      function updateById(_x8, _x9) {
        return _updateById.apply(this, arguments);
      }

      return updateById;
    }() // ** update with the entity data

  }, {
    key: "update",
    value: function () {
      var _update2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee14(query, _update) {
        var collection, transport, client, idField, tag, entityAction;
        return _regenerator.default.wrap(function _callee14$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                collection = this.collection, transport = this.transport, client = this.client, idField = this.idField, tag = this.tag; // let dontHaveAccess = _.find(update, (value, key) => {
                //   return !this.schema.hasOwnProperty(key)
                // })
                //
                // if (dontHaveAccess) throw new Error('don\'t have access to update some keys.')

                entityAction = this.createAction({
                  action: _enum.EntityAction.UPDATE,
                  payload: {
                    query: query,
                    update: _update
                  }
                });
                _context15.next = 4;
                return client.request(entityAction);

              case 4:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee14, this);
      }));

      function update(_x10, _x11) {
        return _update2.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "incrementById",
    value: function () {
      var _incrementById = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee15(id, bins) {
        var entityAction;
        return _regenerator.default.wrap(function _callee15$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                entityAction = this.createAction({
                  action: _enum.EntityAction.INCREMENT_BY_ID,
                  payload: {
                    query: {
                      id: id
                    },
                    bins: bins
                  }
                });
                return _context16.abrupt("return", this.client.request(entityAction));

              case 2:
              case "end":
                return _context16.stop();
            }
          }
        }, _callee15, this);
      }));

      function incrementById(_x12, _x13) {
        return _incrementById.apply(this, arguments);
      }

      return incrementById;
    }() // ** REMOVE DATA
    // ** id is string or an array

  }, {
    key: "removeById",
    value: function () {
      var _removeById = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee16(id) {
        var entityAction;
        return _regenerator.default.wrap(function _callee16$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                entityAction = this.createAction({
                  action: _enum.EntityAction.REMOVE_BY_ID,
                  payload: {
                    query: {
                      id: id
                    }
                  }
                });
                return _context17.abrupt("return", this.client.request(entityAction));

              case 2:
              case "end":
                return _context17.stop();
            }
          }
        }, _callee16, this);
      }));

      function removeById(_x14) {
        return _removeById.apply(this, arguments);
      }

      return removeById;
    }()
  }, {
    key: "removeByQuery",
    value: function () {
      var _removeByQuery = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee17(query) {
        var entityAction;
        return _regenerator.default.wrap(function _callee17$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                entityAction = this.createAction({
                  action: _enum.EntityAction.REMOVE_BY_QUERY,
                  payload: {
                    query: query
                  }
                });
                return _context18.abrupt("return", this.client.request(entityAction));

              case 2:
              case "end":
                return _context18.stop();
            }
          }
        }, _callee17, this);
      }));

      function removeByQuery(_x15) {
        return _removeByQuery.apply(this, arguments);
      }

      return removeByQuery;
    }()
  }, {
    key: "runCommand",
    value: function () {
      var _runCommand2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee18(command, data) {
        var entityAction;
        return _regenerator.default.wrap(function _callee18$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                entityAction = this.createAction({
                  action: _enum.EntityAction.RUN_COMMAND,
                  payload: {
                    command: command,
                    data: data
                  }
                });
                return _context19.abrupt("return", this.client.request(entityAction));

              case 2:
              case "end":
                return _context19.stop();
            }
          }
        }, _callee18, this);
      }));

      function runCommand(_x16, _x17) {
        return _runCommand2.apply(this, arguments);
      }

      return runCommand;
    }()
  }, {
    key: "createAction",
    value: function createAction() {
      var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          action = _ref6.action,
          payload = _ref6.payload;

      var collection = this.collection;
      return {
        action: action,
        collection: collection,
        payload: payload,
        tag: this.tag
      };
    }
  }, {
    key: "watch",
    value: function watch() {
      var _this7 = this;

      var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          id = _ref7.id;

      this.client.once(_enum.SocketEvents.RECONNECT, function () {
        _this7.watch({
          id: id
        });
      });
      return this.client.requestWatch({
        collection: this.collection,
        entityId: id,
        tag: this.tag
      });
    }
  }, {
    key: "unwatch",
    value: function unwatch() {
      var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          id = _ref8.id;

      return this.client.requestUnwatch({
        collection: this.collection,
        entityId: id,
        tag: this.tag
      });
    }
  }, {
    key: "startWatch",
    value: function () {
      var _startWatch2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee19() {
        return _regenerator.default.wrap(function _callee19$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                _context20.next = 2;
                return this.client.startWatch();

              case 2:
                this.client.removeListener(_enum.TransportEvent.WATCH_RESPONSE, this.handleWatch);
                this.client.on(_enum.TransportEvent.WATCH_RESPONSE, this.handleWatch);
                this.watchEvents.emit(_enum.EntityInnerEvents.START_WATCH, true);
                this.watchStatus = true;

              case 6:
              case "end":
                return _context20.stop();
            }
          }
        }, _callee19, this);
      }));

      function startWatch() {
        return _startWatch2.apply(this, arguments);
      }

      return startWatch;
    }()
  }, {
    key: "autoSync",
    value: function autoSync(status) {
      this.autoSyncStatus = !!status;
      this.watchEvents.emit(_enum.EntityInnerEvents.AUTO_SYNC, status);
    }
  }, {
    key: "stopWatch",
    value: function () {
      var _stopWatch2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee20() {
        return _regenerator.default.wrap(function _callee20$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                this.client.removeListener(_enum.TransportEvent.WATCH_RESPONSE, this.handleWatch);
                this.watchEvents.emit(_enum.EntityInnerEvents.STOP_WATCH, true);
                this.watchStatus = false;

              case 3:
              case "end":
                return _context21.stop();
            }
          }
        }, _callee20, this);
      }));

      function stopWatch() {
        return _stopWatch2.apply(this, arguments);
      }

      return stopWatch;
    }()
  }]);

  return Entity;
}(_events.default);

exports.default = Entity;
;