"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NODE_STATUSES = exports.EntityAction = exports.EntityInnerEvents = exports.JWT_SECRET = exports.WRITE = exports.READ = exports.ALL_COLLECTIONS = exports.DEFAULT_TAG = exports.NEW_ENTITY = exports.WatchActions = exports.SocketEvents = exports.TransportEvent = exports.HttpHeaders = void 0;
var HttpHeaders = {
  ACTION: 'WIRENTITY-ACTION',
  COLLECTION: 'WIRENTITY-COLLECTION',
  TAG: 'WIRENTITY-TAG',
  AUTHORIZATION: 'Authorization'
};
exports.HttpHeaders = HttpHeaders;
var TransportEvent = {
  TRANSPORT_REQUEST: 'WIRENTITY_TRANSPORT_REQUEST',
  WATCH_REQUEST: 'WIRENTITY_WATCH_REQUEST',
  UNWATCH_REQUEST: 'WIRENTITY_UNWATCH_REQUEST',
  PROXY_WATCH_REQUEST: 'WIRENTITY_PROXY_WATCH_REQUEST',
  PROXY_UNWATCH_REQUEST: 'WIRENTITY_PROXY_UNWATCH_REQUEST',
  WATCH_ACTION: 'WIRENTITY_WATCH_ACTION',
  WATCH_RESPONSE: 'WIRENTITY_WATCH_RESPONSE',
  REINITIALIZE_WATCH: 'REINITIALIZE_WATCH'
};
exports.TransportEvent = TransportEvent;
var SocketEvents = {
  CONNECT: 'connect',
  CONNECT_ERROR: 'connect_error',
  DISCONNECT: 'disconnect',
  RECONNECT_ATTEMPT: 'reconnect_attempt',
  RECONNECT: 'reconnect',
  ERROR: 'error'
};
exports.SocketEvents = SocketEvents;
var WatchActions = {
  DELETE: 'ENTITY_DELETE',
  UPDATE: 'ENTITY_UPDATE',
  CREATE: 'ENTITY_CREATE',
  CUSTOM: 'ENTITY_CUSTOM',
  NEW_ENTITY: 'NEW_ENTITY',
  // this one is for syncing new entities(collections) in clients.
  NEW_RULE: 'NEW_RULE'
};
exports.WatchActions = WatchActions;
var NEW_ENTITY = 'newEntity'; // deprecated will remove soon

exports.NEW_ENTITY = NEW_ENTITY;
var DEFAULT_TAG = 'wirentity';
exports.DEFAULT_TAG = DEFAULT_TAG;
var ALL_COLLECTIONS = '*';
exports.ALL_COLLECTIONS = ALL_COLLECTIONS;
var READ = 'read';
exports.READ = READ;
var WRITE = 'write';
exports.WRITE = WRITE;
var JWT_SECRET = 'Hid2iuVzznA7iSv5qIA6Diu5opVEsyMa';
exports.JWT_SECRET = JWT_SECRET;
var EntityInnerEvents = {
  START_WATCH: 'entityStartWatch',
  STOP_WATCH: 'entityStopWatch',
  AUTO_SYNC: 'entityAutoSync'
};
exports.EntityInnerEvents = EntityInnerEvents;
var EntityAction = {
  CREATE: 'create',
  LOAD_BY_ID: 'loadById',
  LOAD_ALL: 'loadAll',
  LOAD_BY_QUERY: 'loadByQuery',
  LOAD_ONE: 'loadOne',
  COUNT: 'count',
  UPDATE_BY_ID: 'updateById',
  UPDATE: 'update',
  REMOVE_BY_ID: 'removeById',
  REMOVE_BY_QUERY: 'removeByQuery',
  RUN_COMMAND: 'runCommand',
  AUTH: 'auth',
  FETCH_ENTITIES: 'fetchEntities',
  DEFINE_RULE: 'defineRule',
  REMOVE_RULE: 'removeRule',
  GET_RULES: 'getRules',
  PING: 'PING'
};
exports.EntityAction = EntityAction;
var NODE_STATUSES = {
  STARTED: 'started'
};
exports.NODE_STATUSES = NODE_STATUSES;