"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _baseBackend = _interopRequireDefault(require("../backends/baseBackend"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var customBackends = {};

var BackendFactory =
/*#__PURE__*/
function () {
  function BackendFactory() {
    _classCallCheck(this, BackendFactory);
  }

  _createClass(BackendFactory, null, [{
    key: "create",
    value: function create(transportType, transportOptions) {
      switch (transportType) {
        case BackendFactory.HTTP:
          var HttpBackend = require('../backends/httpBackend').default;

          return new HttpBackend(transportOptions);

        case BackendFactory.ZERONODE:
          var ZeroBackend = require('../backends/zeronodeBackend').default;

          return new ZeroBackend(transportOptions);

        case BackendFactory.KITOO:
          var KitooBackend = require('../backends/kitooBackend').default;

          return new KitooBackend(transportOptions);

        case BackendFactory.MONGO:
          var MongoBackend = require('../backends/mongoBackend').default;

          return new MongoBackend(transportOptions);

        case BackendFactory.AERO:
          var AeroBackend = require('../backends/aerospikeBackend').default;

          return new AeroBackend(transportOptions);

        case BackendFactory.SEQUELIZE:
          var SequelizeBackend = require('../backends/sequelizeBackend').default;

          return new SequelizeBackend(transportOptions);

        default:
          var CustomBackend = customBackends[transportType];

          var ProcessBackend = require('../backends/processBackend').default;

          return CustomBackend ? new CustomBackend(transportOptions) : new ProcessBackend(transportOptions);
      }
    }
  }, {
    key: "inject",
    value: function inject(_ref) {
      var type = _ref.type,
          Backend = _ref.Backend;
      if (!(Backend.prototype instanceof _baseBackend.default)) throw new Error('Backend must be inherited from BaseBackend');
      customBackends[type] = Backend;
    }
  }]);

  return BackendFactory;
}();

exports.default = BackendFactory;
BackendFactory.HTTP = 'HTTP';
BackendFactory.ZERONODE = 'ZERONODE';
BackendFactory.KITOO = 'KITOO';
BackendFactory.MONGO = 'MONGO';
BackendFactory.AERO = 'AERO';
BackendFactory.SEQUELIZE = 'SEQUELIZE';
BackendFactory.PROCESS = 'PROCESS';