"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _baseClient = _interopRequireDefault(require("../clients/baseClient"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var customClients = {};

var ClientFactory =
/*#__PURE__*/
function () {
  function ClientFactory() {
    _classCallCheck(this, ClientFactory);
  }

  _createClass(ClientFactory, null, [{
    key: "create",
    value: function create(transportType, transportOptions) {
      switch (transportType) {
        case ClientFactory.HTTP:
          var HttpClient = require('../clients/httpClient').default;

          return new HttpClient(transportOptions);

        case ClientFactory.ZERONODE:
          var ZeroClient = require('../clients/zeronodeClient').default;

          return new ZeroClient(transportOptions);

        case ClientFactory.KITOO:
          var KitooClient = require('../clients/kitooClient').default;

          return new KitooClient(transportOptions);

        case ClientFactory.MONGO:
          var MongoClient = require('../clients/mongoClient').default;

          return new MongoClient(transportOptions);

        case ClientFactory.AERO:
          var AeroClient = require('../clients/aerospikeClient').default;

          return new AeroClient(transportOptions);

        case ClientFactory.SEQUELIZE:
          var SequelizeClient = require('../clients/sequelizeClient').default;

          return new SequelizeClient(transportOptions);

        default:
          var CustomClient = customClients[transportType];

          var ProcessClient = require('../clients/processClient').default;

          return CustomClient ? new CustomClient(transportOptions) : new ProcessClient(transportOptions);
      }
    }
  }, {
    key: "inject",
    value: function inject(_ref) {
      var type = _ref.type,
          Client = _ref.Client;
      if (!(Client.prototype instanceof _baseClient.default)) throw new Error('Client must be inherited from BaseClient');
      customClients[type] = Client;
    }
  }]);

  return ClientFactory;
}();

exports.default = ClientFactory;
ClientFactory.HTTP = 'HTTP';
ClientFactory.ZERONODE = 'ZERONODE';
ClientFactory.KITOO = 'KITOO';
ClientFactory.MONGO = 'MONGO';
ClientFactory.AERO = 'AERO';
ClientFactory.SEQUELIZE = 'SEQUELIZE';
ClientFactory.PROCESS = 'PROCESS';