"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _events = _interopRequireDefault(require("events"));

var _shortid = _interopRequireDefault(require("shortid"));

var _clientFactory = _interopRequireDefault(require("./clientFactory"));

var _backendFactory = _interopRequireDefault(require("./backendFactory"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var _private = new Map();

var EVENTS = {
  CONNECT: 'connect',
  CREATE: 'create',
  LOAD_BY_ID: 'loadById',
  LOAD_BY_QUERY: 'loadByQuery',
  LOAD_ALL: 'loadAll',
  UPDATE: 'update',
  UPDATE_BY_ID: 'updateById',
  INCREMENT_BY_ID: 'incrementById',
  REMOVE_BY_ID: 'removeById',
  REMOVE_BY_QUERY: 'removeByQuery',
  RUN_COMMAND: 'runCommand'
};
var kitooTransport = null;

var EntityTransport =
/*#__PURE__*/
function (_EventEmitter) {
  _inherits(EntityTransport, _EventEmitter);

  function EntityTransport() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$id = _ref.id,
        id = _ref$id === void 0 ? _shortid.default.generate() : _ref$id,
        transportType = _ref.transportType,
        _ref$force = _ref.force,
        force = _ref$force === void 0 ? false : _ref$force,
        backend = _ref.backend,
        client = _ref.client;

    _classCallCheck(this, EntityTransport);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(EntityTransport).call(this));

    switch (transportType) {
      case _backendFactory.default.KITOO:
        if (force || !kitooTransport) {
          var _scope2 = {
            transportType: transportType,
            client: null,
            backend: null,
            id: id
          };

          _private.set(_assertThisInitialized(_this), _scope2);
        }

        if (force) return _possibleConstructorReturn(_this, _assertThisInitialized(_this));
        if (!kitooTransport) kitooTransport = _assertThisInitialized(_this);
        return _possibleConstructorReturn(_this, kitooTransport);

      default:
        var _scope = {
          transportType: transportType,
          client: client,
          backend: backend,
          id: id
        };

        _private.set(_assertThisInitialized(_this), _scope);

        return _possibleConstructorReturn(_this, _assertThisInitialized(_this));
    }

    return _this;
  }

  _createClass(EntityTransport, [{
    key: "addRoute",
    value: function addRoute(route) {
      var backend = this.getBackend();
      if (!backend) throw new Error('You should bind to backend before adding routes');
      return backend.addRoute(route);
    } // ** AVAR::NOTE transport connect creates the client to use and also connects it if needed

  }, {
    key: "connect",
    value: function () {
      var _connect = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var options,
            credentials,
            masterKey,
            waitToConnect,
            _scope,
            client,
            _args = arguments;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = _args.length > 0 && _args[0] !== undefined ? _args[0] : {};
                credentials = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
                masterKey = _args.length > 2 ? _args[2] : undefined;
                waitToConnect = _args.length > 3 ? _args[3] : undefined;
                // console.log(`AVAR::EntityTransport::${this.transportType}::connect options = `, options)
                _scope = _private.get(this);
                client = _scope.client || _clientFactory.default.create(this.transportType, Object.assign({}, options, {
                  id: this.id
                }));
                client.setTransport(this);
                _context.next = 9;
                return client.connect(credentials, masterKey, waitToConnect);

              case 9:
                _scope.client = client;
                return _context.abrupt("return", _scope.client);

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function connect() {
        return _connect.apply(this, arguments);
      }

      return connect;
    }() // ** AVAR::NOTE transport bind creates the backend also binds it

  }, {
    key: "bind",
    value: function () {
      var _bind = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(options) {
        var _scope, backend;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                // console.log(`AVAR::EntityTransport::${this.transportType}::bind options = `, options)
                _scope = _private.get(this);
                backend = _scope.backend || _backendFactory.default.create(this.transportType, Object.assign({}, options, {
                  id: this.id
                }));
                backend.setTransport(this);
                _context2.next = 5;
                return backend.bind();

              case 5:
                _scope.backend = backend;
                return _context2.abrupt("return", _scope.backend);

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function bind(_x) {
        return _bind.apply(this, arguments);
      }

      return bind;
    }()
  }, {
    key: "getClient",
    value: function getClient() {
      var _private$get = _private.get(this),
          client = _private$get.client;

      return client;
    }
  }, {
    key: "getBackend",
    value: function getBackend() {
      var _private$get2 = _private.get(this),
          backend = _private$get2.backend;

      return backend;
    }
  }, {
    key: "events",
    get: function get() {
      return EVENTS;
    }
  }, {
    key: "id",
    get: function get() {
      return _private.get(this).id;
    }
  }, {
    key: "transportType",
    get: function get() {
      var _private$get3 = _private.get(this),
          transportType = _private$get3.transportType;

      return transportType;
    }
  }, {
    key: "client",
    get: function get() {
      return this.getClient();
    }
  }, {
    key: "backend",
    get: function get() {
      return this.getBackend();
    }
  }], [{
    key: "injectNewTransport",
    value: function injectNewTransport(_ref2) {
      var type = _ref2.type,
          Backend = _ref2.Backend,
          Client = _ref2.Client;

      _backendFactory.default.inject({
        type: type,
        Backend: Backend
      });

      _clientFactory.default.inject({
        type: type,
        Client: Client
      });
    }
  }]);

  return EntityTransport;
}(_events.default);

exports.default = EntityTransport;
EntityTransport.HTTP = 'HTTP';
EntityTransport.ZERONODE = 'ZERONODE';
EntityTransport.KITOO = 'KITOO';
EntityTransport.MONGO = 'MONGO';
EntityTransport.AERO = 'AERO';
EntityTransport.SEQUELIZE = 'SEQUELIZE';
EntityTransport.BASE = 'BASE';