"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function buildParams(prefix, obj, add) {
  var rbracket = /\[\]$/;
  var name;

  if (Array.isArray(obj)) {
    // Serialize array item.
    _lodash.default.each(obj, function (v, i) {
      if (rbracket.test(prefix)) {
        // Treat each array item as a scalar.
        add(prefix, v);
      } else {
        // Item is non-scalar (array or object), encode its numeric index.
        buildParams(prefix + '[' + (_typeof(v) === 'object' && v != null ? i : '') + ']', v, add);
      }
    });
  } else if (_typeof(obj) === 'object') {
    // Serialize object item.
    for (name in obj) {
      buildParams(prefix + '[' + name + ']', obj[name], add);
    }
  } else {
    // Serialize scalar item.
    add(prefix, obj);
  }
} // Serialize an array of form elements or a set of
// key/values into a query string


var _default = function _default(a) {
  var prefix;
  var s = [];

  var add = function add(key, valueOrFunction) {
    // If value is a function, invoke it and use its return value
    var value = _lodash.default.isFunction(valueOrFunction) ? valueOrFunction() : valueOrFunction;
    s[s.length] = encodeURIComponent(key) + '=' + encodeURIComponent(value == null ? '' : value);
  }; // If an array was passed in, assume that it is an array of form elements.


  if (Array.isArray(a)) {
    // Serialize the form elements
    _lodash.default.each(a, function (name, value) {
      add(name, value);
    });
  } else {
    // If traditional, encode the "old" way (the way 1.3.2 or older
    // did it), otherwise encode params recursively.
    for (prefix in a) {
      buildParams(prefix, a[prefix], add);
    }
  } // Return the resulting serialization


  return s.join('&');
};

exports.default = _default;