"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = makePostgresQuery;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function makePostgresQuery(DatTypes, query) {
  var mutateQuery = function mutateQuery(val) {
    if (!_lodash.default.isObject(val)) return val;

    if (_lodash.default.isArray(val)) {
      return val.map(mutateQuery);
    }

    return _lodash.default.mapKeys(val, function (queryVal, key) {
      if (_lodash.default.isString(key) && key.startsWith('$Sequelize')) {
        return _lodash.default.get(DatTypes, key.replace('$Sequelize.', ''));
      }

      return key;
    });
  };

  return _lodash.default.mapValues(query, mutateQuery);
}