"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _r = _interopRequireDefault(require("r2"));

var _buildUrlParams = _interopRequireDefault(require("./buildUrlParams"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function requestWrapper(_x) {
  return _requestWrapper.apply(this, arguments);
}

function _requestWrapper() {
  _requestWrapper = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee5(data) {
    var res, contentType, isJsonResponse;
    return _regenerator.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return data.response;

          case 2:
            res = _context5.sent;
            contentType = res.headers.get('content-type');
            isJsonResponse = contentType && contentType.indexOf('application/json') > -1;
            if (!isJsonResponse) res.json = function () {
              return res;
            };

            if (res.ok) {
              _context5.next = 8;
              break;
            }

            throw res;

          case 8:
            return _context5.abrupt("return", res);

          case 9:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _requestWrapper.apply(this, arguments);
}

var _default = _objectSpread({}, _r.default, {
  get: function () {
    var _get = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee(url) {
      var options,
          _args = arguments;
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
              if (options.qs) url = "".concat(url, "?").concat((0, _buildUrlParams.default)(options.qs));
              options.credentials = 'include';
              _context.t0 = requestWrapper;
              _context.next = 6;
              return _r.default.get(url, options);

            case 6:
              _context.t1 = _context.sent;
              return _context.abrupt("return", (0, _context.t0)(_context.t1));

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    function get(_x2) {
      return _get.apply(this, arguments);
    }

    return get;
  }(),
  post: function () {
    var _post = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee2(url) {
      var options,
          _args2 = arguments;
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              options = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : {};
              options.credentials = 'include';
              _context2.t0 = requestWrapper;
              _context2.next = 5;
              return _r.default.post(url, options);

            case 5:
              _context2.t1 = _context2.sent;
              return _context2.abrupt("return", (0, _context2.t0)(_context2.t1));

            case 7:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    function post(_x3) {
      return _post.apply(this, arguments);
    }

    return post;
  }(),
  delete: function () {
    var _delete2 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee3(url) {
      var options,
          _args3 = arguments;
      return _regenerator.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              options = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
              options.credentials = 'include';
              _context3.t0 = requestWrapper;
              _context3.next = 5;
              return _r.default.delete(url, options);

            case 5:
              _context3.t1 = _context3.sent;
              return _context3.abrupt("return", (0, _context3.t0)(_context3.t1));

            case 7:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    function _delete(_x4) {
      return _delete2.apply(this, arguments);
    }

    return _delete;
  }(),
  put: function () {
    var _put = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee4(url) {
      var options,
          _args4 = arguments;
      return _regenerator.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              options = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : {};
              options.credentials = 'include';
              _context4.t0 = requestWrapper;
              _context4.next = 5;
              return _r.default.put(url, options);

            case 5:
              _context4.t1 = _context4.sent;
              return _context4.abrupt("return", (0, _context4.t0)(_context4.t1));

            case 7:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    function put(_x5) {
      return _put.apply(this, arguments);
    }

    return put;
  }()
});

exports.default = _default;