"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _mongoose = require("mongoose");

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return data.map(parsePipline);
}

function parsePipline(pipeline) {
  var mapFn = _lodash.default.isArray(pipeline) ? 'map' : 'mapValues';
  return _lodash.default[mapFn](pipeline, function (val) {
    if (_lodash.default.isObject(val) && val._bsontype !== 'ObjectID') return parsePipline(val);

    if (_lodash.default.isString(val)) {
      var matches = /ObjectId\((.*)\)/g.exec(val);
      if (matches && matches[1]) return _mongoose.Types.ObjectId(matches[1]);
      var d = new Date(val);
      if (d.toString() === 'Invalid Date') return val;
      return d;
    }

    return val;
  });
}