"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _sequelizeBackend = _interopRequireDefault(require("../backends/sequelizeBackend"));

var _enum = require("../enum");

var _requireLib2 = _interopRequireDefault(require("../utils/requireLib"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _default() {
  return _ref.apply(this, arguments);
}

function _ref() {
  _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2() {
    var _ref2,
        backend,
        _ref2$collections,
        collections,
        _requireLib,
        Client,
        options,
        associations,
        entities,
        client,
        _handleTrigger,
        _handleTrigger2,
        _args2 = arguments;

    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _handleTrigger2 = function _ref5() {
              _handleTrigger2 = _asyncToGenerator(
              /*#__PURE__*/
              _regenerator.default.mark(function _callee(_ref3) {
                var _deleteData, _data;

                var channel, payload, _JSON$parse, table, id, type, changes, row, association, actualType, actualId, oldEntity, __association, pk, doc, entity, deleteData;

                return _regenerator.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        channel = _ref3.channel, payload = _ref3.payload;
                        _JSON$parse = JSON.parse(payload), table = _JSON$parse.table, id = _JSON$parse.id, type = _JSON$parse.type, changes = _JSON$parse.changes, row = _JSON$parse.row;
                        association = _lodash.default.find(associations, {
                          from: table
                        });
                        actualType = type;
                        actualId = id;
                        oldEntity = backend.getEntity({
                          collection: table,
                          tag: backend.tag
                        });
                        __association = association ? association.from : null;

                        if (type === 'UPDATE') {
                          fixDataTypes(changes, oldEntity.schema);
                        }

                        if (!association) {
                          _context.next = 17;
                          break;
                        }

                        pk = association.key;
                        _context.next = 12;
                        return backend.getModel(table).model.findOne({
                          where: _defineProperty({}, oldEntity.idField, id),
                          attributes: [pk]
                        });

                      case 12:
                        doc = _context.sent;
                        id = doc ? doc[pk] : row ? row[pk] : id;
                        table = association.to;

                        if (type === 'INSERT') {
                          type = 'UPDATE';
                          changes = row;
                        }

                        if (type !== 'DELETE') {
                          changes[oldEntity.idField] = actualId;
                          changes = _defineProperty({}, association.from, [changes]);
                        }

                      case 17:
                        entity = backend.getEntity({
                          collection: table,
                          tag: backend.tag
                        });
                        _context.t0 = type;
                        _context.next = _context.t0 === 'INSERT' ? 21 : _context.t0 === 'DELETE' ? 23 : _context.t0 === 'UPDATE' ? 27 : 28;
                        break;

                      case 21:
                        backend.emitWatch({
                          action: _enum.WatchActions.CREATE,
                          data: row,
                          collection: table,
                          tag: backend.tag
                        });
                        return _context.abrupt("break", 28);

                      case 23:
                        deleteData = (_deleteData = {}, _defineProperty(_deleteData, entity.idField, id), _defineProperty(_deleteData, "__association", __association), _defineProperty(_deleteData, "__event", actualType), _deleteData);

                        if (association) {
                          deleteData.removed = _defineProperty({}, oldEntity.idField, actualId);
                        }

                        backend.emitWatch({
                          action: _enum.WatchActions.DELETE,
                          data: deleteData,
                          collection: table,
                          tag: backend.tag
                        });
                        return _context.abrupt("break", 28);

                      case 27:
                        backend.emitWatch({
                          action: _enum.WatchActions.UPDATE,
                          data: (_data = {}, _defineProperty(_data, entity.idField, id), _defineProperty(_data, "update", changes), _defineProperty(_data, "__association", __association), _defineProperty(_data, "__event", actualType), _data),
                          collection: table,
                          tag: backend.tag
                        });

                      case 28:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));
              return _handleTrigger2.apply(this, arguments);
            };

            _handleTrigger = function _ref4(_x) {
              return _handleTrigger2.apply(this, arguments);
            };

            _ref2 = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : {}, backend = _ref2.backend, _ref2$collections = _ref2.collections, collections = _ref2$collections === void 0 ? [] : _ref2$collections;
            _requireLib = (0, _requireLib2.default)('pg'), Client = _requireLib.Client;

            if (backend instanceof _sequelizeBackend.default) {
              _context2.next = 6;
              break;
            }

            throw new Error('For pgTrigger watch plugin, backend must be instanceOf SequelizeBackend');

          case 6:
            options = backend._options;
            associations = [];
            entities = _lodash.default.isEmpty(collections) ? backend.entities : collections.map(function (collection) {
              var collectionToFind = collection;

              if (_lodash.default.isObject(collection)) {
                collectionToFind = collection.collection;
                associations.push({
                  from: collectionToFind,
                  to: collection.association,
                  key: collection.foreignKey
                });
              }

              return _lodash.default.find(backend.entities, {
                collection: collectionToFind,
                tag: backend.tag
              });
            });
            client = new Client({
              host: options.host,
              port: options.port,
              user: options.username,
              password: options.password,
              database: options.db
            });
            _context2.next = 12;
            return client.connect();

          case 12:
            _context2.next = 14;
            return Promise.all(entities.map(function (entity) {
              return createTrigger({
                collection: entity.collection,
                idField: entity.idField,
                client: client
              });
            }));

          case 14:
            client.query('LISTEN table_update');
            client.on('notification', _handleTrigger);

          case 16:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _ref.apply(this, arguments);
}

function createTrigger() {
  return _createTrigger.apply(this, arguments);
}

function _createTrigger() {
  _createTrigger = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3() {
    var _ref6,
        collection,
        _ref6$idField,
        idField,
        client,
        queries,
        _i,
        _queries,
        sql,
        _args3 = arguments;

    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _ref6 = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {}, collection = _ref6.collection, _ref6$idField = _ref6.idField, idField = _ref6$idField === void 0 ? 'id' : _ref6$idField, client = _ref6.client;
            queries = ['create extension IF NOT EXISTS hstore;', "DROP FUNCTION IF EXISTS diffObject(text)", "CREATE OR REPLACE FUNCTION diffObject(str text) RETURNS json AS $$\n\t\tBEGIN\n\t\tIF octet_length(str) < 5000 THEN\n\t\treturn cast(str AS json);\n\t\tELSE \n\t\tRETURN json_build_object('forceFetch', true);\n\t\tEND IF;\n\t\tEND;\n\t\t$$ LANGUAGE plpgsql;", "CREATE OR REPLACE FUNCTION notification_".concat(collection, "() RETURNS trigger AS $$\n\t\tDECLARE\n\t\t  id bigint;\n\t\tBEGIN\n\t\t  IF TG_OP = 'INSERT' OR TG_OP = 'UPDATE' THEN\n\t\t\tid = NEW.").concat(idField, ";\n\t\t  ELSE\n\t\t\tid = OLD.").concat(idField, ";\n\t\t  END IF;\n\n\t\t  IF TG_OP = 'UPDATE' THEN\n\t\t\tPERFORM pg_notify('table_update', json_build_object('schema', TG_TABLE_SCHEMA, 'table', TG_TABLE_NAME, 'id', id, 'type', TG_OP, 'changes', diffObject(hstore_to_json(hstore(NEW) - hstore(OLD))::text))::text);\n\t\t\tRETURN NEW;\n\t\t  END IF;\n\n\t\t  IF TG_OP = 'INSERT' THEN\n\t\t\tPERFORM pg_notify('table_update', json_build_object('schema', TG_TABLE_SCHEMA, 'table', TG_TABLE_NAME, 'id', id, 'type', TG_OP, 'row', row_to_json(NEW))::text);\n\t\t\tRETURN NEW;\n\t\t  END IF;\n\n\t\t  IF TG_OP = 'DELETE' THEN\n\t\t\tPERFORM pg_notify('table_update', json_build_object('schema', TG_TABLE_SCHEMA, 'table', TG_TABLE_NAME, 'id', id, 'type', TG_OP, 'row', row_to_json(OLD))::text);\n\t\t\tRETURN OLD;\n\t\t  END IF;\n\n\t\tEND;\n\t\t$$ LANGUAGE plpgsql;"), "DROP TRIGGER IF EXISTS users_trigger on \"public\".\"".concat(collection, "\";"), "CREATE TRIGGER users_trigger AFTER INSERT OR UPDATE OR DELETE ON \"".concat(collection, "\" FOR EACH ROW EXECUTE PROCEDURE notification_").concat(collection, "();")];
            _i = 0, _queries = queries;

          case 3:
            if (!(_i < _queries.length)) {
              _context3.next = 18;
              break;
            }

            sql = _queries[_i];
            _context3.prev = 5;
            _context3.next = 8;
            return client.query(sql);

          case 8:
            _context3.next = 15;
            break;

          case 10:
            _context3.prev = 10;
            _context3.t0 = _context3["catch"](5);

            if (!(['23505', '42710', 'XX000'].indexOf(_context3.t0.code) !== -1)) {
              _context3.next = 14;
              break;
            }

            return _context3.abrupt("return");

          case 14:
            console.error(_context3.t0);

          case 15:
            _i++;
            _context3.next = 3;
            break;

          case 18:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[5, 10]]);
  }));
  return _createTrigger.apply(this, arguments);
}

function fixDataTypes(data, schema) {
  _lodash.default.each(data, function (value, key) {
    if (_lodash.default.isString(value) && schema[key] === 'JSONB') data[key] = JSON.parse(value);
    if (_lodash.default.isString(value) && schema[key] === 'INTEGER') data[key] = parseInt(value);
    if (_lodash.default.isString(value) && schema[key] === 'FLOAT') data[key] = parseFloat(value);
    if (_lodash.default.isString(value) && schema[key] === 'BOOLEAN') data[key] = value === 't';
  });
}