"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _enum = require("../enum");

function _default(backend) {
  backend.on(_enum.TransportEvent.WATCH_ACTION, _handleWatchAction);

  function _handleWatchAction(_ref) {
    var action = _ref.action,
        data = _ref.data,
        collection = _ref.collection;

    switch (action) {
      case _enum.EntityAction.CREATE:
        backend.emitWatch({
          action: _enum.WatchActions.CREATE,
          data: data,
          collection: collection
        });
        break;

      case _enum.EntityAction.UPDATE:
        _.each(data, function (entityData) {
          backend.emitWatch({
            action: _enum.WatchActions.UPDATE,
            data: entityData,
            collection: collection
          });
        });

        break;

      case _enum.EntityAction.UPDATE_BY_ID:
        backend.emitWatch({
          action: _enum.WatchActions.UPDATE,
          data: data,
          collection: collection
        });
        break;

      case _enum.EntityAction.REMOVE_BY_QUERY:
        _.each(data, function (_ref2) {
          var id = _ref2.id;
          backend.emitWatch({
            action: _enum.WatchActions.DELETE,
            data: {
              _id: id
            },
            collection: collection
          });
        });

        break;

      case _enum.EntityAction.REMOVE_BY_ID:
        backend.emitWatch({
          action: _enum.WatchActions.DELETE,
          data: data,
          collection: collection
        });
        break;
    }
  }
}